/*
Copyright (c) 2008 Francisco Mu�oz 'Hermes' (SPAIN) (code and graphics)
Copyright (c) 2008 Dimitri (SPAIN)  (graphics)
Copyright (c) 2008 RedDwarf (SPAIN)  (some errors fixed and the Linux adaptation)

http://www.elotrolado.net


 This program is free software: you can redistribute
 it and/or modify it under the terms of the GNU 
 General Public License as published by the Free 
 Software Foundation, either version 3 of the 
 License, or (at your option) any later version.

 This program is distributed in the hope that 
 it will be useful, but WITHOUT ANY WARRANTY; 
 without even the implied warranty of MERCHANTABI
 LITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General 
 Public License along with this program.  If not,
 see <http://www.gnu.org/licenses/>. 

*/

#define STRING_VER "Guitar fun v2.7"

#define BACK_COLOR 0xff204070

#ifndef WIN32
#ifndef O_BINARY
#define O_BINARY 0
#endif
#endif

int thread_wakeup=0;
int rumble1=0,rumble2=0;
unsigned char rumbledis=0;
int xbox360_guitar=0;
#define MS_TICK 20   // 1000/MS_TICK = Frames per second

#ifdef GEKKO

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include <ogcsys.h>
#include <gccore.h>

#include <wiiuse/wpad.h>
#include <fat.h>
#include <fcntl.h>
#include "sys/dir.h"
#include "snd.h"       // sound library

// MOD Player
#include "gcmodplay.h"
#include "lydbox_mod.h"

MODPlay mod_track;  



int exit_by_reset=0;

void reset_call() {exit_by_reset=1;}


#define STACKSIZE 65536

static u8 oggplayer_stack[STACKSIZE] ATTRIBUTE_ALIGN(32);
static lwpq_t oggplayer_queue;
static lwp_t h_oggplayer;


syswd_t myalarm;
struct timespec alarm_time;
unsigned mytimer(unsigned int time);

static lwpq_t alarm_queue;
extern volatile int control_thread_main;

void alarm_handler()
{

if((control_thread_main & 2)!=0 && thread_wakeup==0) alarm_time.tv_nsec=2*1000*1000; else {alarm_time.tv_nsec=20*1000*1000;mytimer(0);}

SYS_SetAlarm(myalarm,&alarm_time,alarm_handler);

}
void SetAlarm()
{
alarm_time.tv_sec=0;
alarm_time.tv_nsec=20*1000*1000;
LWP_InitQueue(&alarm_queue);
SYS_CreateAlarm(&myalarm);
//SYS_SetPeriodicAlarm(myalarm,&alarm_time,&alarm_time,alarm_handler);
SYS_SetAlarm(myalarm,&alarm_time,alarm_handler);
}
void ReleaseAlarm()
{
SYS_RemoveAlarm(myalarm);
}

#include "ogc/ipc.h"

typedef struct
{
u32 message;
u32 id; // en realidad es una direccion
u8 modifiers;
u8 unknown;
u8 keys[6];
u8 pad[16];
} key_data_t;


static int keyboard_kb=-1;
static key_data_t key_data1,key_data2;

static key_data_t key_data ATTRIBUTE_ALIGN(32);

s32 keyboard_callback(int ret,void * none)
{
if(keyboard_kb>=0)
	{
    if(key_data.message!=0x7fffffff)
		{
		
		if(key_data.message==2)
			{
			if(key_data1.id==0 || key_data1.id==key_data.id) memcpy(&key_data1,&key_data,16);
			if(key_data2.id==0 || (key_data1.id!=0 && key_data1.id!=key_data.id && key_data2.id==key_data1.id)
			 || key_data2.id==key_data.id) memcpy(&key_data2,&key_data,16);


			}
		else
		if(key_data.message==1 || key_data.message==0)
			{
			if(key_data1.id==key_data.id) key_data1.id=0;
			if(key_data2.id==key_data.id) key_data2.id=0;
			}
		key_data.message=0x7fffffff;
		IOS_IoctlAsync(keyboard_kb,1,(void *) &key_data, 16,(void *) &key_data, 16, keyboard_callback, NULL);
		}
	}
return 0;
}


unsigned gamecubepad=0;

void GetEvent()
{
if(exit_by_reset) exit(0);
WPAD_ScanPads();
gamecubepad=PAD_ScanPads();

if(keyboard_kb<0)
	{
	keyboard_kb=IOS_Open("/dev/usb/kbd", 1);
	key_data.message=0x0;
	key_data1.id=0;
	key_data2.id=0;
	if(keyboard_kb>=0)IOS_IoctlAsync(keyboard_kb,1,(void *) &key_data, 16,(void *) &key_data, 16, keyboard_callback, NULL);
	}


}


#endif

#ifndef GEKKO
#include <SDL/SDL.h>

#include "SDL/SDL_syswm.h"



SDL_SysWMinfo info_sdl;



/*
 PLEASE NOTE: the program will require SDL.dll which is located in
              dev-c++'s dll directory. You have to copy it to you
			  program's home directory or the path.
 */

#endif // GEKKO

float gl_gamma=1.0f;

//#define DEVELOP
int memcardload(char *name,char *dat,int *len);
int save_songs_datas();

// this can be used under LINUX, but it is ignored under Windows

#ifndef WIN32
/* // this part need root perms
#define SCHED_APP SCHED_OTHER
#define PTHD_MAIN_PRIORITY     sched_get_priority_max(SCHED_APP)-2
#define PTHD_THREAD1_PRIORITY  sched_get_priority_max(SCHED_APP)-5
*/

#endif



#ifdef WIN32
#include <windows.h>  // used to change the process class
//#include <GL/glext.h>
#define IS_WIN32 0x666

char barra='\\'; // used for directories

HANDLE h_thread1=NULL,sema_thread1=NULL,sema_main=NULL,sema_SDL=NULL;
int thread1_id;
#else

char barra='/'; // used for directories

#endif 

#include "ito.h"
#include "audio.h"

#ifndef GEKKO
#ifndef IS_WIN32
#include <pthread.h>
#endif
#endif

#include <malloc.h>


#include <stdlib.h>
#include <stdio.h>


#include <sys/types.h>
#include <sys/stat.h>


#include <fcntl.h>
#include <unistd.h>
#ifndef GEKKO
#include <dirent.h>
#endif
#include <math.h>

#ifdef GEKKO
#define Delay SDL_Delay

void SDL_Delay(unsigned t)
{
usleep(t*1000);
}

#endif

#include "video.h"
#include "game.h"
#include "3d_engine.h"

#include "licenses_txt.h"
#include "credits_txt.h"

#include "guitar30_pcm.h"
#include "guitar31_pcm.h"
#include "guitar32_pcm.h"
#include "out_pcm.h"

#include "clin_pcm.h"
#include "clin2_pcm.h"
#include "aplauso_pcm.h"
#include "effect_pcm.h"

#include "abucheo_pcm.h"
#include "ovacion_pcm.h"

#define  TIME_STEP  (8820/2)

#define AUDIO_LOOP_93MS 1
#define AUDIO_LOOP_46MS 2

int current_audio_loop_divider=AUDIO_LOOP_46MS; // used when you playing game
 
char main_dir[FILENAME_MAX]="";
char global_dir[FILENAME_MAX]="";
char pathname[1024+1];
 
int SDL_state=0;

extern int paused;

int n_sticks=0;

#ifndef GEKKO
SDL_Joystick *joy1=0, *joy2=0;

SDL_Surface * icon=NULL; // App icon                    
#endif

#if 1
                        //1 2 3 4 5 down,up sel,start
int stick1_map_button[9]={-1,-1,-1,-1,-1, -1,-1, -1,-1};
int stick2_map_button[9]={-1,-1,-1,-1,-1, -1,-1, -1,-1};

#else

                         //1 2 3 4 5 down,up sel,start
int stick1_map_button[9]={ 6,4 ,5 ,7 , 2, 14, 12, 8,9};
int stick2_map_button[9]={ 6,4 ,5 ,7 , 2, 14, 12, 8,9};
#endif

#define AXIS_0_UP 0
#define AXIS_0_DOWN 1

#define AXIS_1_UP 2
#define AXIS_1_DOWN 3

#define AXIS_2_UP 4
#define AXIS_2_DOWN 5

#define AXIS_3_UP 6
#define AXIS_3_DOWN 7

#if 1     
                   // down, up, wah-wah
int stick1_map_axis[3]={-1,-1,-1};
int stick2_map_axis[3]={-1,-1,-1};

#else
int stick1_map_axis[3]={-1,-1,AXIS_1_DOWN};
int stick2_map_axis[3]={-1,-1,AXIS_1_DOWN};

#endif

int stick1_wahwah=0;
int stick2_wahwah=0;


u32 old_pad = 0;
u32 new_pad;

u32 old_pad2 = 0;
u32 new_pad2;

#define PAD_1 1
#define PAD_2 2 
#define PAD_3 4 
#define PAD_4 8 
#define PAD_5 16

#define PAD_UP 64
#define PAD_DOWN 32 
#define PAD_SELECT 128
#define PAD_START 256


/* 
readpad(0)-> lectura pad 1
readpad(1)-> lectura pad 2
readpad(2)-> lectura combinada de pad 1 y pad 2
readpad(128) -> lee pad 2 y devuelve sobre pad 1 (new_pad/old_pad)
readpad(129) -> lee pad 1 y devuelve sobre pad 2 (new_pad2/old_pad2)
*/

int readpad(int pad)
{
int n;
int ret,ret2=0;
u32 paddata;

int change=pad>127;pad&=127;

#ifndef GEKKO
int m,hat;
int axis_deathzone=4096;
//GetEvent();

for(n=0;n<2;n++)
{
if(pad==0 && n==1) break; 
if((pad==1) && n==0) continue; 


if(n==0)
{
	paddata=0;
	

      stick1_wahwah=0;

	  
	// leer botones
	for(m=0;m<9;m++)
	{
    if(!change)
     {
     if(joy1)
      {
      if(stick1_map_button[m]>=0)
       {
       if(stick1_map_button[m]>=256) 
         {ret=SDL_JoystickGetHat(joy1, stick1_map_button[m]-256);
         if(ret & SDL_HAT_UP) paddata|=PAD_UP;
         if(ret & SDL_HAT_DOWN) paddata|=PAD_DOWN;
         }
       else
       if(SDL_JoystickGetButton(joy1, stick1_map_button[m])) paddata|=(1<<m);
       }
      }
     }
    else
     {
     if(joy2)
      {
      if(stick2_map_button[m]>=0)
       {
       if(stick2_map_button[m]>=256) 
         {ret=SDL_JoystickGetHat(joy2, stick2_map_button[m]-256);
         if(ret & SDL_HAT_UP) paddata|=PAD_UP;
         if(ret & SDL_HAT_DOWN) paddata|=PAD_DOWN;
         }
       else
       if(SDL_JoystickGetButton(joy2, stick2_map_button[m])) paddata|=(1<<m);
       }
      }                               
                                      

     }
    }
    
    if(!change)
     {
     if(stick1_map_button[5]<0) // axis down
     {
       
     if(joy1 && stick1_map_axis[0]>=0)
       {int val;
        val=SDL_JoystickGetAxis(joy1,stick1_map_axis[0]>>1);
         if(stick1_map_axis[0] & 1) val=(val>axis_deathzone); else val=(val<-axis_deathzone);
         if(val)  paddata|=(1<<5);
        }
    }
    
    if(stick1_map_button[6]<0) // axis up
    {
       
    if(joy1 && stick1_map_axis[1]>=0)
       {int val;
        val=SDL_JoystickGetAxis(joy1,stick1_map_axis[1]>>1);
         if(stick1_map_axis[1] & 1) val=(val>axis_deathzone); else val=(val<-axis_deathzone);
         if(val)  paddata|=(1<<6);
        }
    }
    
     if(joy1 && stick1_map_axis[2]>=0)
      {
      stick1_wahwah=SDL_JoystickGetAxis(joy1,stick1_map_axis[2]>>1);
      if(stick1_wahwah<0) stick1_wahwah=-stick1_wahwah;
      
      stick1_wahwah>>=7;
      if(stick1_wahwah>127) stick1_wahwah=127;
      if(stick1_wahwah<16) stick1_wahwah=0;
      }
      }
      else
      {
     if(stick2_map_button[5]<0) // axis down
     {
       
     if(joy2 && stick2_map_axis[0]>=0)
       {int val;
        val=SDL_JoystickGetAxis(joy2,stick2_map_axis[0]>>1);
         if(stick2_map_axis[0] & 1) val=(val>axis_deathzone); else val=(val<-axis_deathzone);
         if(val)  paddata|=(1<<5);
        }
    }
    
    if(stick2_map_button[6]<0) // axis up
    {
       
    if(joy2 && stick2_map_axis[1]>=0)
       {int val;
        val=SDL_JoystickGetAxis(joy2,stick2_map_axis[1]>>1);
         if(stick2_map_axis[1] & 1) val=(val>axis_deathzone); else val=(val<-axis_deathzone);
         if(val)  paddata|=(1<<6);
        }
    }
    
     if(joy2 && stick2_map_axis[2]>=0)
      {
      stick1_wahwah=SDL_JoystickGetAxis(joy2,stick2_map_axis[2]>>1);
      if(stick1_wahwah<0) stick1_wahwah=-stick1_wahwah;
      
      stick1_wahwah>>=7;
      if(stick1_wahwah>127) stick1_wahwah=127;
      if(stick1_wahwah<16) stick1_wahwah=0;
      }
      }
      
        new_pad = paddata & ~old_pad;
        old_pad = paddata;
        
            
		ret2=1;
		
}

else
{
paddata=0;

    
   /* if(change)
      stick1_wahwah=0;
	else*/
	  stick2_wahwah=0;
	
		// leer botones
	for(m=0;m<9;m++)
	{
     if(change)
     {
     if(joy1)
      {
      if(stick1_map_button[m]>=0)
       {
       if(stick1_map_button[m]>=256) 
         {ret=SDL_JoystickGetHat(joy1, stick1_map_button[m]-256);
         if(ret & SDL_HAT_UP) paddata|=PAD_UP;
         if(ret & SDL_HAT_DOWN) paddata|=PAD_DOWN;
         }
       else
       if(SDL_JoystickGetButton(joy1, stick1_map_button[m])) paddata|=(1<<m);
       }
      }
     }
    else
     {
     if(joy2)
      {
      if(stick2_map_button[m]>=0)
       {
       if(stick2_map_button[m]>=256) 
         {ret=SDL_JoystickGetHat(joy2, stick2_map_button[m]-256);
         if(ret & SDL_HAT_UP) paddata|=PAD_UP;
         if(ret & SDL_HAT_DOWN) paddata|=PAD_DOWN;
         }
       else
       if(SDL_JoystickGetButton(joy2, stick2_map_button[m])) paddata|=(1<<m);
       }
      }                               
                                      

     }

    }
    
    if(change)
     {
     if(stick1_map_button[5]<0) // axis down
     {
       
     if(joy1 && stick1_map_axis[0]>=0)
       {int val;
        val=SDL_JoystickGetAxis(joy1,stick1_map_axis[0]>>1);
         if(stick1_map_axis[0] & 1) val=(val>axis_deathzone); else val=(val<-axis_deathzone);
         if(val)  paddata|=(1<<5);
        }
    }
    
    if(stick1_map_button[6]<0) // axis up
    {
       
    if(joy1 && stick1_map_axis[1]>=0)
       {int val;
        val=SDL_JoystickGetAxis(joy1,stick1_map_axis[1]>>1);
         if(stick1_map_axis[1] & 1) val=(val>axis_deathzone); else val=(val<-axis_deathzone);
         if(val)  paddata|=(1<<6);
        }
    }
    
     if(joy1 && stick1_map_axis[2]>=0)
      {
      stick2_wahwah=SDL_JoystickGetAxis(joy1,stick1_map_axis[2]>>1);
      if(stick2_wahwah<0) stick2_wahwah=-stick2_wahwah;
      
      stick2_wahwah>>=7;
      if(stick2_wahwah>127) stick2_wahwah=127;
      if(stick2_wahwah<16) stick2_wahwah=0;
      }
      }
      else
      {
     if(stick2_map_button[5]<0) // axis down
     {
       
     if(joy2 && stick2_map_axis[0]>=0)
       {int val;
        val=SDL_JoystickGetAxis(joy2,stick2_map_axis[0]>>1);
         if(stick2_map_axis[0] & 1) val=(val>axis_deathzone); else val=(val<-axis_deathzone);
         if(val)  paddata|=(1<<5);
        }
    }
    
    if(stick2_map_button[6]<0) // axis up
    {
       
    if(joy2 && stick2_map_axis[1]>=0)
       {int val;
        val=SDL_JoystickGetAxis(joy2,stick2_map_axis[1]>>1);
         if(stick2_map_axis[1] & 1) val=(val>axis_deathzone); else val=(val<-axis_deathzone);
         if(val)  paddata|=(1<<6);
        }
    }
    
     if(joy2 && stick2_map_axis[2]>=0)
      {
      stick2_wahwah=SDL_JoystickGetAxis(joy2,stick2_map_axis[2]>>1);
      if(stick2_wahwah<0) stick2_wahwah=-stick2_wahwah;
      
      stick2_wahwah>>=7;
      if(stick2_wahwah>127) stick2_wahwah=127;
      if(stick2_wahwah<16) stick2_wahwah=0;
      }
      }
        new_pad2 = paddata & ~old_pad2;
        old_pad2 = paddata;
        
            
          if(pad==2) // mezcla la lectura de los dos pads
			{
			new_pad|=new_pad2;
			old_pad|=old_pad2;
			old_pad2=old_pad;

			}
			
            
		ret2=1;
		
		}
}


		
return ret2;

#else // gekko

u32 type0,type1;
s32 ret0,ret1;

static u32 oldtype0=0xffffffff;
static u32 oldtype1=0xffffffff;

extern int input_mode;//0; // 0->guitar, 1->pad, 2->keyboard, 3->guitar2 4->pad2
extern int input_mode2;

//WPAD_ScanPads();
ret0=WPAD_Probe(0, &type0);
ret1=WPAD_Probe(1, &type1);

if(ret0==WPAD_ERR_NO_CONTROLLER) oldtype0=0xffffffff;
if(ret1==WPAD_ERR_NO_CONTROLLER) oldtype1=0xffffffff;

// logica que decide el modo de entrada de forma automatica
// PAD0

if(ret0==WPAD_ERR_NONE)
	{
	if(stick1_map_button[1]==0x666 && (gamecubepad & 1)==1 && input_mode==0) ;
	else
	if(stick2_map_button[1]==0x666 && ((gamecubepad>>1) & 1)==1 && input_mode==3) ;
	else
	if(oldtype0!=type0)
	 {
	 if(type0==WPAD_EXP_GUITARHERO3) {stick1_map_button[1]=0x665;input_mode=0;if(type1==WPAD_EXP_GUITARHERO3) {input_mode2=3;stick2_map_button[1]=0x665;}}
	 else
		 {
		 if(input_mode==0) 
			 {
			 if(type1==WPAD_EXP_GUITARHERO3) {input_mode=3;stick1_map_button[1]=0x665;} else input_mode=1;
			 }
		 else
		 if(input_mode==3 || input_mode==4) 
			 {
			  if(type1==WPAD_EXP_GUITARHERO3) {input_mode=3;stick1_map_button[1]=0x665;} else input_mode=1;
			 }
		 }
	 }
	oldtype0=type0;
	}
// PAD1

if(ret1==WPAD_ERR_NONE)
	{

	if(stick1_map_button[1]==0x666 && (gamecubepad & 1)==1 && input_mode2==0) ;
	else
	if(stick2_map_button[1]==0x666 && ((gamecubepad>>1) & 1)==1 && input_mode2==3) ;
	else
	if(oldtype1!=type1)
	 {
	 if(type1==WPAD_EXP_GUITARHERO3) 
		 {
		 if(type0==WPAD_EXP_GUITARHERO3) {input_mode=0;stick1_map_button[1]=0x665;input_mode2=3;stick2_map_button[1]=0x665;}
		 else if(input_mode==0) {input_mode2=3;stick2_map_button[1]=0x665;} else {input_mode=3;stick1_map_button[1]=0x665;}
	     }
	 else
		 {
		 if(input_mode2==3 || input_mode2==4) 
			 {
			 input_mode2=4;
			 }
		 }
	 }
	oldtype1=type1;
	}

for(n=0;n<2;n++)
{
int type;
static expansion_t w_exp;

if(pad==0 && n==1) break; 
if((pad==1) && n==0) continue; 


if(n==0)
{

u32 butt;

if(pad==2 && (input_mode==3 || input_mode==4)) change=1;

if(change!=0) {ret=ret1;type=type1;} else {ret=ret0;type=type0;}

paddata=0;
	stick1_wahwah=0;
	
	if(ret==WPAD_ERR_NO_CONTROLLER && stick1_map_button[1]!=0x666) {new_pad=old_pad=0;rumble1=0;}
	
	if(stick1_map_button[1]==0x666 && (gamecubepad & 1)==1) // gamecube adaptor
	 {
	 butt=PAD_ButtonsHeld(0+(change!=0));
	 if(butt & PAD_TRIGGER_R) paddata|=PAD_1;
	 if(butt & PAD_BUTTON_X) paddata|=PAD_2;
	 if(butt & PAD_BUTTON_Y) paddata|=PAD_3;
	 if(butt & PAD_BUTTON_A) paddata|=PAD_4;
	 if(butt & PAD_BUTTON_B) paddata|=PAD_5;

	 if(butt & PAD_BUTTON_UP) paddata|=PAD_UP;
	 if(butt & PAD_BUTTON_DOWN) paddata|=PAD_DOWN;
	 if(butt & PAD_BUTTON_START) paddata|=PAD_START;
	 if(butt & PAD_BUTTON_MENU) paddata|=PAD_SELECT;
	 
	 stick1_wahwah=PAD_StickY(0+(change!=0))<<8;
	 if(stick1_wahwah<0) stick1_wahwah=-stick1_wahwah;
      
     stick1_wahwah>>=7;
     if(stick1_wahwah>127) stick1_wahwah=127;
     if(stick1_wahwah<16) stick1_wahwah=0;
     if(stick1_wahwah<0) stick1_wahwah=0;
	 rumble1=0;
	 }

	if(ret==WPAD_ERR_NONE)
	{
	if(rumbledis==0)
	 {
	 if(rumble1>0)
		{rumble1--;
		WPAD_Rumble(0+(change!=0), rumble1>5);
		}
		else WPAD_Rumble(0+(change!=0), 0);
	}
     butt=WPAD_ButtonsHeld(0+(change!=0));
      if(type!=WPAD_EXP_GUITARHERO3 || stick1_map_button[1]==0x666)
	  {
	 

	   if(type==WPAD_EXP_NUNCHUK)
		 {
		 if(butt & WPAD_NUNCHUK_BUTTON_Z) paddata|=PAD_1;

		 if(pad==2)  {if(butt & (WPAD_BUTTON_B | WPAD_NUNCHUK_BUTTON_C)) paddata|=PAD_2;}
		 else
		 if(butt & WPAD_NUNCHUK_BUTTON_C) paddata|=PAD_2;

		 if(pad==2 || paused)  {if(butt & WPAD_BUTTON_A) paddata|=PAD_1;}
		 else
			 {
		     if(butt & WPAD_BUTTON_A) paddata|=PAD_3;
		     if(butt & WPAD_BUTTON_B) paddata|=PAD_4;
			 if(butt & (WPAD_BUTTON_LEFT | WPAD_BUTTON_RIGHT | WPAD_BUTTON_UP | WPAD_BUTTON_DOWN)) paddata|=PAD_5;
			 if(butt & (WPAD_BUTTON_MINUS | WPAD_BUTTON_PLUS)) paddata|=PAD_5;
			 }
		 }
       else
		  {
		  if(pad==2 || paused)  {if(butt & WPAD_BUTTON_A) paddata|=PAD_1;}
		  else
			  {
			  if(stick1_map_button[0]==0x666)
				  {if(butt & (WPAD_BUTTON_B | WPAD_BUTTON_MINUS)) paddata|=PAD_1;
				   if(butt & (WPAD_BUTTON_LEFT | WPAD_BUTTON_RIGHT | WPAD_BUTTON_UP | WPAD_BUTTON_DOWN)) paddata|=PAD_2;
				   if(butt & WPAD_BUTTON_A) paddata|=PAD_3;
				  }
			  else
				  {if(butt & (WPAD_BUTTON_LEFT | WPAD_BUTTON_RIGHT | WPAD_BUTTON_UP | WPAD_BUTTON_DOWN)) paddata|=PAD_1;
				   if(butt & WPAD_BUTTON_A) paddata|=PAD_2;
				  }
			  }
	      if(pad==2 || paused)
	        {if(butt & (WPAD_BUTTON_B | WPAD_BUTTON_MINUS)) paddata|=PAD_2;}
	    
		    
		  if(stick1_map_button[0]==0x666)
			  {if(butt & WPAD_BUTTON_1) paddata|=PAD_4;
	           if(butt & WPAD_BUTTON_2) paddata|=PAD_5;
			  }
		  else 
              {
			  if(stick1_map_button[0]==0x667)
				  {
			      if(butt & WPAD_BUTTON_1) paddata|=PAD_3;
	              if(butt & WPAD_BUTTON_2) paddata|=PAD_4;
			      if(butt & (WPAD_BUTTON_MINUS | WPAD_BUTTON_PLUS)) paddata|=PAD_5;
				  }
			  else
				  {
			      if(butt & WPAD_BUTTON_1) paddata|=PAD_4;
	              if(butt & WPAD_BUTTON_2) paddata|=PAD_5;
			      if(butt & (WPAD_BUTTON_MINUS | WPAD_BUTTON_PLUS)) paddata|=PAD_3;
				  }

			  }
          }
	  
      
	  if(butt & WPAD_BUTTON_UP) paddata|=PAD_UP;
	  if(butt & WPAD_BUTTON_DOWN) paddata|=PAD_DOWN;

	  if(butt & WPAD_BUTTON_HOME) paddata|=PAD_SELECT;
	  if((butt & WPAD_BUTTON_B) && (butt & WPAD_BUTTON_HOME)) paddata|=PAD_START;
	  }
	 else //guitarra
	 {
	 WPAD_Expansion(0+(change!=0),&w_exp);
	 
     if(butt & WPAD_GUITAR_HERO_3_BUTTON_GREEN) paddata|=PAD_1;
	 if(butt & WPAD_GUITAR_HERO_3_BUTTON_RED) paddata|=PAD_2;
	 if(butt & WPAD_GUITAR_HERO_3_BUTTON_YELLOW) paddata|=PAD_3;
	 if(butt & WPAD_GUITAR_HERO_3_BUTTON_BLUE) paddata|=PAD_4;
	 if(butt & WPAD_GUITAR_HERO_3_BUTTON_ORANGE) paddata|=PAD_5;

	 if(butt & WPAD_GUITAR_HERO_3_BUTTON_STRUM_UP) paddata|=PAD_UP;
	 if(butt & WPAD_GUITAR_HERO_3_BUTTON_STRUM_DOWN) paddata|=PAD_DOWN;
	 if(butt & WPAD_GUITAR_HERO_3_BUTTON_MINUS) paddata|=PAD_SELECT;
	 if(butt & WPAD_GUITAR_HERO_3_BUTTON_PLUS) paddata|=PAD_START;
     
	
	
	  stick1_wahwah=32767*w_exp.gh3.whammy_bar;
	  if(stick1_wahwah<0) stick1_wahwah=-stick1_wahwah;
      
      stick1_wahwah>>=7;
      if(stick1_wahwah>127) stick1_wahwah=127;
      if(stick1_wahwah<16) stick1_wahwah=0;
      if(stick1_wahwah<0) stick1_wahwah=0;
	  
	 }
	
	 }  
        
	if(ret==WPAD_ERR_NONE || (stick1_map_button[1]==0x666 && (gamecubepad & 1)==1)) 
	{
     new_pad = paddata & ~old_pad;
       old_pad = paddata;
	 ret2=1;        
	}
		

}
if(n==1)
{

u32 butt;
paddata=0;	

if(pad==2 && (input_mode2==3 || input_mode2==4)) change=1;

if(change!=0) {ret=ret0;type=type0;} else {ret=ret1;type=type1;}

     stick2_wahwah=0;

	  
	 if(ret==WPAD_ERR_NO_CONTROLLER && stick2_map_button[1]!=0x666) {new_pad2=old_pad2=0;rumble2=0;}

	 if(stick2_map_button[1]==0x666 && ((gamecubepad>>1) & 1)==1) // gamecube adaptor
	 {
	 butt=PAD_ButtonsHeld(1-(change!=0));
	 if(butt & PAD_TRIGGER_R) paddata|=PAD_1;
	 if(butt & PAD_BUTTON_X) paddata|=PAD_2;
	 if(butt & PAD_BUTTON_Y) paddata|=PAD_3;
	 if(butt & PAD_BUTTON_A) paddata|=PAD_4;
	 if(butt & PAD_BUTTON_B) paddata|=PAD_5;

	 if(butt & PAD_BUTTON_UP) paddata|=PAD_UP;
	 if(butt & PAD_BUTTON_DOWN) paddata|=PAD_DOWN;
	 if(butt & PAD_BUTTON_START) paddata|=PAD_START;
	 if(butt & PAD_BUTTON_MENU) paddata|=PAD_SELECT;
	 
	 stick2_wahwah=PAD_StickY(1-(change!=0))<<8;
	 if(stick2_wahwah<0) stick2_wahwah=-stick2_wahwah;
      
     stick2_wahwah>>=7;
     if(stick2_wahwah>127) stick2_wahwah=127;
     if(stick2_wahwah<16) stick2_wahwah=0;
     if(stick2_wahwah<0) stick2_wahwah=0;
	 rumble2=0;
	 }

	 if(ret==WPAD_ERR_NONE) 
	 {
	 if(rumbledis==0)
	 {
	 if(rumble2>0)
		{
		rumble2--;
		WPAD_Rumble(1-(change!=0), rumble2>5);
		
		}
	   else WPAD_Rumble(1-(change!=0), 0);
	}
      butt=WPAD_ButtonsHeld(1-(change!=0));
      if(type!=WPAD_EXP_GUITARHERO3 || stick2_map_button[1]==0x666)
	  {

	    if(type==WPAD_EXP_NUNCHUK)
		 {
		 if(butt & WPAD_NUNCHUK_BUTTON_Z) paddata|=PAD_1;

		 if(pad==2)  {if(butt & (WPAD_BUTTON_B | WPAD_NUNCHUK_BUTTON_C)) paddata|=PAD_2;}
		 else
		 if(butt & WPAD_NUNCHUK_BUTTON_C) paddata|=PAD_2;

		 if(pad==2 || paused)  {if(butt & WPAD_BUTTON_A) paddata|=PAD_1;}
		 else
			 {
		     if(butt & WPAD_BUTTON_A) paddata|=PAD_3;
		     if(butt & WPAD_BUTTON_B) paddata|=PAD_4;
			 if(butt & (WPAD_BUTTON_LEFT | WPAD_BUTTON_RIGHT | WPAD_BUTTON_UP | WPAD_BUTTON_DOWN)) paddata|=PAD_5;
			 if(butt & (WPAD_BUTTON_MINUS | WPAD_BUTTON_PLUS)) paddata|=PAD_5;
			 }
		 }
       else
		  {
		  if(pad==2 || paused)  {if(butt & WPAD_BUTTON_A) paddata|=PAD_1;}
		  else
			  {
			  if(stick2_map_button[0]==0x666)
				  {if(butt & (WPAD_BUTTON_B | WPAD_BUTTON_MINUS)) paddata|=PAD_1;
				   if(butt & (WPAD_BUTTON_LEFT | WPAD_BUTTON_RIGHT | WPAD_BUTTON_UP | WPAD_BUTTON_DOWN)) paddata|=PAD_2;
				   if(butt & WPAD_BUTTON_A) paddata|=PAD_3;
				  }
			  else
				  {if(butt & (WPAD_BUTTON_LEFT | WPAD_BUTTON_RIGHT | WPAD_BUTTON_UP | WPAD_BUTTON_DOWN)) paddata|=PAD_1;
				   if(butt & WPAD_BUTTON_A) paddata|=PAD_2;
				  }
			  }
	      if(pad==2 || paused)
	        {if(butt & (WPAD_BUTTON_B | WPAD_BUTTON_MINUS)) paddata|=PAD_2;}
	    
		    
		  if(stick2_map_button[0]==0x666)
			  {if(butt & WPAD_BUTTON_1) paddata|=PAD_4;
	           if(butt & WPAD_BUTTON_2) paddata|=PAD_5;
			  }
		  else 
              {if(stick1_map_button[0]==0x667)
				  {
			      if(butt & WPAD_BUTTON_1) paddata|=PAD_3;
	              if(butt & WPAD_BUTTON_2) paddata|=PAD_4;
			      if(butt & (WPAD_BUTTON_MINUS | WPAD_BUTTON_PLUS)) paddata|=PAD_5;
				  }
			  else
				  {
			      if(butt & WPAD_BUTTON_1) paddata|=PAD_4;
	              if(butt & WPAD_BUTTON_2) paddata|=PAD_5;
			      if(butt & (WPAD_BUTTON_MINUS | WPAD_BUTTON_PLUS)) paddata|=PAD_3;
				  }
			  }
          }
	  
      
	  if(butt & WPAD_BUTTON_UP) paddata|=PAD_UP;
	  if(butt & WPAD_BUTTON_DOWN) paddata|=PAD_DOWN;

	  if(butt & WPAD_BUTTON_HOME) paddata|=PAD_SELECT;
	  if((butt & WPAD_BUTTON_B) && (butt & WPAD_BUTTON_HOME)) paddata|=PAD_START;
	   }
	 else //guitarra
	 {
	 WPAD_Expansion(1-(change!=0),&w_exp);
	 

     if(butt & WPAD_GUITAR_HERO_3_BUTTON_GREEN) paddata|=PAD_1;
	 if(butt & WPAD_GUITAR_HERO_3_BUTTON_RED) paddata|=PAD_2;
	 if(butt & WPAD_GUITAR_HERO_3_BUTTON_YELLOW) paddata|=PAD_3;
	 if(butt & WPAD_GUITAR_HERO_3_BUTTON_BLUE) paddata|=PAD_4;
	 if(butt & WPAD_GUITAR_HERO_3_BUTTON_ORANGE) paddata|=PAD_5;

	 if(butt & WPAD_GUITAR_HERO_3_BUTTON_STRUM_UP) paddata|=PAD_UP;
	 if(butt & WPAD_GUITAR_HERO_3_BUTTON_STRUM_DOWN) paddata|=PAD_DOWN;
	 if(butt & WPAD_GUITAR_HERO_3_BUTTON_MINUS) paddata|=PAD_SELECT;
	 if(butt & WPAD_GUITAR_HERO_3_BUTTON_PLUS) paddata|=PAD_START;
     
	
	
	  stick2_wahwah=32767*w_exp.gh3.whammy_bar;
	  if(stick2_wahwah<0) stick2_wahwah=-stick2_wahwah;
      
      stick2_wahwah>>=7;
      if(stick2_wahwah>127) stick2_wahwah=127;
      if(stick2_wahwah<16) stick2_wahwah=0;
      if(stick2_wahwah<0) stick2_wahwah=0;
	  
	 }


	
	 } 
     
	if(ret==WPAD_ERR_NONE || (stick2_map_button[1]==0x666 && ((gamecubepad>>1) & 1)==1)) 
	{
      new_pad2 = paddata & ~old_pad2;
      old_pad2 = paddata;
     
	   if(pad==2) // mezcla la lectura de los dos pads
			{
			new_pad|=new_pad2;
			old_pad|=old_pad2;
			old_pad2=old_pad;

			}
	  ret2=1;	
	}

}

}
return ret2;
#endif
}


#ifndef GEKKO
SDL_Event event,event2;
#endif


void ordena_especial2();
void get_files();


void s_debug(char *c)
{
printf("%s\n",c);
}



volatile int control_thread1=255; // hilo ogg

volatile int control_thread_main=0; 
#ifndef GEKKO
#ifndef IS_WIN32
pthread_t thread1;

struct sched_param sthread1,sthread2;


pthread_mutex_t mutex_thread1;
pthread_cond_t cond_thread1;

pthread_mutex_t mutex_thread_main;
pthread_cond_t cond_thread_main;
#endif
#endif

void myprintf(char *a,...)
{
}
void reset_notes();
extern int midi_ritmo;

#ifndef GEKKO
#ifdef IS_WIN32

#include "..\tremor\ivorbiscodec.h"
#include "..\tremor\ivorbisfile.h"

#else

#include "../tremor/ivorbiscodec.h"
#include "../tremor/ivorbisfile.h"

#endif

#else // GEKKO
#include "../tremor/ivorbiscodec.h"
#include "../tremor/ivorbisfile.h"
#endif

struct
{
char *mem;
int size;
int pos;
} file[4];



#define ACTIVE_SOUND 10000000

int twoplayers=0;
int modeplayers=0;

int signal_generate_dib_notes=1;

int  ovacion=0;
int abucheo=0;
int abucheo_timer=0;
int  aplausos=0;

static int key_flash=0; // usada en read_key de forma interna

int debug_mode=1;

void s_debug(char *c);


unsigned fail_key=0;
unsigned two_fail_key=0;


int bajo_off=0; // suprime pista del bajo

int tex_mastil=2;

int input_mode=2;//0; // 0->guitar, 1->pad, 2->keyboard, 3->guitar2 4->pad2
int input_mode2=2;

int post_key=0,post_key2=0;


#ifndef GEKKO
						 // F1-F5,Enter,esc,arriba,abajo,izquierda,derecha
unsigned int keys_raw[10]={SDLK_F1,SDLK_F2,SDLK_F3,SDLK_F4,SDLK_F5, SDLK_RETURN, SDLK_ESCAPE, SDLK_UP, SDLK_DOWN, SDLK_BACKSPACE};
unsigned int keys_raw2[10]={SDLK_F1,SDLK_F2,SDLK_F3,SDLK_F4,SDLK_F5, SDLK_RETURN, SDLK_ESCAPE, SDLK_UP, SDLK_DOWN, SDLK_BACKSPACE};
#else 




int key_test(key_data_t *k,int key)
{
if(k->id==0 || k->message!=2) return 0;

if(k->keys[0]==key) return 1;
if(k->keys[1]==key) return 1;
if(k->keys[2]==key) return 1;
if(k->keys[3]==key) return 1;
if(k->keys[4]==key) return 1;
if(k->keys[5]==key) return 1;
return 0;
}
unsigned int keys_raw[10]={0x3a,0x3b,0x3c,0x3d,0x3e, 0x28, 0x29, 0x52, 0x51, 0x2a};
unsigned int keys_raw2[10]={0x3a,0x3b,0x3c,0x3d,0x3e, 0x28, 0x29, 0x52, 0x51, 0x2a};

#endif

#define KEY_F1 1
#define KEY_F2 2
#define KEY_F3 4
#define KEY_F4 8
#define KEY_F5 16
#define KEY_ENTER 32
#define KEY_ESC 64
#define KEY_UP 128
#define KEY_DOWN 256

#define KEY_WAHDOWN 512

#define KEY_WAH 1024

unsigned new_key;
unsigned old_key=0;

unsigned new_key2;
unsigned old_key2=0;



Uint8 *keystate=NULL;



int Read_Keyboard(int mode)
{
int n;
static unsigned key=0;
static unsigned key2=0;
static unsigned last_key=0;

#ifndef GEKKO
unsigned temp;
#endif


if(mode==255)
{
key=key2=last_key=0;
new_key=new_key2=0;
old_key=old_key2=KEY_WAHDOWN;
return 1;
}
#ifndef GEKKO
if(mode==0)
	{
    key=key2=last_key=0;
	keystate = SDL_GetKeyState(NULL);
	if(!keystate) return 0;
	
     if(keystate[SDLK_TAB]) key|=KEY_F5; else key&=~(KEY_F5);
     if(keystate[SDLK_RETURN] || keystate[SDLK_KP_ENTER] || keystate[SDLK_F1]) key|=KEY_ENTER; else key&=~(KEY_ENTER);
     if(keystate[SDLK_ESCAPE] || keystate[SDLK_F2]) key|=KEY_F2; else key&=~(KEY_F2);
     if(keystate[SDLK_ESCAPE]) key|=KEY_ESC; else key&=~(KEY_ESC);
     if(keystate[SDLK_UP]) key|=KEY_UP; else key&=~(KEY_UP);
     if(keystate[SDLK_DOWN]) key|=KEY_DOWN; else key&=~(KEY_DOWN);
     
     
     
	new_key = key & ~old_key;old_key = key;  
	
	return 1;
	}
if(mode==1)
	{
	keystate = SDL_GetKeyState(NULL);
	if(!keystate) return 0;
	
	//if(!keystate) return 0;

	for(n=0;n<9;n++)
	{
	if(keystate[keys_raw[n]]) key|=(1<<n); else key&=~(1<<n);
	}
	
	
	if(keystate[keys_raw[n]]) key|=(KEY_WAHDOWN); else key&=~(KEY_WAHDOWN);
    
    if((key & KEY_WAHDOWN)!=0 && (old_key & KEY_WAHDOWN)==0) {key^=KEY_WAH;}
    
    old_key&=~KEY_WAH; 
     
	new_key = key & ~old_key;old_key = key;  
	return 1;
	}

if(mode==2)
	{
	
	keystate = SDL_GetKeyState(NULL);
	if(!keystate) return 0;

	for(n=0;n<9;n++)
	{
	if(keystate[keys_raw2[n]]) key2|=(1<<n); else key2&=~(1<<n);
	}
	if(keystate[keys_raw2[n]]) key2|=(KEY_WAHDOWN); else key2&=~(KEY_WAHDOWN);
    
    if((key2 & KEY_WAHDOWN)!=0 && (old_key2 & KEY_WAHDOWN)==0) {key2^=KEY_WAH;}
    
    old_key2&=~KEY_WAH; 
	new_key2 = key2 & ~old_key2;old_key2 = key2;  
	return 1;
	}

if(mode==3)
	{
    
    SDL_PollEvent(&event);
         
    if(event.key.state==SDL_PRESSED)
    {
    if(last_key!=event.key.keysym.sym) 
     {
     last_key=event.key.keysym.sym;
	 return event.key.keysym.sym;
     }
    }
    if(event.key.state==SDL_RELEASED)
    {
    if(last_key==event.key.keysym.sym) 
     {
     last_key=0;
     }
    }
   
  

	return 0;
	}


#else // GEKKO
/*
if(keyboard_kb<0)
	{
	keyboard_kb=IOS_Open("/dev/usb/kbd", 1);
	key_data.message=0x0;
	key_data1.id=0;
	key_data2.id=0;
	}
if(keyboard_kb>=0)
	{
    if(key_data.message!=0x7fffffff)
		{
		
		if(key_data.message==2)
			{
			if(key_data1.id==0 || key_data1.id==key_data.id) memcpy(&key_data1,&key_data,16);
			if(key_data2.id==0 || (key_data1.id!=0 && key_data1.id!=key_data.id && key_data2.id==key_data1.id)
			 || key_data2.id==key_data.id) memcpy(&key_data2,&key_data,16);
			}
		else
		//if(key_data.message==1)
			{
			if(key_data1.id==key_data.id) key_data1.id=0;
			if(key_data2.id==key_data.id) key_data2.id=0;
			}
		key_data.message=0x7fffffff;

        IOS_IoctlAsync(keyboard_kb,1,(void *) &key_data, 16,(void *) &key_data, 16, keyboard_callback, NULL);
		
		}
	}
	*/
if(mode==0)
	{
    key=key2=last_key=0;
	

     if(key_test(&key_data1,0x2b)) key|=KEY_F5;  // TAB
     if(key_test(&key_data1,0x28)  || key_test(&key_data1,0x3a)) key|=KEY_ENTER;  // RETURN- F1
     if(key_test(&key_data1,0x29) || key_test(&key_data1,0x3b)) key|=KEY_F2;  // ESC -F2
     if(key_test(&key_data1,0x29)) key|=KEY_ESC; // ESC
     if(key_test(&key_data1,0x52)) key|=KEY_UP; // UP
     if(key_test(&key_data1,0x51)) key|=KEY_DOWN; // DOWN

	 if(key_test(&key_data2,0x2b)) key|=KEY_F5; // TAB
     if(key_test(&key_data2,0x28)  || key_test(&key_data2,0x3a)) key|=KEY_ENTER; // RETURN- F1
     if(key_test(&key_data2,0x29) || key_test(&key_data2,0x3b)) key|=KEY_F2;  // ESC -F2
     if(key_test(&key_data2,0x29)) key|=KEY_ESC; // ESC
     if(key_test(&key_data2,0x52)) key|=KEY_UP;  // UP
     if(key_test(&key_data2,0x51)) key|=KEY_DOWN; // DOWN
     
     
     
	new_key = key & ~old_key;old_key = key;  
	
	return 1;
	}
if(mode==1)
	{
	

	for(n=0;n<9;n++)
	{
	if(key_test(&key_data1,keys_raw[n])) key|=(1<<n); else key&=~(1<<n);
	}
	
	
	if(key_test(&key_data1,keys_raw[n]))  key|=(KEY_WAHDOWN); else key&=~(KEY_WAHDOWN);
    
    if((key & KEY_WAHDOWN)!=0 && (old_key & KEY_WAHDOWN)==0) {key^=KEY_WAH;}
    
    old_key&=~KEY_WAH; 
     
	new_key = key & ~old_key;old_key = key;  
	return 1;
	}

if(mode==2)
	{
	
  

	for(n=0;n<9;n++)
	{
	if(key_test(&key_data2,keys_raw2[n]))  key2|=(1<<n); else key2&=~(1<<n);
	}
	if(key_test(&key_data2,keys_raw2[n]))  key2|=(KEY_WAHDOWN); else key2&=~(KEY_WAHDOWN);
    
    if((key2 & KEY_WAHDOWN)!=0 && (old_key2 & KEY_WAHDOWN)==0) {key2^=KEY_WAH;}
    
    old_key2&=~KEY_WAH; 
	new_key2 = key2 & ~old_key2;old_key2 = key2;  
	return 1;
	}

if(mode==3)
	{
    
   if(key_data1.id!=0)
           if(key_data1.keys[0]) 
	           if(last_key!=key_data1.keys[0])
		          {
	              last_key=key_data1.keys[0];
	              return key_data1.keys[0];
                  }
	if(key_data2.id!=0)
           if(key_data2.keys[0])
               if(last_key!=key_data2.keys[0])
		          {
	              last_key=key_data2.keys[0];
	              return key_data2.keys[0];
                  }
    if(key_data1.keys[0]==0  && key_data2.keys[0]==0) last_key=0;
   
  
	return 0;
	}





#endif
	
return 1;

}


unsigned voices=0;

int mc_test=0;
extern unsigned PY;
extern unsigned PX;
int create_mc();

//int modo_estrella=0; // suspended

int global_song_level=0; // se usa para la tabla de records

int fallo_sound=128;

int mid_speed=4;
 
int pcm_volume=100;
int effects_volume=70;

int sound1_div=1;
int sound2_div=1;

int cuenta_atras; // se  usa para controlar el sonido de cuenta atras

unsigned score=0,score_star=0;
unsigned multiplica=1;
int aciertos=0;
int rockometro=64;

int max_note_seq=0; // secuencia de notas mas larga
int note_seq=0; // contador de secuencia de nota

int notes_ok=0;
int notes_total=0;


unsigned two_score=0,two_score_star=0;
unsigned two_multiplica=1;
int two_aciertos=0;
int two_rockometro=64;

int two_max_note_seq=0; // secuencia de notas mas larga
int two_note_seq=0; // contador de secuencia de nota

int two_notes_ok=0;
int two_notes_total=0;

unsigned index_color[10]= // colores del contador de notas
{
0x80000060,
0x80000080,

0x800060a0,
0x800080c0,

0x8000a0a0,
0x8000c0c0,
0x8000d0d0,

0x8000a000,
0x8000c000,
0x8000e000,
};



void display_star(int x,int y,unsigned color)
{
y+=4;

itoTriangle(color,x,y+4,0, color,x+15,y+4,0, color,x+7,y+15,0);
itoTriangle(color,x+7,y,0, color,x,y+12,0, color,x+15,y+12,0);

itoGsFinish();
}

void display_star2(int x,int y,unsigned color)
{


itoTriangle(color,x,y+8,0, color,x+31,y+8,0, color,x+15,y+31,0);
itoTriangle(color,x+15,y,0, color,x,y+24,0, color,x+31,y+24,0);

itoGsFinish();
}

inline unsigned calc_score(unsigned base)
{
unsigned rock=1;
if(rockometro>48) rock=3;
else if(rockometro>32) rock=2;

return (base*(rock))*multiplica;
}
inline unsigned calc_score2(unsigned base)
{
unsigned rock=1;
if(two_rockometro>48) rock=3;
else if(two_rockometro>32) rock=2;

return (base*(rock))*two_multiplica;
}
int paused=0;
int men_pause=0;

int tema=0;

int light_time[16]={0,0,0,0,0,0,0,0};


int wah_wah[32];
int two_wah_wah[32];

int pos_table[20];
int fond_table=0;

int zurdo=0;
int two_zurdo=0;



int flash=0;



typedef struct 
{
char path[256];
char title[64];
char artist[64];
char group[32]; // pack group
}
t_list_songs;

t_list_songs list_songs[514];

int n_list_songs=0;

// caca
typedef struct
{
unsigned id;
short video,hand;
short volume;
unsigned char div1,div2;
short effects_volume;
char input_mode;
unsigned char rumble;
unsigned  keyboard[20]; 

int stick1_map_button[9];
int stick2_map_button[9];
int stick1_map_axis[3];
int stick2_map_axis[3];  

int audio_loop;
int gamma;
int reserv[5]; 
} conf_game;

conf_game configuration;

typedef struct
{
int older;
char title[32]; 
char artist[32];
unsigned records[5][3][3][2]; 

} data_songs; // 428



struct
{
unsigned id;
data_songs songs[128];
} data_memory;


void init_mem_card_datas()
{
int n;

configuration.id=0x1cacafea;

configuration.video=MODEVIDEO;
configuration.hand=zurdo | (two_zurdo<<1);
configuration.volume=pcm_volume;
configuration.div1=sound1_div;
configuration.div2=sound2_div;
configuration.effects_volume=effects_volume;
configuration.input_mode=input_mode | (input_mode2<<4);
configuration.rumble=rumbledis;
for(n=0;n<10;n++) configuration.keyboard[n]=keys_raw[n];
for(n=0;n<10;n++) configuration.keyboard[n+10]=keys_raw2[n];
for(n=0;n<9;n++) configuration.stick1_map_button[n]=stick1_map_button[n];
for(n=0;n<9;n++) configuration.stick2_map_button[n]=stick2_map_button[n];
for(n=0;n<3;n++) configuration.stick1_map_axis[n]=stick1_map_axis[n];
for(n=0;n<3;n++) configuration.stick2_map_axis[n]=stick2_map_axis[n];
configuration.audio_loop=2; // current_audio_loop_divider
#ifdef GEKKO
configuration.audio_loop=2;
#endif
configuration.gamma=(int) (gl_gamma*1000.0f);
data_memory.id=0x1cacafea;
for(n=0;n<128;n++) data_memory.songs[n].older=-1;
}

void get_mem_card_datas()
{
int n;
 MODEVIDEO=configuration.video;
 zurdo=configuration.hand & 1;
 two_zurdo=(configuration.hand>>1) & 1;
 pcm_volume=configuration.volume;
 if(pcm_volume>100) pcm_volume=100;
 sound1_div=configuration.div1;
 sound2_div=configuration.div2;
 effects_volume=configuration.effects_volume;
 rumbledis=configuration.rumble;
 if(effects_volume>100) effects_volume=100;
				  
 if(configuration.id==0x1cacafea)
	{
	input_mode=configuration.input_mode;
	input_mode2=(input_mode>>4) & 15;
	input_mode&=15;

    for(n=0;n<10;n++) keys_raw[n]=configuration.keyboard[n];
	for(n=0;n<10;n++) keys_raw2[n]=configuration.keyboard[n+10];
	for(n=0;n<9;n++) stick1_map_button[n]=configuration.stick1_map_button[n];
    for(n=0;n<9;n++) stick2_map_button[n]=configuration.stick2_map_button[n];
    for(n=0;n<3;n++) stick1_map_axis[n]=configuration.stick1_map_axis[n];
    for(n=0;n<3;n++) stick2_map_axis[n]=configuration.stick2_map_axis[n];
    current_audio_loop_divider=configuration.audio_loop; 
	#ifdef GEKKO
    current_audio_loop_divider=configuration.audio_loop=2;
    #endif
    //configuration.gamma=100;
    if(configuration.gamma<500) configuration.gamma=500;
    if(configuration.gamma>4000  ) configuration.gamma=4000;
    gl_gamma=((float) (configuration.gamma))/1000.0f;
    itoGamma(gl_gamma);
    }
}



/********************************************************************************/
/* bitmaps */

typedef struct{
	
	 
	unsigned size;
	unsigned reserved; 
	unsigned offset; 

	unsigned header_size; 
	unsigned width ; 
	unsigned height; 
	unsigned short planes;  
	unsigned short bpp; 
	unsigned compression; 
	unsigned image_size; 	
	unsigned ppm[2]; 
	unsigned colors_used,colors_important; 


} bmp_header;

static bmp_header bmph;

typedef  struct 
{
unsigned char b,g,r,a;
} _prgba;

 _prgba *prgba;

//static u16 pal_bmp[256];

unsigned short texture[256*256];
unsigned short mastil_texture[3][64*256];

unsigned short *background=NULL;
unsigned short *ext_mastil=NULL;




void scale_bmp_16b(unsigned short *src,int src_x,int src_y, unsigned short *dest,int dest_x,int dest_y)
{
int n,m;
int max_n,max_m;
int cx_src,cy_src,cx_dest,cy_dest;
int x_src,y_src,x_dest,y_dest;
int desp_src,desp_dest;

max_n=src_y;if(dest_y>max_n) max_n=dest_y;
max_m=src_x;if(dest_x>max_m) max_m=dest_x;


y_src=cy_src=0;
y_dest=cy_dest=0;
for(n=0;n<max_n;n++)
{
x_src=cx_src=0;
x_dest=cx_dest=0;

desp_src=y_src*src_x;
desp_dest=y_dest*dest_x;

for(m=0;m<max_m;m++)
{
dest[x_dest+desp_dest]=src[x_src+desp_src];

cx_src+=src_x;
if(cx_src>=max_m) {cx_src-=max_m;x_src++;if(x_src>=src_x) x_src=src_x-1;}
cx_dest+=dest_x;
if(cx_dest>=max_m) {cx_dest-=max_m;x_dest++;if(x_dest>=dest_x) x_dest=dest_x-1;}             
}
cy_src+=src_y;
if(cy_src>=max_n) {cy_src-=max_n;y_src++;if(y_src>=src_y) y_src=src_y-1;}
cy_dest+=dest_y;
if(cy_dest>=max_n) {cy_dest-=max_n;y_dest++;if(y_dest>=dest_y) y_dest=dest_y-1;}             
}
 
}

#ifndef GEKKO
#define GET_U32(v) v
#define GET_U16(v) v
#else
#define GET_U32(v) (((v>>24) & 0xff) | ((v & 0xff) <<24) | ((v>>8) & 0xff00) | ((v<<8) & 0xff0000))
#define GET_U16(v) (((v>>8) & 0xff) | ((v & 0xff)<<8))
#endif

void load_bmp_texture(char *bitmap, unsigned short *text, int transparente)
{
int l,n,m,k;
unsigned char *punt;
int colors;


punt=(unsigned char*) bitmap;

memcpy((void *)&bmph,punt+2,52);


// conversion de endian
bmph.offset=GET_U32(bmph.offset);
bmph.header_size=GET_U32(bmph.header_size);
bmph.width=GET_U32(bmph.width);
bmph.height=GET_U32(bmph.height);

bmph.planes=GET_U16(bmph.planes);
bmph.bpp=GET_U16(bmph.bpp);

bmph.compression=GET_U32(bmph.compression);
bmph.image_size=GET_U32(bmph.image_size);
bmph.colors_used=GET_U32(bmph.colors_used);
bmph.colors_important=GET_U32(bmph.colors_important);



if(!bmph.image_size)
		bmph.image_size=bmph.height*(((bmph.width*(bmph.bpp)*2/8)/2)+3) & (~3);

colors=bmph.bpp;
	if(colors==8 && bmph.colors_used==0) bmph.colors_used=256;
	if(colors==4 && bmph.colors_used==0) bmph.colors_used=16;
	if(colors==1 && bmph.colors_used==0) bmph.colors_used=2;

prgba=(_prgba *) (punt+54);

punt+=54+4*bmph.colors_used;
if(colors==1)
	{

	n=((bmph.width>>3)+3) & ~3;
	for(m=0;m<bmph.height;m++)
	for(l=0;l<bmph.width;l+=8)
		{
		unsigned char ind;

		ind=punt[(l>>3)+(n)*(bmph.height-1-m)];

		for(k=0;k<8;k++)
			{
			if(ind & 128) text[l+k+(m*128)]=32768+(15<<10)+(15<<5)+15; else text[l+k+(m*128)]=0;
			ind<<=1;
			}


		}
	
	}

if(colors==4)
	{
   
	n=((bmph.width>>1)+3) & ~3;
	for(m=0;m<bmph.height;m++)
	for(l=0;l<bmph.width;l++)
		{
		unsigned char ind;

		ind=punt[(l>>1)+(n)*(bmph.height-1-m)];

		if(l % 1) ind &=15; else ind>>=4;
		ind&=15;
		
		text[l+(m*bmph.width)]=((prgba[ind].b>>3)<<10) | ((prgba[ind].g>>3)<<5) |((prgba[ind].r>>3)) | ((ind!=0 || transparente==0)<<15);


		}
	
	}
if(colors==8)
	{

	n=((bmph.width)+3) & ~3;
	for(m=0;m<bmph.height;m++)
	for(l=0;l<bmph.width;l++)
		{
		unsigned char ind;

		ind=punt[(l)+(n)*(bmph.height-1-m)];
   
		
		text[l+(m*bmph.width)]=((prgba[ind].b>>3)<<10) | ((prgba[ind].g>>3)<<5) |((prgba[ind].r>>3)) | ((1)<<15);


		}
	
	}
if(colors==24)
	{
	
	n=((bmph.width*3)+3) & ~3;
	for(m=0;m<bmph.height;m++)
	for(l=0;l<bmph.width;l++)
		{
		unsigned short rgba;
		unsigned char *p;

		p=&punt[(l*3)+(n)*(bmph.height-1-m)];
        rgba=((((unsigned)p[0])>>3)<<10) | ((((unsigned)p[1])>>3)<<5) | (((unsigned)p[2])>>3);
        
	   if(transparente==0) rgba|=0x8000; 
	   else if(rgba) rgba|=0x8000;
	   
		text[l+(m*bmph.width)]=rgba;


		}
	
	}

    
}


void load_external_neck()
{
int fd;
static int count=0;
 // mastil
 
 sprintf(pathname,"%sbitmaps%cneck%i.bmp",main_dir,barra,count);
 fd=open(pathname,O_RDONLY | O_BINARY, S_IREAD);
           
 if(fd<0)
 {
 count=0;
 sprintf(pathname,"%sbitmaps%cneck0.bmp",main_dir,barra);
 fd=open(pathname,O_RDONLY | O_BINARY, S_IREAD);
 if(fd<0)
  {
  sprintf(pathname,"%sbitmaps%cneck.bmp",main_dir,barra);
  //printf("path %s\n",pathname);
  fd=open(pathname,O_RDONLY | O_BINARY, S_IREAD);
  }
 }

  if(fd>=0)
  {
  char *t1;
  unsigned short *t2;
  int size;
  size=lseek(fd,0,2);
  t1=malloc(size+64); 
  count++;
  if(t1)
  {
  lseek(fd,0,0);
  read(fd,t1,size);close(fd);
  memcpy((void *)&bmph,t1+2,52); // copia informacion del BMP

  // conversion de endian
bmph.offset=GET_U32(bmph.offset);
bmph.header_size=GET_U32(bmph.header_size);
bmph.width=GET_U32(bmph.width);
bmph.height=GET_U32(bmph.height);

bmph.planes=GET_U16(bmph.planes);
bmph.bpp=GET_U16(bmph.bpp);

bmph.compression=GET_U32(bmph.compression);
bmph.image_size=GET_U32(bmph.image_size);
bmph.colors_used=GET_U32(bmph.colors_used);
bmph.colors_important=GET_U32(bmph.colors_important);

  
  t2=malloc(bmph.height*((bmph.width+3) & ~3)*2);
  if(t2)
  {
  if(!ext_mastil) ext_mastil=malloc(64*256*2);
  if(ext_mastil)
    {
    load_bmp_texture(t1, t2,0);
    scale_bmp_16b(t2,bmph.width,bmph.height,ext_mastil,64,256);
    }
  free(t2);
  } 
  free(t1);
  } else close(fd);
 
  }
}

/*******************************************************************************/
/* FILE FUNCTIONS */

void fprintf2(void *a,void *b,...)
{
}

int f_read(void * punt, int bytes, int blocks, int *f)
{
int b;
int c;

int d;


if(bytes*blocks<=0) return 0;

blocks=bytes*blocks;
c=0;


while(blocks>0)
{
b=blocks;if(b>4096) b=4096;
if(*f>=0x666 && *f<=0x668 )
	{
	d=(*f)-0x666;
	if((file[d].pos+b)>file[d].size) b=file[d].size-file[d].pos;
	if(b>0)
		{memcpy(punt,file[d].mem+file[d].pos,b);
		file[d].pos+=b;
		}
	}
else
b=read( *f,((char *)punt)+c,b);

if(b<=0) {return c/bytes;}
c+=b;
blocks-=b;
}
return c/bytes;
}

int f_seek(int *f,long offset, int mode)
{
int k,d;
mode&=3;
if(*f>=0x666 && *f<=0x668 )
	{
	d=(*f)-0x666;
	k=0;
	
	if(mode==0)
		{
		if(offset<0 || offset>=file[d].size) k=-1;
		else file[d].pos=offset;
		}
	if(mode==1)
		{
		if((file[d].pos+offset)>=file[d].size || (file[d].pos+offset)<0) k=-1;
		else file[d].pos+=offset;
		}
	if(mode==2)
		{
		if((file[d].size+offset)>=file[d].size || (file[d].size+offset)<0) k=-1;
		else file[d].pos=file[d].size+offset;
		}

	}
else
k= lseek(*f,(int) offset,mode);

if(k<0) k=-1; else k=0;
return k;

}
int f_close(int *f)
{
int d;
if(*f>=0x666 && *f<=0x668 )
	{
	d=(*f)-0x666;
	if(file[d].mem) {free(file[d].mem);file[d].size=0;file[d].pos=0;}
	return 0;
	}
	else
close( *f);
return 0;
}

long f_tell(int *f)
{	int k,d;
if(*f>=0x666 &&*f<=0x668)
	{
	d=(*f)-0x666;
	k=file[d].pos;
	}
	else
k=lseek(* f,0L,1);


return (long) k;

}


/****************************************************************************************************************************************/
// MIDI
/****************************************************************************************************************************************/



unsigned short nota_map[20];
unsigned short nota[MAX_NOTES];

unsigned short two_nota_map[20];
unsigned short two_nota[MAX_NOTES];

int star_table[260][8];
int star_pos=0,star_counter=0;

int two_star_table[260][8];
int two_star_pos=0,two_star_counter=0;

int nota_indx=0;
int nota_step=0;

int lights_effects=0;

#define MIDI_MAX_TRACKS 3

int MIDI_MAX_SIZE=0;

int game_level=0;

int midi_ritmo=0;

#define EASY_LEVEL	 1
#define MEDIUM_LEVEL 2
#define HARD_LEVEL   4
#define EXPERT_LEVEL 8



static unsigned track_status[MIDI_MAX_TRACKS];
static unsigned track_offset[MIDI_MAX_TRACKS];
static unsigned track_end[MIDI_MAX_TRACKS];
static unsigned track_timer[MIDI_MAX_TRACKS];
static double track_dtimer[MIDI_MAX_TRACKS];
static unsigned track_ticks[MIDI_MAX_TRACKS];
static int midi_notes_keys[MIDI_MAX_TRACKS][5];
static int midi_keyonoff[MIDI_MAX_TRACKS];


static unsigned char *midi_file=0;

static int midi_pos=0;

static int midi_mode=0;
static int midi_tracks=0;

static int midi_ticks=96; // divisor tiempo de cuarto de nota del MIDI

static int midi_ticks_quarter=24; // ticks por cuarto de nota
static int midi_tempo=500000; // tiempo en microsegundos de un cuarto de nota


static int get_32b()
{
int r=0;
r=midi_file[midi_pos];midi_pos++;
r=(r<<8)+midi_file[midi_pos];midi_pos++;
r=(r<<8)+midi_file[midi_pos];midi_pos++;
r=(r<<8)+midi_file[midi_pos];midi_pos++;

return r;
}

static int get_24b()
{
int r=0;
r=midi_file[midi_pos];midi_pos++;
r=(r<<8)+midi_file[midi_pos];midi_pos++;
r=(r<<8)+midi_file[midi_pos];midi_pos++;

return r;
}

static int get_16b()
{
int r=0;
r=midi_file[midi_pos];midi_pos++;
r=(r<<8)+midi_file[midi_pos];midi_pos++;

return r;
}

static unsigned ReadVlen() 
{ 
register unsigned val; 
register unsigned char c; 
val = midi_file[midi_pos];midi_pos++;
if (val & 0x80) 
	{ 
	val&=0x7f; 
	do 
	{
	c=midi_file[midi_pos];midi_pos++;
	val = (val << 7) + (c & 0x7f); 
	} while (c & 0x80); 
	} 
return (val); 
}



static double d_get_time_midi(unsigned t)
{
double time;

time=(((((double) midi_tempo)/ (double) ((midi_ticks*24)/midi_ticks_quarter))*(double) t));
return time;
}


unsigned midi_get_tempo()
{
return midi_tempo;
}


int last_midi_note=0;

#define MAX_TIME_EFFECTS 2048
unsigned time_effects[MAX_TIME_EFFECTS][2];
int time_effects_pos=0;
int time_effects_max=0;

void set_note(int note,unsigned time_pos,unsigned time_len)
{
int n;

note--;



if(time_effects_max<(MAX_TIME_EFFECTS-1))
{
if(midi_get_tempo()/100000!=time_effects[time_effects_max][1]) 
 {
 if(time_effects_max>0 || (time_effects_max==0 && time_effects[time_effects_max][1]!=0)) time_effects_max++;
 time_effects[time_effects_max][0]=time_pos+5000;
 time_effects[time_effects_max][1]=midi_get_tempo()/100000;
 //printf("tick %i %i\n",time_pos+5000,midi_get_tempo()/100000);
 
 }
}




time_pos=(time_pos+5000)/100;



time_len=(time_len)/100;
if(time_len==0) time_len=1;

if(time_pos>=MAX_NOTES) return;


if(time_pos>last_midi_note) last_midi_note=time_pos;
nota[time_pos]|=7<<(note*3);
notes_total++;

n=1;
time_len--;
while(time_len) 
	{if((time_pos+n)>=MAX_NOTES) return;
	if((time_pos+n)>last_midi_note) last_midi_note=time_pos+n;
	nota[time_pos+n]|=3<<(note*3);

     time_len--;n++;
	}


}

void set_note2(int note,unsigned time_pos,unsigned time_len)
{
int n;
//int f;
note--;
/*
f=0;
if(midi_get_tempo()<500000) f=1;
*/

time_pos=(time_pos+5000)/100;



time_len=(time_len)/100;
if(time_len==0) time_len=1;

if(time_pos>=MAX_NOTES) return;


if(time_pos>last_midi_note) last_midi_note=time_pos;
two_nota[time_pos]|=7<<(note*3);
two_notes_total++;

n=1;
time_len--;
while(time_len) 
	{if((time_pos+n)>=MAX_NOTES) return;
	 if((time_pos+n)>last_midi_note) last_midi_note=time_pos+n;
	two_nota[time_pos+n]|=3<<(note*3);

     time_len--;n++;
	}


}



int open_midi(char *name,int mode)
{
#define _PS2_
#ifdef _PS2_
int FMID=0;
#else
FILE *FMID;
#endif
int n,l;
int flag=255;


int mid_time=0;
int mid_time_ms=0;


int note_ref;

last_midi_note=0;

if(mode==0) game_level=0;

//notes_count=0;

time_effects_pos=0;
time_effects_max=0;
time_effects[0][0]=0;
time_effects[0][1]=0;


note_ref=60;
if(mode==MEDIUM_LEVEL) note_ref=60+12*1;
if(mode==HARD_LEVEL) note_ref=60+12*2;
if(mode==EXPERT_LEVEL) note_ref=60+12*3;

for(n=0;n<MIDI_MAX_TRACKS;n++) track_status[n]=0; // tracks off



#ifdef _PS2_
FMID = open(name, O_RDONLY | O_BINARY, S_IREAD );
if(FMID==0) 
	{
	if(debug_mode) s_debug("MIDI: open fail");
	return -1;
    }
MIDI_MAX_SIZE=lseek(FMID,0,2);
lseek(FMID,0,0);
if(MIDI_MAX_SIZE<=0) {MIDI_MAX_SIZE=0;close(FMID);FMID=0;
					if(debug_mode) s_debug("MIDI: truncated file");
					return -1;}

midi_file=malloc(MIDI_MAX_SIZE);
if(midi_file==0) {MIDI_MAX_SIZE=0;close(FMID);FMID=0;
				if(debug_mode) s_debug("MIDI: malloc fail");
				return -1;}
if(read(FMID,midi_file,MIDI_MAX_SIZE)!=MIDI_MAX_SIZE) // error leyendo...
	{free(midi_file);MIDI_MAX_SIZE=0;close(FMID);FMID=0;
	if(debug_mode) s_debug("MIDI: truncated file");
	return -1;}

	
close(FMID);FMID=0;

#else
FMID= fopen(name, "rb");
	if(FMID==NULL)
	{
		return -1;
	}

fseek(FMID,0,SEEK_END);
MIDI_MAX_SIZE=ftell(FMID);
fseek(FMID,0,SEEK_SET);

if(MIDI_MAX_SIZE<=0) {MIDI_MAX_SIZE=0;fclose(FMID);
					return -1;}

midi_file=(unsigned char *) malloc(MIDI_MAX_SIZE);
if(midi_file==0) {MIDI_MAX_SIZE=0;fclose(FMID);
				return -1;}

if(fread(midi_file,1,MIDI_MAX_SIZE, FMID)!=MIDI_MAX_SIZE) // error leyendo...
	{free(midi_file);MIDI_MAX_SIZE=0;fclose(FMID);
	return -1;}


	
fclose(FMID);


#endif


midi_pos=0; 

mid_time=0; // contador de ticks global

midi_ticks=96; // divisor tiempo de cuarto de nota del MIDI
midi_ticks_quarter=24; // ticks por cuarto de nota
midi_tempo=500000; // tiempo en microsegundos de un cuarto de nota

if(!strncmp((char *) &midi_file[midi_pos],"MThd",4))
{
int len_header=0;


midi_pos+=4;
len_header=get_32b();

//printf("MIDI Header len %i\n",len_header);

midi_mode=get_16b();
midi_tracks=get_16b();
midi_ticks=get_16b();

n=6;

while(n<len_header)
{
midi_pos++;n++;
}

if(midi_ritmo && midi_tracks<3) midi_ritmo=0; // anula ritmo



for(l=0;l<midi_tracks && l<MIDI_MAX_TRACKS;l++)
	{
	if(!strncmp((char *) &midi_file[midi_pos],"MTrk",4))
		{
	
		track_status[l]=1;
		track_timer[l]=0;
		track_dtimer[l]=0.0;
		midi_pos+=4;
		track_end[l]=get_32b();
		track_offset[l]=midi_pos;
		track_end[l]+=track_offset[l];
		midi_pos=track_end[l];
		}
	}


for(n=0;n<MIDI_MAX_TRACKS;n++) 
for(l=0;l<5;l++) {midi_notes_keys[n][l]=-1;midi_keyonoff[l]=0;}

while(1)
{
if(flag==0) break; // ninguna pista activa, salir
if(flag==1) // actualizar contador de ticks
	{
	unsigned temp=0x7fffffff;
	for(l=0;l<MIDI_MAX_TRACKS;l++)
	{
	if(mode!=0)
	if((l==1 && midi_ritmo==1) || (l==2 && midi_ritmo==0 && twoplayers==0) || (l==2 && midi_ritmo==0 && twoplayers!=0 && modeplayers==0)) continue;

	if(track_status[l]!=0)
		{
		if(track_timer[l]<temp) temp=track_timer[l];
		}
	}
	mid_time=temp;
	}

flag=0;





for(l=0;l<MIDI_MAX_TRACKS;l++) // rastrea todas las pistas
{
unsigned char cmd,dat1,dat2,dat3;
if(mode!=0)
if((l==1 && midi_ritmo==1) 
|| (l==2 && midi_ritmo==0 && twoplayers==0) || (l==2 && midi_ritmo==0 && twoplayers!=0 && modeplayers==0)) continue;
if(track_status[l]==0) continue; //  pista en deshuso

midi_pos=track_offset[l];

if(midi_pos>=track_end[l]) {track_status[l]=0; continue;} // si fin de pista, ignora

flag|=1; // activa flag 1 si pista activa



if(track_status[l]==1) // leer numero de ticks
	{
	
	track_ticks[l]=ReadVlen();
	track_timer[l]+=track_ticks[l];
	
	track_status[l]=2;
	track_offset[l]=midi_pos;
	continue; //esto es nuevo
	}
if(track_status[l]==2) // leer comando/nota
	{
	if(mid_time<track_timer[l]) continue; // espera a que el timer general alcance al de la pista
	}

	
track_dtimer[l]+=d_get_time_midi(track_ticks[l]); // ajusta el timer de precision (en microsegundos)

flag|=2; // flag=3 si comando/nota en tiempo

    
mid_time_ms=(unsigned) (track_dtimer[l]/1000.0);                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     

	cmd=midi_file[midi_pos];midi_pos++;

	if(cmd==0xff)
		{
		
		dat1=midi_file[midi_pos];midi_pos++;

		switch(dat1)
			{
			case 1:
			case 2:
			case 3:
		    case 4:
			case 5:
			case 6:
			case 7:
				dat2=midi_file[midi_pos];midi_pos+=dat2+1;break;
			case 0x2d:
				dat2=midi_file[midi_pos];midi_pos++;
				break;
			case 0x2f:
				dat2=midi_file[midi_pos];midi_pos++;
				track_status[l]=0; // flag de fin de pista
				//printf("End of track\n");
				break;
			case 0:
				dat2=midi_file[midi_pos];midi_pos++;break;
			case 0x51:
				dat2=midi_file[midi_pos];midi_pos++;
				midi_tempo=get_24b();
				break;
	
			case 0x58:
				
				dat2=midi_file[midi_pos];midi_pos++;
				
				dat3=midi_file[midi_pos];midi_pos++;
			
				
				dat3=midi_file[midi_pos];midi_pos++;
			

				dat3=midi_file[midi_pos];midi_pos++;
				midi_ticks_quarter=dat3;

				dat3=midi_file[midi_pos];midi_pos++;

				break;
			case 0x8f:
				midi_pos++;
			default:
				dat2=midi_file[midi_pos];midi_pos++;
				while(dat2) {midi_pos++;dat2--;}

				break;
			

			}
		}// cmd //255
	 
	else
		{
		
		switch(cmd>>4)
				{
		
				case 8:
					//cuenta++; if(cuenta>20) goto ender;
			
					dat2=midi_file[midi_pos];midi_pos++;
					dat3=midi_file[midi_pos];midi_pos++;

					
					
					if(mode!=0)
					if(dat2>=note_ref && dat2<(note_ref+5))
						{
						int vel;
						vel=(mid_time_ms-midi_notes_keys[l][dat2-note_ref]);
					
						if(l<2 ||  twoplayers==0) set_note(dat2-note_ref+1, midi_notes_keys[l][dat2-note_ref],vel);
						else if((l==2 && (modeplayers==1)) ) set_note2(dat2-note_ref+1, midi_notes_keys[l][dat2-note_ref],vel);
						
						}
					midi_keyonoff[l]=0;
					break;
			
				case 9:
		
					dat2=midi_file[midi_pos];midi_pos++;
					dat3=midi_file[midi_pos];midi_pos++;

				
					if(mode==0) 
						{
						if(l==2)
							{
							if(dat2>=60 && dat2<65) game_level|=EASY_LEVEL<<8;
							if(dat2>=72 && dat2<77) game_level|=MEDIUM_LEVEL<<8;
							if(dat2>=84 && dat2<89) game_level|=HARD_LEVEL<<8;
							if(dat2>=96 && dat2<101) game_level|=EXPERT_LEVEL<<8;
							}
						else
							{
							if(dat2>=60 && dat2<65) game_level|=EASY_LEVEL;
							if(dat2>=72 && dat2<77) game_level|=MEDIUM_LEVEL;
							if(dat2>=84 && dat2<89) game_level|=HARD_LEVEL;
							if(dat2>=96 && dat2<101) game_level|=EXPERT_LEVEL;
							}
						}
					if(dat2>=note_ref && dat2<(note_ref+5))
						{
						midi_notes_keys[l][dat2-note_ref]=mid_time_ms;
						}
						midi_keyonoff[l]=1;
					break;

				case 0xa:
				case 0xb:
				case 0xe:
			       
					dat2=midi_file[midi_pos];midi_pos++;
					dat3=midi_file[midi_pos];midi_pos++;
					break;
				case 0xc:
				case 0xd:
					
					dat2=midi_file[midi_pos];midi_pos++;
					break;
				case 0xf:
					
				if(cmd==0xf0)
					{
					do
					{
					if(midi_pos>=track_end[l]) {break;} // si fin de pista, corta el rollo
					dat2=midi_file[midi_pos];midi_pos++;
					if(midi_pos>=track_end[l]) {break;} // si fin de pista, corta el rollo
					dat3=midi_file[midi_pos];midi_pos++;
					} while(dat2!=0xf7);
					}
					if(cmd==0xf2) midi_pos+=2; //  song position
					if(cmd==0xf4) midi_pos+=1;
					
					break;

				default:
					dat2=cmd;	
					dat3=midi_file[midi_pos];midi_pos++;

					if(mode==0 && dat3!=0) 
						{
						if(l==2)
							{
							if(dat2>=60 && dat2<65) game_level|=EASY_LEVEL<<8;
							if(dat2>=72 && dat2<77) game_level|=MEDIUM_LEVEL<<8;
							if(dat2>=84 && dat2<89) game_level|=HARD_LEVEL<<8;
							if(dat2>=96 && dat2<101) game_level|=EXPERT_LEVEL<<8;
							}
						else
							{
							if(dat2>=60 && dat2<65) game_level|=EASY_LEVEL;
							if(dat2>=72 && dat2<77) game_level|=MEDIUM_LEVEL;
							if(dat2>=84 && dat2<89) game_level|=HARD_LEVEL;
							if(dat2>=96 && dat2<101) game_level|=EXPERT_LEVEL;
							}
						}

					if(dat2>=note_ref && dat2<(note_ref+5))
						{

						if(midi_keyonoff[l]==0 || dat3==0) 
							{
							int vel;
							//myprintf("Nota #2: %u, time %i\n",dat2-note_ref+1,mid_time_ms-midi_notes_keys[l][dat2-note_ref]);

							//mid_time_ms-=(unsigned) (d_get_time_midi(dat3)/1000.0); // ajusta el timer de precision (en microsegundos)
							vel=(mid_time_ms-midi_notes_keys[l][dat2-note_ref]);
							if(mode!=0)
								{
								if(l<2 ||  twoplayers==0) set_note(dat2-note_ref+1, midi_notes_keys[l][dat2-note_ref],vel);
								else if(l==2 && (modeplayers==1)) set_note2(dat2-note_ref+1, midi_notes_keys[l][dat2-note_ref],vel);
								}
						
							}
							else {midi_notes_keys[l][dat2-note_ref]=mid_time_ms;//midi_key_vel[l][dat2-note_ref]=64;//127-dat3;
							}
							
						}
						
					
					break;
				}
		}

	if(track_status[l]!=0) // cambia a estado 1 (coger ticks) y guard la posicion
	{
	track_offset[l]=midi_pos;
	track_status[l]=1;
	}


	} // for


}


}

free(midi_file);
if(mode==0) return game_level;

if(modeplayers==0)
    {two_notes_total=notes_total;
	for(n=0;n<MAX_NOTES;n++) {two_nota[n]=nota[n];}
    }

return 0;
}

/*********************************************************************************/
/* PCM Out */
/*********************************************************************************/

#define MAX_PCMOUT 2048*2
short pcmout[MAX_PCMOUT*2];  /* take 4k out of the data segment, not the stack */

#define READ_SAMPLES 16384
#define SEND_SAMPLES 7680

int pcm_indx=0;
short pcm_ring[READ_SAMPLES+2048*4] __attribute__((aligned(16))); 

int pcm_indx2=0;
short pcm_ring2[READ_SAMPLES+2048*4] __attribute__((aligned(16))); 

int pcm_indx3=0;
short pcm_ring3[READ_SAMPLES+2048*4] __attribute__((aligned(16))); 

short pcm_mix_ring[SEND_SAMPLES] __attribute__((aligned(16))); 

int copy_samples(short *dest,short * ori,int bytes, int channels)
{
int n;
bytes>>=1;
if(channels==1)
	{
	for(n=0;n<bytes;n++)
		{
		*dest++=*ori;*dest++=*ori++;
		}
	return (bytes<<1);
	}
if(channels==2)
	{
	for(n=0;n<bytes;n++)
		{
		*dest++=*ori++;
		}
	return bytes;
	}
return 0;
}

 OggVorbis_File vf;
 OggVorbis_File vf2;
 OggVorbis_File vf3;

  int my_eof=0;
  int current_section;
vorbis_info *vi;

int my_eof2=0;
  int current_section2;
vorbis_info *vi2;

int my_eof3=0;
  int current_section3;
vorbis_info *vi3;


// reset datas

int key_note[5];
int key_ok[5];
int disp_key[5];

unsigned key_point=0,key2_point=0;

int two_key_note[5];
int two_key_ok[5];
int two_disp_key[5];

int flag_tresnotas=0;


int fallo=0;
int two_fallo=0;


void reset_notes()
{
int n;
ovacion=0;

lights_effects=0;

abucheo_timer=0;
abucheo=0;
aplausos=0;
bajo_off=0;
fail_key=0;
two_fail_key=0;
cuenta_atras=-1;
paused=0;
score=0;
score_star=0;
two_score=0;
two_score_star=0;
multiplica=1; 
aciertos=0;
rockometro=64;
two_multiplica=1; 
two_aciertos=0;
two_rockometro=64;
voices=0;

max_note_seq=0;
note_seq=0;
two_max_note_seq=0;
two_note_seq=0;

flash=0;

notes_ok=0;
two_notes_ok=0;

post_key=post_key2=0;

//old_vibrato=0;
//vibrato=0;
for(n=0;n<32;n++) {wah_wah[n]=0;two_wah_wah[n]=0;}

for(n=0;n<16;n++) light_time[n]=0;
key_point=0;key2_point=0;
for(n=0;n<5;n++) 
	{
	key_note[n]=key_ok[n]=disp_key[n]=0;
	two_key_note[n]=two_key_ok[n]=two_disp_key[n]=0;
	}
fond_table=0;fallo=0;two_fallo=0;fallo_sound=128;
}

void disp_number(int x,int y,unsigned num)
{

int flag=1;
unsigned div=100000,m;
if(num>999999) {x-=8;div=1000000;} // por si las moscas
while(div>0)
{
m=num/div;
if((m==0 && flag==0) || m!=0 || div==1)
	{
	flag=0;
	SetTexture(TEXT_NUM+(m));
	itoTextureSprite(0xff808080, x,y, 0,0,x+16,y+32, 16,16, 0);
	}
num-=m*div;
x+=16;div/=10;
itoGsFinish();


}
}


void fun_note_fallo()
{
multiplica=1; 
aciertos=0;
note_seq=0;

rumble1=15;

if(abucheo_timer==0 && (twoplayers==0 || (twoplayers==0 && two_fallo))) abucheo_timer=1;
if(mid_speed==4)
{
if(rockometro>32) rockometro-=4; else 
	{if(twoplayers==0 || (twoplayers!=0 && modeplayers!=0) || (twoplayers!=0 && modeplayers==0 && two_rockometro<=32))
			if(abucheo<=0) abucheo=ACTIVE_SOUND; rockometro--;
	}
}
if(rockometro<0) rockometro=0;

if(star_counter!=0)
		{
		int l;

		star_counter=0;
		for(l=0;l<8;l++)
			{
			if(star_table[star_pos][l]>=0) nota[star_table[star_pos][l]]&=32767; else break;
			}
		if(star_table[star_pos][0]>=0) star_pos++;
		}
}

void fun_note_ok()
{
note_seq++;

abucheo_timer=0;
if(note_seq>max_note_seq) max_note_seq=note_seq;

if(aciertos<10) aciertos++;
if(aciertos>=10)
	{
	
	if(multiplica<4) {multiplica++;voices|=8;if(multiplica<4) {aciertos=0;}}
	}
if(mid_speed==4) rockometro++;

if(rockometro>=96) {if(ovacion<=0  && abucheo<=0) ovacion=ACTIVE_SOUND;}
if(rockometro>128) rockometro=128;
}


void two_fun_note_fallo()
{
two_multiplica=1; 
two_aciertos=0;
two_note_seq=0;

rumble2=15;

if(abucheo_timer==0 && (twoplayers==0 || (twoplayers==0 && fallo))) abucheo_timer=1;
if(mid_speed==4)
{
if(two_rockometro>32) two_rockometro-=4; else 
	{if(twoplayers==0 || (twoplayers!=0 && modeplayers!=0) || (twoplayers!=0 && modeplayers==0 && rockometro<=32))
		if(abucheo<=0) abucheo=ACTIVE_SOUND; two_rockometro--;
	}
}
if(two_rockometro<0) two_rockometro=0;

if(two_star_counter!=0)
		{
		int l;

		two_star_counter=0;
		for(l=0;l<8;l++)
			{
			if(two_star_table[two_star_pos][l]>=0) two_nota[two_star_table[two_star_pos][l]]&=32767; else break;
			}
		if(two_star_table[two_star_pos][0]>=0) two_star_pos++;
		}
}

void two_fun_note_ok()
{
two_note_seq++;

abucheo_timer=0;
if(two_note_seq>two_max_note_seq) two_max_note_seq=two_note_seq;

if(two_aciertos<10) two_aciertos++;
if(two_aciertos>=10)
	{
	
	if(two_multiplica<4) {two_multiplica++;voices|=8;if(two_multiplica<4) {two_aciertos=0;}}
	}
if(mid_speed==4) two_rockometro++;

if(two_rockometro>=96) {if(ovacion<=0  && abucheo<=0) ovacion=ACTIVE_SOUND;}
if(two_rockometro>128) two_rockometro=128;
}


unsigned border2=0xff000010;

void main_playing()
{
	int n,m,m2,s,i;

int wah_temp=0;	

unsigned col;

int ind;

unsigned short *punt_note=0;
unsigned short *punt_note2=0;


unsigned short *two_punt_note=0;
unsigned short *two_punt_note2=0;





itoZTest(FALSE);

n=16;

if(aplausos>0 && aplausos!=ACTIVE_SOUND && aplausos!=65536) aplausos-=n;
if(ovacion>0 && ovacion!=ACTIVE_SOUND) ovacion-=n;
if(abucheo>0 && abucheo!=ACTIVE_SOUND) abucheo-=n;
if(abucheo_timer>0) abucheo_timer+=n;

if(abucheo_timer>3000)
	{
	if(abucheo<=0) abucheo=ACTIVE_SOUND;
	}
if(nota_indx>=last_midi_note) {abucheo_timer=0;abucheo=0;}

col=0xff000010;

if(nota_indx>=last_midi_note)
		{
		
		m=(nota_indx-last_midi_note)*3;
		if(m>128) m=128;
		m=128-m;
		
		col=0xff000000 | (((((col>>16) & 255)*m)>>7)<<16) | (((((col>>8) & 255)*m)>>7)<<8) | ((((col & 255)*m)>>7));
		
		}

border2=col;
ClearScreen(col); // borra pantalla
itoZTest(FALSE);


itoPrimShade(ITO_PRIM_SHADE_GOURAUD);


PX=0;PY=0;color=0xffffffff;bkcolor=0;tamletra=2;


m=0;

nvert2=0;

m=Y_STEP1;




ind=nota_indx+10;

if(time_effects_max<=1 || time_effects_pos>=(time_effects_max))
{
if((ind & 128)) lights_effects=1; else lights_effects=0;
}

else
{
if(time_effects_pos<(time_effects_max))
{
int tim;
if(ind>=(time_effects[time_effects_pos+1][0]/100)) {time_effects_pos++;lights_effects&=~128;}
tim=time_effects_pos-1; if(tim<0) tim=0;
 if(time_effects[time_effects_pos][1]!=time_effects[tim][1]) {if((lights_effects & 128)==0) lights_effects^=1;lights_effects|=128;} //else lights_effects=0;
 

}
else lights_effects=0;
}
i=-Y_STEP1+nota_step;


	dib_escenario(25*m,ind);
	if(nota_indx<last_midi_note) dib_lights2(Y_STEP1*27); 
	else {if(rockometro>32 || two_rockometro>32) {if(aplausos<=0 && abucheo<=0)  aplausos=65536;}
		 else {if(abucheo<=0) abucheo=ACTIVE_SOUND; }
		 }
 


itoZTest(TRUE);


fond_table=0;	


punt_note=0;
punt_note2=0;

nota_map[14]=0;

two_punt_note=0;
two_punt_note2=0;

two_nota_map[14]=0;

for(n=0;n<15;n++)
	{
	if((ind-n)>=MAX_NOTES) continue;
	
	if(star_table[star_pos][0]>=0 && star_table[star_pos][0]<(ind-n) && star_table[star_pos+1][0]==ind-n)
		{star_pos++;star_counter=0;}

	if(star_counter==0 && star_table[star_pos][0]==ind-n && star_table[star_pos][0]>=0 )
		{
		int l;
		for(l=0;l<8;l++)
			{
			if(star_table[star_pos][l]>=0) star_counter++; else break;
			}
		}

	// two_

	if(two_star_table[two_star_pos][0]>=0 && two_star_table[two_star_pos][0]<(ind-n) && two_star_table[two_star_pos+1][0]==ind-n)
		{two_star_pos++;two_star_counter=0;}

	if(two_star_counter==0 && two_star_table[two_star_pos][0]==ind-n && two_star_table[two_star_pos][0]>=0 )
		{
		int l;
		for(l=0;l<8;l++)
			{
			if(two_star_table[two_star_pos][l]>=0) two_star_counter++; else break;
			}
		}
	
	if((ind-n)>=MAX_NOTES || (ind-n)<=0) nota_map[n]=0;
	else nota_map[n]=nota[ind-n];

	if((ind-n)>=MAX_NOTES || (ind-n)<=0) two_nota_map[n]=0;
	else two_nota_map[n]=two_nota[ind-n];

	if(n==13)
		{
	   if((ind-13)<MAX_NOTES) {punt_note=&nota[ind-13];two_punt_note=&two_nota[ind-13];} else {punt_note=0;two_punt_note=0;}
	  
		}
	if(n==14)
		{
	   if((ind-14)<MAX_NOTES) {punt_note2=&nota[ind-14];two_punt_note2=&two_nota[ind-14];} else {punt_note2=0;two_punt_note2=0;}
		}
	  
		
	}



for(n=0;n<15;n++)
	{
	if((ind-n)>=MAX_NOTES) continue;

	fond_table+=Y_STEP1;pos_table[n]=fond_table+i;

	}

fond_table+=Y_STEP1;
pos_table[n]=fond_table+i; // uno mas 
pos_table[n+1]=fond_table+Y_STEP1+i; // otro mas 

if(tex_mastil==3)	
{
n=(flash>>1) & 127;
if(n==10 || n==12 || n==74 || n==76 || n==78 || n==80)
	SetTexture(TEXT_MASTIL+1);
	
else
if(n==11 || n==75 || n==79)
	SetTexture(TEXT_MASTIL+2);

else SetTexture(TEXT_MASTIL+0);

}
else
if(tex_mastil==2)	
{
n=(flash>>1) & 127;
if(n==10 || n==12 || n==74 || n==76 || n==78 || n==80)
	SetTexture(TEXT_MASTIL+1);
	
else
if(n==11 || n==75 || n==79)
	SetTexture(TEXT_MASTIL+2);

else SetTexture(TEXT_MASTIL+0);

}
else
	if(tex_mastil==1)	
	{
	
	n=(flash>>3) & 3;
	if(n==1 || n==3)
		
		SetTexture(TEXT_MASTIL+(1));
	else
	if(n==2)
		SetTexture(TEXT_MASTIL+(2)); 
	else 
		SetTexture(TEXT_MASTIL+(0));
	}
else
	if(tex_mastil==0 || tex_mastil==4)	
	{
	
	n=(flash>>4) & 3;
	if(n==1 || n==3)
		SetTexture(TEXT_MASTIL+(1));
	else
	if(n==2)
		SetTexture(TEXT_MASTIL+(2)); 
	else SetTexture(TEXT_MASTIL+(0));

	}



for(n=0;n<17;n++)
	{
	dib_mastil1(fond_table-pos_table[n],ind-n,(i)*(n==0),n);
	}
itoBlend(0);
z_offset=0.0f;
Send_Vertex(TYPE_MASTIL1);
itoBlend(1);


for(n=0;n<15;n++)
	{
	if((ind-n)>=MAX_NOTES) continue;	
	
	if(((3-(ind-n)) & 3)==0) 
		dib_traste(fond_table-(pos_table[n]),1);
	}
z_offset=0.5f;
Send_Vertex(TYPE_MASTIL1);

if(twoplayers)
{
for(n=0;n<17;n++)
	{
	dib_mastil2(fond_table-pos_table[n],ind-n,(i)*(n==0),n);
	}

z_offset=0.0f;
Send_Vertex(TYPE_MASTIL2);

for(n=0;n<15;n++)
	{
	if((ind-n)>=MAX_NOTES) continue;	
	
	if(((3-(ind-n)) & 3)==0) 
		dib_traste(fond_table-(pos_table[n]),2);
	}
z_offset=0.5f;
Send_Vertex(TYPE_MASTIL2);
}



m=Y_STEP1;

dib_cuerda(1,(17*m),0);
dib_cuerda(2,(17*m),0);
dib_cuerda(3,(17*m),0);
dib_cuerda(4,(17*m),0);
dib_cuerda(5,(17*m),0);
z_offset=20.0f;
Send_Vertex(TYPE_MASTIL);


// transforma notas largas (one-two)

m=31;m2=31;
for(n=11;n>=0;n--) 
	{
	unsigned short flag=0;
	unsigned short flag2=0;

		if((ind-n)<MAX_NOTES) {flag=nota[ind-n];flag2=two_nota[ind-n];}

		if((m & 1)!=0 && (disp_key[0] & 128)!=0)
			{
			s=(flag>>(0*3)) & 7;
			if(s==0 || s==6 || s==7) m&=~1;
			if(s==3) nota_map[n]^=1<<(0*3);
			}
		if((m & 2)!=0 && (disp_key[1] & 128)!=0)
			{
			s=(flag>>(1*3)) & 7;
			if(s==0 || s==6 || s==7) m&=~2;
			if(s==3) nota_map[n]^=1<<(1*3);
			}
		if((m & 4)!=0 && (disp_key[2] & 128)!=0)
			{
			s=(flag>>(2*3)) & 7;
			if(s==0 || s==6 || s==7) m&=~4;
			if(s==3) nota_map[n]^=1<<(2*3);
			}
		if((m & 8)!=0 && (disp_key[3] & 128)!=0)
			{
			s=(flag>>(3*3)) & 7;
			if(s==0 || s==6 || s==7) m&=~8;
			if(s==3) nota_map[n]^=1<<(3*3);
			}
		if((m & 16)!=0 && (disp_key[4] & 128)!=0)
			{
			s=(flag>>(4*3)) & 7;
			if(s==0 || s==6 || s==7) m&=~16;
			if(s==3) nota_map[n]^=1<<(4*3);
			}

		// two_

		if((m2 & 1)!=0 && (two_disp_key[0] & 128)!=0)
			{
			s=(flag2>>(0*3)) & 7;
			if(s==0 || s==6 || s==7) m2&=~1;
			if(s==3) two_nota_map[n]^=1<<(0*3);
			}
		if((m2 & 2)!=0 && (two_disp_key[1] & 128)!=0)
			{
			s=(flag2>>(1*3)) & 7;
			if(s==0 || s==6 || s==7) m2&=~2;
			if(s==3) two_nota_map[n]^=1<<(1*3);
			}
		if((m2 & 4)!=0 && (two_disp_key[2] & 128)!=0)
			{
			s=(flag2>>(2*3)) & 7;
			if(s==0 || s==6 || s==7) m2&=~4;
			if(s==3) two_nota_map[n]^=1<<(2*3);
			}
		if((m2 & 8)!=0 && (two_disp_key[3] & 128)!=0)
			{
			s=(flag2>>(3*3)) & 7;
			if(s==0 || s==6 || s==7) m2&=~8;
			if(s==3) two_nota_map[n]^=1<<(3*3);
			}
		if((m2 & 16)!=0 && (two_disp_key[4] & 128)!=0)
			{
			s=(flag2>>(4*3)) & 7;
			if(s==0 || s==6 || s==7) m2&=~16;
			if(s==3) two_nota_map[n]^=1<<(4*3);
			}

	}





// transforma notas largas cuando hay fallo (one-two)

m=31;m2=31;

for(n=11;n>=0;n--) 
	{
	unsigned short flag=0;
	unsigned short flag2=0;

		if((ind-n)<MAX_NOTES) {flag=nota[ind-n];flag2=two_nota[ind-n];}

		if((m & 1)!=0 && (fail_key & 1)!=0 )
			{
			s=(flag>>(0*3)) & 7;
			if(s==0 || s==6 || s==7) m&=~1;
			if(s==3) nota_map[n]^=1<<(0*3);
			}
		if((m & 2)!=0 && (fail_key & 2)!=0)
			{
			s=(flag>>(1*3)) & 7;
			if(s==0 || s==6 || s==7) m&=~2;
			if(s==3) nota_map[n]^=1<<(1*3);
			}
		if((m & 4)!=0 && (fail_key & 4)!=0)
			{
			s=(flag>>(2*3)) & 7;
			if(s==0 || s==6 || s==7) m&=~4;
			if(s==3) nota_map[n]^=1<<(2*3);
			}
		if((m & 8)!=0 && (fail_key & 8)!=0)
			{
			s=(flag>>(3*3)) & 7;
			if(s==0 || s==6 || s==7) m&=~8;
			if(s==3) nota_map[n]^=1<<(3*3);
			}
		if((m & 16)!=0 && (fail_key & 16)!=0)
			{
			s=(flag>>(4*3)) & 7;
			if(s==0 || s==6 || s==7) m&=~16;
			if(s==3) nota_map[n]^=1<<(4*3);
			}

	  // two_

		if((m2 & 1)!=0 && (two_fail_key & 1)!=0)
			{
			s=(flag2>>(0*3)) & 7;
			if(s==0 || s==6 || s==7) m2&=~1;
			if(s==3) two_nota_map[n]^=1<<(0*3);
			}
		if((m2 & 2)!=0 && (two_fail_key & 2)!=0)
			{
			s=(flag2>>(1*3)) & 7;
			if(s==0 || s==6 || s==7) m2&=~2;
			if(s==3) two_nota_map[n]^=1<<(1*3);
			}
		if((m2 & 4)!=0 && (two_fail_key & 4)!=0)
			{
			s=(flag2>>(2*3)) & 7;
			if(s==0 || s==6 || s==7) m2&=~4;
			if(s==3) two_nota_map[n]^=1<<(2*3);
			}
		if((m2 & 8)!=0 && (two_fail_key & 8)!=0)
			{
			s=(flag2>>(3*3)) & 7;
			if(s==0 || s==6 || s==7) m2&=~8;
			if(s==3) two_nota_map[n]^=1<<(3*3);
			}
		if((m2 & 16)!=0 && (two_fail_key & 16)!=0)
			{
			s=(flag2>>(4*3)) & 7;
			if(s==0 || s==6 || s==7) m2&=~16;
			if(s==3) two_nota_map[n]^=1<<(4*3);
			}
	
	
	
	}



// player one dib notes

for(n=0;n<15;n++)
	{
	int k;
	int gallo;

	if((ind-n)>=MAX_NOTES) continue;
	
	m=nota_map[n];

	if(n==0) signal_generate_dib_notes=3;

	if((m & 32767)!=0)
		{
		k=fond_table-(pos_table[n]);

				
		if(!((fallo==0 && n==11 && i>=-4) || n>11)) dib_liganotas(m,k,1);
		for(s=0;s<5;s++)
			{
			int kk,kk2,kk3=0,kk4;
			kk=(m>>(s*3)) & 7;
			kk4=kk;
			kk2=(nota_map[n+1]>>(s*3)) & 7;
			if(n>0) {kk3=(nota_map[n-1]>>(s*3)) & 7;if(!kk3) kk3=5;}
			k=fond_table-(pos_table[n]/*+i*/);

			if(kk==7 && son_ligadas==0 && star_on<0 && ((n==4 && (flash & 1)==0) || (n==2 && (flash & 1)==1))) 
				{star_on=s+1;
				star_posz=k;
				star_step=0;
				}

			if(kk==5 ) kk=0;
			if(kk!=0)
			if(fallo==0)
				{
				if(kk>5 && ((n==11 && i>=-8) || (n==13 && i<-8) || (n==12 ))) {kk=8;}
				else
				if(kk<4 && (n==11 && i>=-8)) {k=k-i-2;}
				else
				if(kk<4 && n>11) {if(key_ok[s]!=0) kk=0; else if(((nota_map[11]>>(s*3)) & 6)==2) kk=3; else kk=0;}
				}
				
			
			gallo=fallo;

			if(((fail_key>>s) & 1)!=0) if(kk==2) kk=3;

			
			if(kk)

				dib_note(s+1+512*(kk==6 )+64*(kk==3)+96*(kk==2)+128*((n>=12 && gallo) || (gallo && kk4==2))
					 +256*(m>32767)+1024*(kk2>=5 && kk4<4)+2048*(kk3>=5 && kk4<4)+16384*(n>=11 && gallo==0 && kk4<6)+32768*(kk==8)+65536*(n==0),k,1);
					 
				
			}
		}
	}




dib_onestar(1);

z_offset=30.0f;	

Send_Vertex(TYPE_PLAYER1);

// player two dib notes

if(twoplayers)
{
for(n=0;n<15;n++)
	{
	int k;
	int two_gallo;

	if((ind-n)>=MAX_NOTES) continue;
	
	m=two_nota_map[n];

	if((m & 32767)!=0 )
		{
		k=fond_table-(pos_table[n]);
		
		if(!((two_fallo==0 && n==11 && i>=-4) || n>11)) dib_liganotas(m,k,2);
		for(s=0;s<5;s++)
			{
			int kk,kk2,kk3=0,kk4;
			kk=(m>>(s*3)) & 7;
			kk4=kk;
			kk2=(two_nota_map[n+1]>>(s*3)) & 7;
			if(n>0) {kk3=(two_nota_map[n-1]>>(s*3)) & 7;if(!kk3) kk3=5;}
			k=fond_table-(pos_table[n]);

			if(kk==7 && son_ligadas==0 && star_on<0 && ((n==4 && (flash & 1)==0) || (n==2 && (flash & 1)==1))) 
				{star_on=s+1;
				star_posz=k;
				star_step=0;
				}
			
			two_gallo= two_fallo;

			if(kk==5 ) kk=0;
			if(kk!=0)
			if(two_fallo==0)
				{
				
				if(kk>5 && ((n==11 && i>=-8) || (n==13 && i<-8) || (n==12 ))) {kk=8;}
				else
				if(kk<4 && (n==11 && i>=-8)) {k=k-i-2;}
				else
				if(kk<4 && n>11) {if(two_key_ok[s]!=0) kk=0; else if(((two_nota_map[11]>>(s*3)) & 6)==2) kk=3; else kk=0;}
				}
				
			
			
			if(((two_fail_key>>s) & 1)!=0) if(kk==2) kk=3;


			
			if(kk)

				dib_note(s+1+512*(kk==6 )+64*(kk==3)+96*(kk==2)+128*((n>=12 && two_gallo) || (two_gallo && kk4==2))
					 +256*(m>32767)+1024*(kk2>=5 && kk4<4)+2048*(kk3>=5 && kk4<4)+16384*(n>=11 && two_gallo==0 && kk4<6)+32768*(kk==8)+65536*(n==0),k,2);
			
			}
		}
	}


dib_onestar(2);

z_offset=30.0f;	
Send_Vertex(TYPE_PLAYER2);
}

if(!paused)
{
for(n=31;n>0;n--) {wah_wah[n]=wah_wah[n-1];two_wah_wah[n]=two_wah_wah[n-1];}

wah_wah[0]=0;two_wah_wah[0]=0;

}

////////////////////////////
// input one
////////////////////////////


wah_temp=wah_pop(); // get wahwah from sound buffer

if(input_mode==2)
if(Read_Keyboard(1))
		{
		int t;

		
		if(!paused)
		{
        if(new_key & KEY_WAH)
         {
         wah_wah[0]=wah_temp;
	     stick1_wahwah=100;
         }
         else 
         {
         wah_wah[0]=0;
	     stick1_wahwah=0;
         }
	    
		if((new_key | old_key) & KEY_F1) key_note[0]|=1; else {key_point&=~1;key_note[0]=0;
                                                               if(key_ok[0]) for(t=0;t<5;t++) if(!((key_point>>t) & 1)) key_ok[t]=0;}
		if((new_key | old_key) & KEY_F2 ) key_note[1]|=1; else {key_point&=~2;key_note[1]=0;
                                                               if(key_ok[1]) for(t=0;t<5;t++) if(!((key_point>>t) & 1)) key_ok[t]=0;}
		if((new_key | old_key) & KEY_F3) key_note[2]|=1; else {key_point&=~4;key_note[2]=0;
                                                               if(key_ok[2]) for(t=0;t<5;t++) if(!((key_point>>t) & 1)) key_ok[t]=0;}
		if((new_key | old_key) & KEY_F4)  key_note[3]|=1; else {key_point&=~8;key_note[3]=0;
                                                               if(key_ok[3]) for(t=0;t<5;t++) if(!((key_point>>t) & 1)) key_ok[t]=0;}
		if((new_key | old_key) & KEY_F5) key_note[4]|=1; else {key_point&=~16;key_note[4]=0;
                                                               if(key_ok[4]) for(t=0;t<5;t++) if(!((key_point>>t) & 1)) key_ok[t]=0;}
		
		
			if((new_key & KEY_ENTER) || post_key)
			{
            key_point=0;
			for(n=0;n<32;n++) wah_wah[n]=0;
			m=0;
			for(n=0;n<5;n++) {if(key_note[n] & 1) {m=1;key_note[n]|=2;if(((key_point>>n) & 1)) {key_point&=~(1<<n);key_note[n]&=~2;}}}

			if(!m) 
				{
				if(post_key>3)
					{
				    for(m=0;m<5;m++) {key_ok[m]=0;fail_key|=1<<m;}fallo=1;fallo_sound&=127; // fallo
				    fun_note_fallo();post_key=0;
					}
				else post_key++;
				} else post_key=0;
			}
			}
			else
			{
			if((new_key) & (KEY_DOWN)) men_pause=1;
			if((new_key) & (KEY_UP)) men_pause=0;

			}

		if((new_key & KEY_ESC)  && paused==0) {paused=1;men_pause=0;}
		else if((new_key & (KEY_F1 | KEY_ENTER)) && paused && men_pause==0) paused=0;

		}


if(input_mode!=2)
if(readpad(0 +128*(input_mode==3 || input_mode==4)) )
		{
		int t;

        wah_wah[0]=(stick1_wahwah);
		
 
		if(!paused)
		{

		if(input_mode==0 || input_mode==3)
		{
		if((new_pad | old_pad) & PAD_1) key_note[0]|=1; else {key_point&=~1;key_note[0]=0;
                                                      if(key_ok[0]) for(t=0;t<5;t++) if(!((key_point>>t) & 1)) key_ok[t]=0;}
		if((new_pad | old_pad) & PAD_2) key_note[1]|=1; else {key_point&=~2;key_note[1]=0;
                                                      if(key_ok[1]) for(t=0;t<5;t++) if(!((key_point>>t) & 1)) key_ok[t]=0;}
		if((new_pad | old_pad) & PAD_3) key_note[2]|=1; else {key_point&=~4;key_note[2]=0;
                                                      if(key_ok[2]) for(t=0;t<5;t++) if(!((key_point>>t) & 1)) key_ok[t]=0;}
		if((new_pad | old_pad) & PAD_4)  key_note[3]|=1; else {key_point&=~8;key_note[3]=0;
                                                      if(key_ok[3]) for(t=0;t<5;t++) if(!((key_point>>t) & 1)) key_ok[t]=0;}
		if((new_pad | old_pad) & PAD_5) key_note[4]|=1; else {key_point&=~16;key_note[4]=0;
                                                      if(key_ok[4]) for(t=0;t<5;t++) if(!((key_point>>t) & 1)) key_ok[t]=0;}
		
		
			if((new_pad & (PAD_UP | PAD_DOWN)) || post_key)
			{
            key_point=0;
			for(n=0;n<32;n++) wah_wah[n]=0;
			m=0;
			for(n=0;n<5;n++) {if(key_note[n] & 1) {m=1;key_note[n]|=2;if(((key_point>>n) & 1)) {key_point&=~(1<<n);key_note[n]&=~2;}}}

			if(!m) 
				{
				if(post_key>3)
					{for(m=0;m<5;m++) {key_ok[m]=0;fail_key|=1<<m;}fallo=1;fallo_sound&=127; // fallo
				     fun_note_fallo(); post_key=0;
					}
				else post_key++;
				} else post_key=0;

		
			}
		} // input mode ==0

		if(input_mode==1 || input_mode==4)
		{
        key_point=0;
        if((new_pad | old_pad) & PAD_1) key_note[0]|=1; else {key_note[0]=0;if(key_ok[0]) for(t=0;t<5;t++) key_ok[t]=0;}
		if((new_pad | old_pad) & PAD_2 ) key_note[1]|=1; else {key_note[1]=0;if(key_ok[1]) for(t=0;t<5;t++) key_ok[t]=0;}
		if((new_pad | old_pad) & PAD_3) key_note[2]|=1; else {key_note[2]=0;if(key_ok[2]) for(t=0;t<5;t++) key_ok[t]=0;}
		if((new_pad | old_pad) & PAD_4)  key_note[3]|=1; else {key_note[3]=0;if(key_ok[3]) for(t=0;t<5;t++) key_ok[t]=0;}
		if((new_pad | old_pad) & PAD_5) key_note[4]|=1; else {key_note[4]=0;if(key_ok[4]) for(t=0;t<5;t++) key_ok[t]=0;}
		
			
			m=0;
			

			if((new_pad) & PAD_1) {key_note[0]|=2;m=1; }
			if((new_pad) & PAD_2 ) {key_note[1]|=2;m=1;}
			if((new_pad) & PAD_3) {key_note[2]|=2; m=1;}
			if((new_pad) & PAD_4)  {key_note[3]|=2;m=1; }
			if((new_pad) & PAD_5) {key_note[4]|=2;m=1;}
			if(m) {for(n=0;n<32;n++) wah_wah[n]=0;}

	
		} // input mode ==1

		}
	 else
		{
		if((new_pad) & (PAD_DOWN)) men_pause=1;
		if((new_pad) & (PAD_UP)) men_pause=0;

		}
		
		if(input_mode==0 || input_mode==3)
			{if((new_pad & PAD_START) && (old_pad & (PAD_1 | PAD_2 | PAD_3 | PAD_4))==(PAD_1 | PAD_2 | PAD_3 | PAD_4)  && paused==0) {paused=1;men_pause=0;new_pad=0;}
			else if((new_pad & (PAD_START  | PAD_1)) && paused && men_pause==0) paused=0;
			}
		else
			{if((new_pad & PAD_START) && paused==0) {paused=1;men_pause=0;new_pad=0;}
			else if((new_pad & (PAD_START | PAD_4 | PAD_1 | PAD_3)) && paused && men_pause==0) paused=0;
			}
		}

if(nota_indx<50 && key_note[4]==3)
	{
	key_note[4]&=1;
	if(!twoplayers) bajo_off=1;
	}
	////////////////////////////////////////////////////
	if(!paused)
	{
	unsigned short flag,flag2,flag4;
	unsigned short *pnote;
	int o,t,key_master,pp;
	int key_star=0;
	int test=0;
	unsigned fail_out=0;


   pp=0;
   if(i>=-8) pp=1;
   
	m=0;

	for(n=0;n<5;n++)
			{
			flag=nota_map[14];
			flag=(flag>>(n*3)) & 7;
		
			if(flag>=6) {m=1;fail_out|=1<<n;fail_key|=1<<n;fallo=1;voices|=1;/*fallo_sound&=127;*/
			            if(punt_note2) *(punt_note2)=0;
						for(t=0;t<5;t++) key_ok[t]=0;break;
						}
		
			}
	if(m) fun_note_fallo();
	if(punt_note2) *(punt_note2)&=32767;
	test=0;
	for(n=0;n<5;n++)
			{
			 int key_flag=0;

			 key_master=0;
			 for(o=pp;o<2;o++)
				{
				flag=0;flag2=0;
				if(punt_note)
					pnote=punt_note+o;
				else pnote=0;

				if(pnote) 
				{
				flag=*(pnote);flag2=*(pnote+1);
				flag=(flag>>(n*3)) & 7;
				flag2=(flag2>>(n*3)) & 7;
				
				if(flag>=6)  flag=3;
				else if(flag==3 || flag==2) flag=2; 
				else  if(flag==5) flag=1;
				else flag=0;

				if(flag2>=6)  flag2=3;
				else if(flag2==3 || flag2==2) flag2=2; 
				else  if(flag2==5) flag2=1;
				else flag2=0;
				}
			    
				if(flag2>flag) {flag=flag2;pnote++;}
				if(flag>1) flag--;

				if(flag==0)
				{
				if(test==0) {test=1;continue;}
				}

				flag4=0;
				if(pnote) flag4=(*(pnote)>>(n*3)) & 7;

				if(flag==1 && flag4==5) {key_flag=1;continue;} // nota ya percutida

				if(key_note[n]==3)
					{
					if(!m && flag<2) if(o==0) {test=1;continue;}

					if(flag<2 || m) ;
					else {notes_ok++;key_master=1;key_ok[n]=8;fail_key&=~(1<<n);fallo=0;score+=calc_score(15);fun_note_ok(); if(pnote) if(*pnote>32767) key_star=1;} 
					if(flag>=2)
					{
					if(pnote) *pnote=((*pnote) & (~(7<<(n*3))))| (5<<(n*3));
					flag=1;
					}
					}
				if(key_star)
					{if(pnote) *pnote &= 32767;key_star=0;
					if(key_master && star_counter>0)
						{
						star_counter--;if(star_counter==0) {score_star=5000;}
						}
					}
				}
			
			
			if(key_master || (key_master==0 && key_flag==1)) key_note[n]=1;
			}
			//////
			test=0;
			

			for(n=0;n<5;n++)
			{
				//key_master=0;
			 for(o=pp;o<2;o++)
				{
				flag=0;flag2=0;
				if(punt_note)
					pnote=punt_note+o;
				else pnote=0;

				if(pnote) 
				{
				flag=*(pnote);flag2=*(pnote+1);
				flag=(flag>>(n*3)) & 7;
				flag2=(flag2>>(n*3)) & 7;
				
				if(flag>=6)  flag=3;
				else if(flag==3 || flag==2) flag=2; 
				else  if(flag==5) flag=1;
				else flag=0;

				if(flag2>=6)  flag2=3;
				else if(flag2==3 || flag2==2) flag2=2; 
				else  if(flag2==5) flag2=1;
				else flag2=0;
				}
			    
				if(flag2>flag) {flag=flag2;pnote++;}
				if(flag>1) flag--;

				if(flag==0)
				{
				if(test==0) {test=1;continue;}
				}

				flag4=0;
				if(pnote) flag4=((*(pnote))>>(n*3)) & 7;

				if(flag==1 && flag4==5) continue; // nota ya percutida

			
				if(key_note[n]==3)
					{
					if(m==0) fun_note_fallo();
					for(t=0;t<5;t++) {key_ok[t]=0;fail_key|=(1<<t);}key_note[n]=1;m=1;fallo=1;fallo_sound&=127; // fallo
					
					}
					else 
				if(key_note[n]==1)
					{
					if(flag==1 || (flag!=0 &&  flag4==6)) 
						{if( flag4==6 && ((fail_out>>n) & 1)==0) {key_point|=(1<<n); score+=calc_score(15);fun_note_ok(); notes_ok++;key_ok[n]=8;fail_key&=~(1<<n);fallo=0;} 
					      if (key_ok[n]>0 && m==0) {key_ok[n]=8;score+=calc_score(1);}  else {for(t=0;t<5;t++) {key_ok[t]=0;fail_key|=(1<<t);}}
						  }
			
					if(flag!=0 &&  flag4==6)
					{
					if(pnote) *pnote=((*pnote) & (~(7<<(n*3))))| (5<<(n*3));

					flag=1;
					}
					}
				
			

				}
			}

			for(n=0;n<5;n++)
			{
			flag=0;
			if(key_ok[n]) {key_ok[n]--;flag=128;}
			if(flag)
				{
				if(key_note[n]==1) flag|=64;
				if(key_note[n]==3) flag|=64;
				}
			else if(key_note[n]==1) flag=64;
			disp_key[n]=flag;
			}
			
	}
	
////////////////////////////
// fin input one
////////////////////////////


////////////////////////////
// input two
////////////////////////////

if(twoplayers)
{
if(input_mode2==2)
if(Read_Keyboard(2)) // keyboard 2: 129-> mapa de keys 1, 130->mapa de keys 2
		{
		int t;
		
		if(!paused)
		{
	    if(new_key2 & KEY_WAH)
         {
         two_wah_wah[0]=wah_temp;
	     stick2_wahwah=100;
         }
         else 
         {
         two_wah_wah[0]=0;
	     stick2_wahwah=0;
         }
		if((new_key2 | old_key2) & KEY_F1) two_key_note[0]|=1; else {key2_point&=~1;two_key_note[0]=0;
                                                                    if(two_key_ok[0]) for(t=0;t<5;t++) if(!((key2_point>>t) & 1)) two_key_ok[t]=0;}
		if((new_key2 | old_key2) & KEY_F2 ) two_key_note[1]|=1; else {key2_point&=~2;two_key_note[1]=0;
                                                                    if(two_key_ok[1]) for(t=0;t<5;t++) if(!((key2_point>>t) & 1)) two_key_ok[t]=0;}
		if((new_key2 | old_key2) & KEY_F3) two_key_note[2]|=1; else {key2_point&=~4;two_key_note[2]=0;
                                                                    if(two_key_ok[2]) for(t=0;t<5;t++) if(!((key2_point>>t) & 1)) two_key_ok[t]=0;}
		if((new_key2 | old_key2) & KEY_F4)  two_key_note[3]|=1; else {key2_point&=~8;two_key_note[3]=0;
                                                                    if(two_key_ok[3]) for(t=0;t<5;t++) if(!((key2_point>>t) & 1)) two_key_ok[t]=0;}
		if((new_key2 | old_key2) & KEY_F5) two_key_note[4]|=1; else {key2_point&=~16;two_key_note[4]=0;
                                                                    if(two_key_ok[4]) for(t=0;t<5;t++) if(!((key2_point>>t) & 1)) two_key_ok[t]=0;}
		
		
			if((new_key2 & KEY_ENTER) || post_key2)
			{
            key2_point=0;
			for(n=0;n<32;n++) two_wah_wah[n]=0;
			m=0;
			for(n=0;n<5;n++) {if(two_key_note[n] & 1) {m=1;two_key_note[n]|=2;if(((key2_point>>n) & 1)) {key2_point&=~(1<<n);two_key_note[n]&=~2;}}}

			if(!m) 
				{
				if(post_key2>3)
				  {
				  for(m=0;m<5;m++) {two_key_ok[m]=0;two_fail_key|=1<<m;} two_fallo=1;fallo_sound&=127; // fallo
				  two_fun_note_fallo();post_key2=0;
				  }
				 else post_key2++;
				} else post_key2=0;
		
			}
			}
			else
			{
			if((new_key2) & (KEY_DOWN)) men_pause=1;
			if((new_key2) & (KEY_UP)) men_pause=0;

			
			}
       
       // keyboard pausa si no es clon
        if(input_mode!=2 && input_mode!=2)
        {
		if((new_key2 & KEY_ESC)  && paused==0) {paused=1;men_pause=0;}
		else if((new_key2 & (KEY_F1 | KEY_ENTER)) && paused && men_pause==0) paused=0;

		//old_key2|=new_key2;new_key2&=~old_key2;
        }
    
		}

#if 1
if(input_mode2!=2)
if(readpad(1+128*(input_mode2==3 || input_mode2==4)) )
		{
		int t;

		if(1) // dual shock detectado
			{
			two_wah_wah[0]=(stick2_wahwah);
			}
			else two_wah_wah[0]=0;
		
		
		if(!paused)
		{
	

		if(input_mode2==0 || input_mode2==3)
		{
		if((new_pad2 | old_pad2) & PAD_1) two_key_note[0]|=1; else {key2_point&=~1;two_key_note[0]=0;
                                                                   if(two_key_ok[0]) for(t=0;t<5;t++) if(!((key2_point>>t) & 1)) two_key_ok[t]=0;}
		if((new_pad2 | old_pad2) & PAD_2 ) two_key_note[1]|=1; else {key2_point&=~2;two_key_note[1]=0;
                                                                   if(two_key_ok[1]) for(t=0;t<5;t++) if(!((key2_point>>t) & 1)) two_key_ok[t]=0;}
		if((new_pad2 | old_pad2) & PAD_3) two_key_note[2]|=1; else {key2_point&=~4;two_key_note[2]=0;
                                                                   if(two_key_ok[2]) for(t=0;t<5;t++) if(!((key2_point>>t) & 1)) two_key_ok[t]=0;}
		if((new_pad2 | old_pad2) & PAD_4)  two_key_note[3]|=1; else {key2_point&=~8;two_key_note[3]=0;
                                                                   if(two_key_ok[3]) for(t=0;t<5;t++) if(!((key2_point>>t) & 1)) two_key_ok[t]=0;}
		if((new_pad2 | old_pad2) & PAD_5) two_key_note[4]|=1; else {key2_point&=~16;two_key_note[4]=0;
                                                                   if(two_key_ok[4]) for(t=0;t<5;t++) if(!((key2_point>>t) & 1)) two_key_ok[t]=0;}
		
		
			if((new_pad2 & (PAD_UP | PAD_DOWN)) || post_key2)
			{
            key2_point=0;
			for(n=0;n<32;n++) two_wah_wah[n]=0;
			m=0;
			for(n=0;n<5;n++) {if(two_key_note[n] & 1) {m=1;two_key_note[n]|=2;if(((key2_point>>n) & 1)) {key2_point&=~(1<<n);two_key_note[n]&=~2;}}}

			if(!m) 
				{
				if(post_key2>3)
					{
				    for(m=0;m<5;m++) {two_key_ok[m]=0;two_fail_key|=1<<m;}two_fallo=1;fallo_sound&=127; // fallo
				    two_fun_note_fallo();post_key2=0;
					}
				  else post_key2++;
				} else post_key2=0;
		
			}
		} // input mode ==0

		if(input_mode2==1 || input_mode2==4)
		{
        key2_point=0;
		if((new_pad2 | old_pad2) & PAD_1) two_key_note[0]|=1; else {two_key_note[0]=0;if(two_key_ok[0]) for(t=0;t<5;t++) two_key_ok[t]=0;}
		if((new_pad2 | old_pad2) & PAD_2) two_key_note[1]|=1; else {two_key_note[1]=0;if(two_key_ok[1]) for(t=0;t<5;t++) two_key_ok[t]=0;}
		if((new_pad2 | old_pad2) & PAD_3) two_key_note[2]|=1; else {two_key_note[2]=0;if(two_key_ok[2]) for(t=0;t<5;t++) two_key_ok[t]=0;}
		if((new_pad2 | old_pad2) & PAD_4)  two_key_note[3]|=1; else {two_key_note[3]=0;if(two_key_ok[3]) for(t=0;t<5;t++) two_key_ok[t]=0;}
		if((new_pad2 | old_pad2) & PAD_5) two_key_note[4]|=1; else {two_key_note[4]=0;if(two_key_ok[4]) for(t=0;t<5;t++) two_key_ok[t]=0;}
		

			m=0;
			

			if((new_pad2) & PAD_1) {two_key_note[0]|=2;m=1; }
			if((new_pad2) & PAD_2 ) {two_key_note[1]|=2;m=1;}
			if((new_pad2) & PAD_3) {two_key_note[2]|=2; m=1;}
			if((new_pad2) & PAD_4)  {two_key_note[3]|=2;m=1; }
			if((new_pad2) & PAD_5) {two_key_note[4]|=2;m=1;}
			if(m) {for(n=0;n<32;n++) two_wah_wah[n]=0;}

		
	
		} // input mode ==1

		}
	 else
		{
		if((new_pad2) & (PAD_DOWN)) men_pause=1;
		if((new_pad2) & (PAD_UP)) men_pause=0;

		}
		
		// pausa con PAD 2 si no es un clon
		if(!(((input_mode==0 || input_mode==1) && (input_mode2==3 || input_mode2==4)) ||
            ((input_mode==3 || input_mode==4) && (input_mode2==0 || input_mode2==1))))
       {
		if(input_mode2==0 || input_mode2==3)
			{
            
            if((new_pad2 & PAD_START) && (old_pad2 & (PAD_1 | PAD_2 | PAD_3 | PAD_4))==(PAD_1 | PAD_2 | PAD_3 | PAD_4)  && paused==0) {paused=1;men_pause=0;new_pad2=0;}
			else if((new_pad2 & (PAD_START | PAD_1)) && paused && men_pause==0) paused=0;
			}
		else

			{if((new_pad2 & PAD_START) && paused==0) {paused=1;men_pause=0;new_pad=0;}
			else if((new_pad2 & (PAD_START | PAD_4 | PAD_1 | PAD_3)) && paused && men_pause==0) paused=0;
			}
        }
        
		}
	#endif
	

	////////////////////////////////////////////////////
	if(!paused)
	{
	unsigned short flag,flag2,flag4;
	unsigned short *pnote;
	int o,t,key_master,pp;
	int key_star=0;
	int test=0;
	unsigned fail_out=0;


   pp=0;
   if(i>=-8) pp=1;
   
	m=0;

	for(n=0;n<5;n++)
			{
			flag=two_nota_map[14];
			flag=(flag>>(n*3)) & 7;
			if(flag>=6) {m=1;fail_out|=1<<n;two_fail_key|=1<<n;two_fallo=1;voices|=1;/*fallo_sound&=127;*/
			            if(two_punt_note2) *(two_punt_note2)=0;
						for(t=0;t<5;t++) two_key_ok[t]=0;break;
						}
			}
	if(m) two_fun_note_fallo();
	if(two_punt_note2) *(two_punt_note2)&=32767;
	test=0;
	for(n=0;n<5;n++)
			{
			 int key_flag=0;

			 key_master=0;
			 for(o=pp;o<2;o++)
				{
				flag=0;flag2=0;
				if(two_punt_note)
					pnote=two_punt_note+o;
				else pnote=0;

				if(pnote) 
				{
				flag=*(pnote);flag2=*(pnote+1);
				flag=(flag>>(n*3)) & 7;
				flag2=(flag2>>(n*3)) & 7;
				
				if(flag>=6)  flag=3;
				else if(flag==3 || flag==2) flag=2; 
				else  if(flag==5) flag=1;
				else flag=0;

				if(flag2>=6)  flag2=3;
				else if(flag2==3 || flag2==2) flag2=2; 
				else  if(flag2==5) flag2=1;
				else flag2=0;
				}
			    
				if(flag2>flag) {flag=flag2;pnote++;}
				if(flag>1) flag--;

				if(flag==0)
				{
				if(test==0) {test=1;continue;}
				}

				flag4=0;
				if(pnote) flag4=(*(pnote)>>(n*3)) & 7;

				if(flag==1 && flag4==5) {key_flag=1;continue;} // nota ya percutida

				if(two_key_note[n]==3)
					{
					if(!m && flag<2) if(o==0) {test=1;continue;}

					if(flag<2 || m) ;
					else {two_notes_ok++;key_master=1;two_key_ok[n]=8;two_fail_key&=~(1<<n);two_fallo=0;two_score+=calc_score2(15);two_fun_note_ok(); if(pnote) if(*pnote>32767) key_star=1;} 
					if(flag>=2)
					{
					if(pnote) *pnote=((*pnote) & (~(7<<(n*3))))| (5<<(n*3));
					flag=1;
					}
					}
				if(key_star)
					{if(pnote) *pnote &= 32767;key_star=0;
					if(key_master && two_star_counter>0)
						{
						two_star_counter--;if(two_star_counter==0) {two_score_star=5000;}
						}
					}
				}
			
			
			if(key_master || (key_master==0 && key_flag==1)) two_key_note[n]=1;
			}
			//////
			test=0;
			

			for(n=0;n<5;n++)
			{
			
			 for(o=pp;o<2;o++)
				{
				flag=0;flag2=0;
				if(two_punt_note)
					pnote=two_punt_note+o;
				else pnote=0;

				if(pnote) 
				{
				flag=*(pnote);flag2=*(pnote+1);
				flag=(flag>>(n*3)) & 7;
				flag2=(flag2>>(n*3)) & 7;
				
				if(flag>=6)  flag=3;
				else if(flag==3 || flag==2) flag=2; 
				else  if(flag==5) flag=1;
				else flag=0;

				if(flag2>=6)  flag2=3;
				else if(flag2==3 || flag2==2) flag2=2; 
				else  if(flag2==5) flag2=1;
				else flag2=0;
				}
			    
				if(flag2>flag) {flag=flag2;pnote++;}
				if(flag>1) flag--;

				if(flag==0)
				{
				if(test==0) {test=1;continue;}
				}

				flag4=0;
				if(pnote) flag4=((*(pnote))>>(n*3)) & 7;

				if(flag==1 && flag4==5) continue; // nota ya percutida

			
				if(two_key_note[n]==3)
					{
					if(m==0) two_fun_note_fallo();
					for(t=0;t<5;t++) {two_key_ok[t]=0;two_fail_key|=(1<<t);}two_key_note[n]=1;m=1;two_fallo=1;fallo_sound&=127; // fallo
					
					}
					else 
				if(two_key_note[n]==1 )
					{
					if(flag==1 || (flag!=0 &&  flag4==6)) 
						{if( flag4==6 &&  ((fail_out>>n) & 1)==0) {key2_point|=(1<<n);two_score+=calc_score2(15);two_fun_note_ok(); two_notes_ok++;two_key_ok[n]=8;two_fail_key&=~(1<<n);two_fallo=0;} 
					      if (two_key_ok[n]>0 && m==0) {two_key_ok[n]=8;two_score+=calc_score2(1);}  
						   else {for(t=0;t<5;t++) {two_key_ok[t]=0;two_fail_key|=(1<<t);}}
						  }
			
					if(flag!=0 &&  flag4==6)
					{
					if(pnote) *pnote=((*pnote) & (~(7<<(n*3))))| (5<<(n*3));

					flag=1;
					}
					}
			

				}
			}

			for(n=0;n<5;n++)
			{
			flag=0;
			if(two_key_ok[n]) {two_key_ok[n]--;flag=128;}
			if(flag)
				{
				if(two_key_note[n]==1) flag|=64;
				if(two_key_note[n]==3) flag|=64;
				}
			else if(two_key_note[n]==1) flag=64;
			two_disp_key[n]=flag;
			}
			
	}
}
////////////////////////////
// fin input two
////////////////////////////




itoZTest(FALSE);

// display

// notas en mastil (one)
for(m=0;m<5;m++)
{
unsigned short flag;

flag=disp_key[m];
 dib_note2(m+1+flag, fond_table-(pos_table[11]-i),1);

}
z_offset=40.0f;
Send_Vertex(TYPE_PLAYER1);

// notas en mastil (two)
if(twoplayers)
{
for(m=0;m<5;m++)
{
unsigned short flag;

flag=two_disp_key[m];
 dib_note2(m+1+flag, fond_table-(pos_table[11]-i),2);

}
z_offset=40.0f;

Send_Vertex(TYPE_PLAYER2);
}


itoPrimShade(ITO_PRIM_SHADE_FLAT);

itoZTest(FALSE);


if(nota_indx<50)
{

PX=320-64;PY=(screen_height-192)>>1;tamletra=7;
if((nota_indx/10)>cuenta_atras ) {cuenta_atras=nota_indx/10;voices|=4;}
switch(nota_indx/10)
	{
	case 0:color=0xffffffff;s_printf("5");break;
	case 1:color=0xff00ffff;s_printf("4");break;
	case 2:color=0xff00ff00;s_printf("3");break;
	case 3:color=0xff008fff;s_printf("2");break;
	case 4:color=0xff0000ff;s_printf("1");if(ovacion<=0  && abucheo<=0) ovacion=ACTIVE_SOUND;break;
	}
tamletra=2;


}

// cartel guitar fun

SetTexture(TEXT_IND3);
n=-16;
itoPrimAlphaBlending(TRUE);

// cartel guitarfun
itoTextureSprite(0xff808080, 320-96, n, 0,0, 320+96, n+96, 128,64, 0);
itoGsFinish();

if(twoplayers )
{
color=0xff0ffff;
PX=320+40;PY=n+60;
tamletra=3;itoBlend(0);
if(modeplayers) {PX-=64;s_printf("Cooperative");} else s_printf("Battle");
itoBlend(1);
}
tamletra=2;

if(nota_indx<50)
{
tamletra=2;

if(!twoplayers)
	{
	color=0xfff0f0f0;	
	PX=0;PY=64; s_printf(" %s",list_songs[tema].title);
	color=0xff00f0f0;
	PX=0;PY=84;s_printf(" %s",list_songs[tema].artist);
	}

PX=128+16;PY=screen_height-48;
color=0xff00ffff;

if(bajo_off)
	{
	PX=320-16*5;
	if(midi_ritmo) s_printf("Guitar Off"); else s_printf("Rhythm Off");
	}
else
	{
	

	if(input_mode==0 )
		{
		PX=320-16*6-8;s_printf("Input1: Guitar1");
		}
	else
		if(input_mode==1)
		{
		PX=320-16*8-8;s_printf("Input1: Pad 1");
		}
	else
		if(input_mode==2)
		{
		PX=320-16*7-8;s_printf("Input1: Keyboard");
		}
	else
		if(input_mode==3)
		{
		PX=320-16*7;s_printf("Input1: Guitar2");
		}
	else
		if(input_mode==4)
		{
		PX=320-16*7;s_printf("Input1: Pad 2");
		}
	color=0xff00ff3f;
	PY=screen_height-24;
	
	if(twoplayers)
		{
	if(input_mode2==0)
		{
		PX=320-16*6-8;s_printf("Input2: Guitar2");
		}
	else
		if(input_mode2==1)
		{
		PX=320-16*8-8;s_printf("Input2: Pad 2");
		}
	else
		if(input_mode2==2)
		{
		PX=320-16*8-8;s_printf("Input2: Keyboard");
		}
	else
		if(input_mode2==3)
		{
		PX=320-16*7;s_printf("Input2: Guitar1");
		}
	else
		if(input_mode2==4)
		{
		PX=320-16*7;s_printf("Input2: Pad 1");
		}
		}
	}
// 0->guitar, 1->pad, 2->keyboard

}

itoPrimAlphaBlending(FALSE);
n=screen_height-132;
SetTexture(TEXT_IND1);

if(twoplayers)
	{
	n=0;
	}

	
itoTextureSprite(0xff808080, 0, n, 0,0, 128, n+104, 128,64, 0);
itoGsFinish();

itoPrimAlphaBlending(TRUE);

if(score_star) {score+=25;score_star-=25;if(flash & 1) voices|=16;/*modo_estrella=0;*/}/* else modo_estrella=0;*/
disp_number(20,n+16-4,score>>1);

for(m=0;m<10;m++)
	{
	color=0xff606060;
	if(m<aciertos) color=index_color[m];
	itoSprite(color ,14+m*10,n+64-4,14+m*10+5,n+64+6-4,0);

	}
PX=40;PY=n+80-8;tamletra=1;


color=0xff101030;
if(multiplica==2) color=0xffff0000;
if(multiplica==3) color=0xffb000b0;
if(multiplica==4) color=0xff0000ff;

s_printf("x%i",multiplica);
tamletra=2;
itoPrimAlphaBlending(FALSE);
if(score_star) 
	{
	color=0xff00ffff;
	PX=640-128+16;PY=n-32;
	if(twoplayers) {PY=216;PX=16;}
	display_star(PX,PY,color);PX+=32;
	s_printf("%i",score_star);
	}


SetTexture(TEXT_IND2);
if(twoplayers) itoTextureSprite(0xff808080, 0, 104, 0,0, 128, 104+104, 128,64, 0);
else itoTextureSprite(0xff808080, 640-128, n, 0,0, 640, n+104, 128,64, 0);
itoGsFinish();

{
int x1,y1,x2,y2;
float ang;
x2=640-64;
y2=n+72;

if(twoplayers) {x2=64;y2=104+72;}

ang=3.1416f*((float) (64+(128-rockometro)))/256.0f;
x1=(int)(72.0f*coseno(ang));y1=-(int)(64.0f*seno(ang));
x1+=x2;
y1+=y2;

itoTriangle(0xffff0000,x1,y1,0, 0xffff0000,x2-6,y2,0, 0xffff0000,x2+6,y2,0);
itoTriangle(0xff8f0000,x1,y1,0, 0xff8f0000,x2-4,y2,0, 0xff8f0000,x2+4,y2,0);
itoGsFinish();
}

// player 2 indicators
if(twoplayers)
{
itoPrimAlphaBlending(FALSE);

n=0;
SetTexture(TEXT_IND1);
	
itoTextureSprite(0xff808080, 640-128, n, 0,0, 640, n+104, 128,64, 0);
itoGsFinish();

itoPrimAlphaBlending(TRUE);

if(two_score_star) {two_score+=25;two_score_star-=25;if(flash & 1) voices|=16;/*modo_estrella=0;*/}/* else modo_estrella=0;*/

disp_number(640-128+20,n+16-4,two_score>>1);

for(m=0;m<10;m++)
	{
	color=0xff606060;
	if(m<two_aciertos) color=index_color[m];
	itoSprite(color ,640-128+14+m*10,n+64-4,640-128+14+m*10+5,n+64+6-4,0);

	}
PX=640-128+40;PY=n+80-8;tamletra=1;


color=0xff000000;
if(two_multiplica==2) color=0xffff0000;
if(two_multiplica==3) color=0xffb000b0;
if(two_multiplica==4) color=0xff0000ff;

s_printf("x%i",two_multiplica);
tamletra=2;
itoPrimAlphaBlending(FALSE);
if(two_score_star) 
	{
	color=0xff00ffff;
	PX=640-128+16;PY=216;

	display_star(PX,PY,color);PX+=32;
	s_printf("%i",two_score_star);
	}

n=104;
SetTexture(TEXT_IND2);
itoTextureSprite(0xff808080, 640-128, n, 0,0, 640, n+104, 128,64, 0);
itoGsFinish();

{
int x1,y1,x2,y2;
float ang;
x2=640-64;
y2=n+72;

ang=3.1416f*((float) (64+(128-two_rockometro)))/256.0f;
x1=(int)(72.0f*coseno(ang));y1=-(int)(64.0f*seno(ang));
x1+=x2;
y1+=y2;

itoTriangle(0xffff0000,x1,y1,0, 0xffff0000,x2-6,y2,0, 0xffff0000,x2+6,y2,0);
itoTriangle(0xff8f0000,x1,y1,0, 0xff8f0000,x2-4,y2,0, 0xff8f0000,x2+4,y2,0);
itoGsFinish();
}

} // end of player 2 indicators

if(paused)
	{
	
	tamletra=2;
	if(men_pause==0) color=0xff00f000; else color=0xfff0f0f0;	
	PX=320-7*16;PY=screen_height/2-24; s_printf("Return to Game");
	if(men_pause==1) color=0xff00f000; else color=0xfff0f0f0;	
	PX=320-11*16;PY=screen_height/2+24;s_printf("Exit to Song Selection");
	}



}


void procesa_notas()
{
int n,m,k;
unsigned short flag;
unsigned char notes[5];

unsigned char old_notes[5];
int conta_star;
int flag_star;
int cuenta_notas;
int flag_n;

flag=0;
conta_star=200;
flag_star=0;

cuenta_notas=0;
flag_n=0;

star_table[0][0]=-1;
star_table[1][0]=-1;

star_pos=0;
star_counter=0;

old_notes[0]=0;
old_notes[1]=0;
old_notes[2]=0;
old_notes[3]=0;
old_notes[4]=0;

for(n=0;n<last_midi_note;n++) 
	{
	flag=nota[n];

	notes[0]=(flag>>(0*3)) & 7;
	notes[1]=(flag>>(1*3)) & 7;
	notes[2]=(flag>>(2*3)) & 7;
	notes[3]=(flag>>(3*3)) & 7;
	notes[4]=(flag>>(4*3)) & 7;

	if(flag_tresnotas) // tres notas solo
	{
	if(notes[3])
		{
		if(notes[3]>notes[2]) notes[2]=notes[3];
		notes[3]=0;
		}
	if(notes[4])
		{
		if(notes[4]>notes[1]) notes[1]=notes[4];
		notes[4]=0;
		}
	}
	
	 if(old_notes[0]!=0)
		{
	    if(notes[1]>=6 && old_notes[1]==0) {notes[1]=6;old_notes[1]=1;}

		if(notes[2]>=6 && old_notes[2]==0) {notes[2]=6;old_notes[2]=1;}
		if(notes[3]>=6 && old_notes[3]==0) {notes[3]=6;old_notes[3]=1;}
		if(notes[4]>=6 && old_notes[4]==0) {notes[4]=6;old_notes[4]=1;}
		
		}

	 if(old_notes[1]!=0)
		{
		if(notes[0]>=6 && old_notes[0]==0) {notes[0]=6;old_notes[0]=1;}
		if(notes[2]>=6 && old_notes[2]==0) {notes[2]=6;old_notes[2]=1;}

		if(notes[3]>=6 && old_notes[3]==0) {notes[3]=6;old_notes[3]=1;}
		if(notes[4]>=6 && old_notes[4]==0) {notes[4]=6;old_notes[4]=1;}
		}
	 if(old_notes[2]!=0)
		{
		if(notes[1]>=6 && old_notes[1]==0) {notes[1]=6;old_notes[1]=1;}
		if(notes[3]>=6 && old_notes[3]==0) {notes[3]=6;old_notes[3]=1;}

		if(notes[0]>=6 && old_notes[0]==0) {notes[0]=6;old_notes[0]=1;}
		if(notes[4]>=6 && old_notes[4]==0) {notes[4]=6;old_notes[4]=1;}
		}
	 if(old_notes[3]!=0)
		{
		if(notes[2]>=6 && old_notes[2]==0) {notes[2]=6;old_notes[2]=1;}
		if(notes[4]>=6 && old_notes[4]==0) {notes[4]=6;old_notes[4]=1;}

		if(notes[0]>=6 && old_notes[0]==0) {notes[0]=6;old_notes[0]=1;}
		if(notes[1]>=6 && old_notes[1]==0) {notes[1]=6;old_notes[1]=1;}
		}
	 if(old_notes[4]!=0)
		{
		if(notes[3]>=6 && old_notes[3]==0) {notes[3]=6;old_notes[3]=1;}

		if(notes[0]>=6 && old_notes[0]==0) {notes[0]=6;old_notes[0]=1;}
		if(notes[1]>=6 && old_notes[1]==0) {notes[1]=6;old_notes[1]=1;}
		if(notes[2]>=6 && old_notes[2]==0) {notes[2]=6;old_notes[2]=1;}
		}

    flag_n=0;
   if(notes[0]<6) old_notes[0]=0;
   else
	{
	  flag_n=1;
	if(old_notes[0]==0) old_notes[0]++; else {if(notes[0]==7) {/*notes[0]=0;*/old_notes[0]=0;}
											
											 } 
	}
   
   if(notes[1]<6) old_notes[1]=0;
   else
	{
	  flag_n=1;
	if(old_notes[1]==0) old_notes[1]++; else {if(notes[1]==7) {/*notes[1]=0;*/old_notes[1]=0;}
											 
											 } 
	}
	
   if(notes[2]<6) old_notes[2]=0;
   else
	{
	  flag_n=1;
	if(old_notes[2]==0) old_notes[2]++; else {if(notes[2]==7) {/*notes[2]=0;*/old_notes[2]=0;}
											 
											 }
	}

	if(notes[3]<6) old_notes[3]=0;
   else
	{
	   flag_n=1;
	if(old_notes[3]==0) old_notes[3]++; else {if(notes[3]==7) {/*notes[3]=0;*/old_notes[3]=0;}
											 
											 }
	}

	if(notes[4]<6) old_notes[4]=0;
   else
	{
	   flag_n=1;
	if(old_notes[4]==0) old_notes[4]++; else {if(notes[4]==7) {/*notes[4]=0;*/old_notes[4]=0;}
											 
											 }
	}

 if(flag_n) cuenta_notas++;

 if(cuenta_notas<10) conta_star=0;
 if(cuenta_notas==10) conta_star=280;
// mira si es acorde y rectifica  la nota si son dispares
k=0;
for(m=0;m<5;m++) {if(notes[m]==7) {k=1;break;}}
if(k)
	for(m=0;m<5;m++) {if(notes[m]==6) {notes[m]=7;}}
  

	flag=(notes[0]<<(0*3)) | (notes[1]<<(1*3)) | (notes[2]<<(2*3)) | (notes[3]<<(3*3)) | (notes[4]<<(4*3)) ;

	nota[n]=flag;


	conta_star++;
	if(flag_star)
	{
	if(notes[0]>=7 ||  notes[1]>=7 ||  notes[2]>=7 ||  notes[3]>=7 ||  notes[4]>=7)
			{
		    star_table[star_pos][star_counter]=n;
			star_counter++;
				star_table[star_pos][star_counter]=-1;
			flag_star--;if(flag_star==0) {star_pos++;star_counter=0;star_table[star_pos][star_counter]=-1;}
			nota[n]|=32768;

			}
	}
	else
	if(conta_star>=300 && n<(last_midi_note-200))
		{
		if((notes[0]>=7 ||  notes[1]>=7 ||  notes[2]>=7 ||  notes[3]>=7 ||  notes[4]>=7) && star_pos<256)
			{
			star_counter=0;
		    star_table[star_pos][star_counter]=n;
			star_table[star_pos+1][0]=-1;
			star_counter++;
			star_table[star_pos][star_counter]=-1;
			conta_star=0;flag_star=3+(rand() & 3);
			nota[n]|=32768;
			}
		}
    }
star_pos=0;star_counter=0;


// two_

flag=0;
conta_star=200;
flag_star=0;

cuenta_notas=0;
flag_n=0;

two_star_table[0][0]=-1;
two_star_table[1][0]=-1;

two_star_pos=0;
two_star_counter=0;

old_notes[0]=0;
old_notes[1]=0;
old_notes[2]=0;
old_notes[3]=0;
old_notes[4]=0;

for(n=0;n<last_midi_note;n++) 
	{
	flag=two_nota[n];

	notes[0]=(flag>>(0*3)) & 7;
	notes[1]=(flag>>(1*3)) & 7;
	notes[2]=(flag>>(2*3)) & 7;
	notes[3]=(flag>>(3*3)) & 7;
	notes[4]=(flag>>(4*3)) & 7;

	if(flag_tresnotas) // tres notas solo
	{
	if(notes[3])
		{
		if(notes[3]>notes[2]) notes[2]=notes[3];
		notes[3]=0;
		}
	if(notes[4])
		{
		if(notes[4]>notes[1]) notes[1]=notes[4];
		notes[4]=0;
		}
	}
	
	 if(old_notes[0]!=0)
		{
	    if(notes[1]>=6 && old_notes[1]==0) {notes[1]=6;old_notes[1]=1;}

		if(notes[2]>=6 && old_notes[2]==0) {notes[2]=6;old_notes[2]=1;}
		if(notes[3]>=6 && old_notes[3]==0) {notes[3]=6;old_notes[3]=1;}
		if(notes[4]>=6 && old_notes[4]==0) {notes[4]=6;old_notes[4]=1;}
		
		}

	 if(old_notes[1]!=0)
		{
		if(notes[0]>=6 && old_notes[0]==0) {notes[0]=6;old_notes[0]=1;}
		if(notes[2]>=6 && old_notes[2]==0) {notes[2]=6;old_notes[2]=1;}

		if(notes[3]>=6 && old_notes[3]==0) {notes[3]=6;old_notes[3]=1;}
		if(notes[4]>=6 && old_notes[4]==0) {notes[4]=6;old_notes[4]=1;}
		}
	 if(old_notes[2]!=0)
		{
		if(notes[1]>=6 && old_notes[1]==0) {notes[1]=6;old_notes[1]=1;}
		if(notes[3]>=6 && old_notes[3]==0) {notes[3]=6;old_notes[3]=1;}

		if(notes[0]>=6 && old_notes[0]==0) {notes[0]=6;old_notes[0]=1;}
		if(notes[4]>=6 && old_notes[4]==0) {notes[4]=6;old_notes[4]=1;}
		}
	 if(old_notes[3]!=0)
		{
		if(notes[2]>=6 && old_notes[2]==0) {notes[2]=6;old_notes[2]=1;}
		if(notes[4]>=6 && old_notes[4]==0) {notes[4]=6;old_notes[4]=1;}

		if(notes[0]>=6 && old_notes[0]==0) {notes[0]=6;old_notes[0]=1;}
		if(notes[1]>=6 && old_notes[1]==0) {notes[1]=6;old_notes[1]=1;}
		}
	 if(old_notes[4]!=0)
		{
		if(notes[3]>=6 && old_notes[3]==0) {notes[3]=6;old_notes[3]=1;}

		if(notes[0]>=6 && old_notes[0]==0) {notes[0]=6;old_notes[0]=1;}
		if(notes[1]>=6 && old_notes[1]==0) {notes[1]=6;old_notes[1]=1;}
		if(notes[2]>=6 && old_notes[2]==0) {notes[2]=6;old_notes[2]=1;}
		}

    flag_n=0;
   if(notes[0]<6) old_notes[0]=0;
   else
	{
	  flag_n=1;
	if(old_notes[0]==0) old_notes[0]++; else {if(notes[0]==7) {/*notes[0]=0;*/old_notes[0]=0;}
											
											 } 
	}
   
   if(notes[1]<6) old_notes[1]=0;
   else
	{
	  flag_n=1;
	if(old_notes[1]==0) old_notes[1]++; else {if(notes[1]==7) {/*notes[1]=0;*/old_notes[1]=0;}
											 
											 } 
	}
	
   if(notes[2]<6) old_notes[2]=0;
   else
	{
	  flag_n=1;
	if(old_notes[2]==0) old_notes[2]++; else {if(notes[2]==7) {/*notes[2]=0;*/old_notes[2]=0;}
											 
											 }
	}

	if(notes[3]<6) old_notes[3]=0;
   else
	{
	   flag_n=1;
	if(old_notes[3]==0) old_notes[3]++; else {if(notes[3]==7) {/*notes[3]=0;*/old_notes[3]=0;}
											 
											 }
	}

	if(notes[4]<6) old_notes[4]=0;
   else
	{
	   flag_n=1;
	if(old_notes[4]==0) old_notes[4]++; else {if(notes[4]==7) {/*notes[4]=0;*/old_notes[4]=0;}
											 
											 }
	}

 if(flag_n) cuenta_notas++;

 if(cuenta_notas<10) conta_star=0;
 if(cuenta_notas==10) conta_star=280;
 
// mira si es acorde y rectifica  la nota si son dispares

k=0;
for(m=0;m<5;m++) {if(notes[m]==7) {k=1;break;}}
if(k)
	for(m=0;m<5;m++) {if(notes[m]==6) {notes[m]=7;}}
  

	flag=(notes[0]<<(0*3)) | (notes[1]<<(1*3)) | (notes[2]<<(2*3)) | (notes[3]<<(3*3)) | (notes[4]<<(4*3)) ;

	two_nota[n]=flag;


	conta_star++;
	if(flag_star)
	{
	if(notes[0]>=7 ||  notes[1]>=7 ||  notes[2]>=7 ||  notes[3]>=7 ||  notes[4]>=7)
			{
		    two_star_table[two_star_pos][two_star_counter]=n;
			two_star_counter++;
			two_star_table[two_star_pos][two_star_counter]=-1;
			flag_star--;if(flag_star==0) {two_star_pos++;two_star_counter=0;two_star_table[two_star_pos][two_star_counter]=-1;}
			two_nota[n]|=32768;

			}
	}
	else
	if(conta_star>=300 && n<(last_midi_note-200))
		{
		if((notes[0]>=7 ||  notes[1]>=7 ||  notes[2]>=7 ||  notes[3]>=7 ||  notes[4]>=7) && two_star_pos<256)
			{
			two_star_counter=0;
		    two_star_table[two_star_pos][two_star_counter]=n;
			two_star_table[two_star_pos+1][0]=-1;
			two_star_counter++;
			two_star_table[two_star_pos][two_star_counter]=-1;
			conta_star=0;flag_star=3+(rand() & 3);
			two_nota[n]|=32768;
			}
		}
    }
two_star_pos=0;two_star_counter=0;
}

static int oldtime=-1;
int ticks=0;

int f_thread1=1; // flag de salida del hilo ogg

static volatile int graph_thd_mode=0; // funcion grafica


#define GRAPH_PAUSED 0
#define GRAPH_INGAME 1

unsigned mytimer(unsigned int time)
{
if(thread_wakeup)
	{
	thread_wakeup=0;
	
	#ifndef GEKKO
    #ifdef IS_WIN32
    {long out; ReleaseSemaphore(sema_main,1,&out);}
    #else
    pthread_cond_signal(&cond_thread_main);   // activa hilo de graficos
    #endif 
    #else // GEKKO
    LWP_ThreadSignal(alarm_queue);
    #endif
	return MS_TICK;
	}

if(control_thread_main & 1) 
 {
 key_flash++;
 
 if(graph_thd_mode==GRAPH_INGAME)
 if(!paused)
	{
	flash++;
	if(ticks<sound_timer_add)
		{
          ticks+=MS_TICK; // 20 milisegundos //1000/50;
	    if(ticks>=sound_timer_add) ticks=sound_timer_add-MS_TICK;
		}
	}
#ifndef GEKKO
#ifdef IS_WIN32
{long out; ReleaseSemaphore(sema_main,1,&out);}
#else
 pthread_cond_signal(&cond_thread_main);   // activa hilo de graficos
#endif 
#else // GEKKO
LWP_ThreadSignal(alarm_queue);
#endif
}
if(control_thread_main & 2)  {return MS_TICK;} // caso especial 1: desincronizacion grafica  


return MS_TICK;
}



void SetGraphThd(int mode)
{
graph_thd_mode=mode;
}




void ingame_graph()
{
 int WAV_AMOUNT;  

   
 WAV_AMOUNT=sound_timer;    
 if(WAV_AMOUNT/sound_timer_add!=oldtime) 
			{
			oldtime=WAV_AMOUNT/sound_timer_add;
			
			ticks=((WAV_AMOUNT % sound_timer_add)/MS_TICK)*MS_TICK;
	
			}

 WAV_AMOUNT=(WAV_AMOUNT/sound_timer_add)*sound_timer_add+ticks;
 
 WAV_AMOUNT=((((44100LL*((long long) mid_speed)/4LL)*(long long)(WAV_AMOUNT)/1000LL))>>10)<<10;

 nota_indx=(WAV_AMOUNT/TIME_STEP);
 nota_step=(Y_STEP1*(WAV_AMOUNT % TIME_STEP))/(TIME_STEP);
 

 if(MODEVIDEO & 1)
  {
  
  itoViewport(0, 0, 720, 480);
  itoClear(border2);
  itoViewport(40, 0, 640, 480);
  }
else 
{  
  itoViewport(0, 0, 640, 480);
  itoClear(border2);
} 

 
 
 main_playing();
 itoGsFinish();
 itoSwitchFrameBuffers();
				
}

int is_activewindow=0;

#ifndef GEKKO
int event_filt(const SDL_Event *event)
{
    
if(event->active.type==SDL_ACTIVEEVENT && event->active.state==SDL_APPMOUSEFOCUS) 
{                               
is_activewindow=event->active.gain;
}
return 1;
}
#endif


void display_fondo1()
{
int n;

border=0xff000000;

itoZTest(FALSE);
itoPrimShade(ITO_PRIM_SHADE_GOURAUD);

 

SetTexture(TEXT_PRI);
itoPrimAlphaBlending(FALSE);
if(background)
itoTextureSpritef(color_filter(0xff808080), 0, 0, 0.0f,0.0f, 640, screen_height, 1.0f,1.0f, 0);
else itoTextureSpritef(color_filter(BACK_COLOR), 0, 0, 0.0f,0.0f, 640, screen_height, 1.0f,1.0f, 0);
itoGsFinish();

itoPrimAlphaBlending(TRUE);

SetTexture(TEXT_PRI+2);
n=(screen_height/2)-190;

itoTextureSprite(color_filter(0xff808080), 320-96, n, 0,0, 320+96, n+96, 128,64, 0);
itoGsFinish();





nvert2=0;
dib_aro1(320.0f,(float) (screen_height/2),100.0f,20.0f,color_filter(0xff0000a0));

DrawTriangleStrip(&vert2[0],nvert2);
itoGsFinish();

nvert2=0;

n=(screen_height-128*1)>>1;

#ifdef GEKKO
	SetTexture(TEXT_WII);
	itoTextureSprite(0xff808080, 320-64, n+32, 0,0, 320+64, n+96, 128,64, 0);
	itoGsFinish();
#endif
SetTexture(TEXT_PRI+1);
itoTextureSprite(0xff606060, 320-64, n, 0,0, 320+64, n+128,128,128, 0);
itoGsFinish();
 
itoPrimAlphaBlending(FALSE);
}


void intro_screen()
{
int n,m;

unsigned color2;

border=0xff000000;


//return;
m=0;
while(1)
	{

	itoZTest(FALSE);
	itoPrimShade(ITO_PRIM_SHADE_GOURAUD);
    ClearScreen(0xff000000);
	itoZTest(FALSE);

	if(m<60)
	{
	

	n=(screen_height>>1)-64;
	color2=((0xff*m/60)<<24);

	SetTexture(TEXT_PRI);
    itoPrimAlphaBlending(FALSE);
    if(background)
    itoTextureSpritef(color_filter(color2 | 0x808080), 0, 0, 0.0f,0.0f, 640, screen_height, 1.0f,1.0f, 0);
    else itoTextureSpritef(color_filter(color2 | (BACK_COLOR & 0xffffff)), 0, 0, 0.0f,0.0f, 640, screen_height, 1.0f,1.0f, 0);
	itoGsFinish();


	SetTexture(TEXT_PRI+3);
	itoPrimAlphaBlending(TRUE);

	itoTextureSprite(color_filter(color2 | 0x808080), 0, n, 0,0, 640, n+128, 128,32, 0);
	itoGsFinish();

	


	if(m==30) PlayVoice(5,8000,0,1000,0x7fff*effects_volume/100,0x7fff*effects_volume/100, 0);
	}
	else
		if(m<120)
		{
        if(background) color2=color_filter(0xff808080); else  color2=color_filter(BACK_COLOR);
        SetTexture(TEXT_PRI);
		itoPrimAlphaBlending(FALSE);
		itoTextureSpritef(color2, 0, 0, 0.0f,0.0f, 640, screen_height, 1.0f,1.0f, 0);
		itoGsFinish();

		color2=0xff808080;

		PX=320-(strlen(STRING_VER)*16)/2;PY=(screen_height>>1)-100;
		PY&=~1;
		tamletra=2;
		color=(0xe0*(m-60)/60);
		color+=0x10;
		if(color>0xff) color=0xff;
        color=(color<<24) |  0xf0f0f0;
		//bkcolor=0;//(((0x40*(m-60)/60) )<<24) | 0xf00000;
		bkcolor=(0xe0*(m-60)/60);
		bkcolor+=0x10;
		if(bkcolor>0xff) bkcolor=0xff;
        bkcolor=(bkcolor<<24) |  0xf00000;
		
		s_printf(STRING_VER);
		PX=320-8*16;PY=(screen_height>>1)-100+32;PY&=~1;
		s_printf("(c) 2008, Hermes");
		PX=320-8*16-8;PY=(screen_height>>1)-100+64;PY&=~1;
		s_printf("(c) 2008, Dimitri");
		color2=color_filter(0xff808080);

		SetTexture(TEXT_PRI+3);
		itoPrimAlphaBlending(TRUE);
		n=(screen_height>>1)-64+(m-60)*2;
		itoTextureSprite(color2, 0, n, 0,0, 640, n+128, 128,32, 0);
		itoGsFinish();
		if(m==90) PlayVoice(5,8000,0,1000,0x7fff*effects_volume/100,0x7fff*effects_volume/100, 0);
		}
		else if(m<180)
		{

        if(background) color2=color_filter(0xff808080); else  color2=color_filter(BACK_COLOR);
	
        SetTexture(TEXT_PRI);
		itoPrimAlphaBlending(FALSE);
		itoTextureSpritef(color2, 0, 0, 0.0f,0.0f, 640, screen_height, 1.0f,1.0f, 0);
		itoGsFinish();

		
		color2=((0xe0*(m-120)/60));
		color2+=0x10;
		if(color2>0xff) color2=0xff;
        color2=(color2<<24);// |  0xf0f0f0;
		itoPrimAlphaBlending(TRUE);
		SetTexture(TEXT_PRI+2);
		n=(screen_height/2)-190;

		itoTextureSprite(color_filter(color2+0x808080), 320-96, n, 0,0, 320+96, n+96, 128,64, 0);
		itoGsFinish();
		


		
		
		nvert2=0;
		dib_aro1(320.0f,(float) (screen_height/2),100.0f,20.0f,color_filter(color2+0xa0));

		DrawTriangleStrip(&vert2[0],nvert2);
		itoGsFinish();


		nvert2=0;

		n=(screen_height-128*1)>>1;

        #ifdef GEKKO
		SetTexture(TEXT_WII);
	    itoTextureSprite(color_filter(color2+0x808080), 320-64, n+32, 0,0, 320+64, n+96, 128,64, 0);
	    itoGsFinish();
		#endif
        SetTexture(TEXT_PRI+1);
		itoTextureSprite(color_filter(color2+0x808080), 320-64, n, 0,0, 320+64, n+128,128,128, 0);
		
		itoGsFinish();

		


	// texto

		PX=320-(strlen(STRING_VER)*16)/2;PY=(screen_height>>1)-100+(m-120)*4;

		tamletra=2;
		color=0xfff0f0f0;
		bkcolor=0xfff00000;

		s_printf(STRING_VER);
		PX=320-8*16;PY=(screen_height>>1)-100+32+(m-120)*4;
		s_printf("(c) 2008, Hermes");
		PX=320-8*16-8;PY=(screen_height>>1)-100+64+(m-120)*4;
		s_printf("(c) 2008, Dimitri");
		color2=0xff808080;

		color2=((0xff*(180-m)/60)<<24) | 0x808080;
	
		SetTexture(TEXT_PRI+3);
		itoPrimAlphaBlending(TRUE);
		n=(screen_height>>1)-64+(60)*2;
		itoTextureSprite(color_filter(color2), 0, n, 0,0, 640, n+128, 128,32, 0);
		itoGsFinish();

		if(m==150) PlayVoice(5,8000,0,1000,0x7fff*effects_volume/100,0x7fff*effects_volume/100, 0);
		if(m==175) PlayVoice(6,22050,0,1000,0x7fff*effects_volume/100,0x7fff*effects_volume/100, 1);

		}
		else
		{
		if(m==200) PlayVoice(6,22050,0,1000,0x7fff*effects_volume/100,0x7fff*effects_volume/100, 1);
		if(m==225) PlayVoice(6,22050,0,1000,0x7fff*effects_volume/100,0x7fff*effects_volume/100, 1);
		if(m==280) break;
		}

	m++;
	
	

	 
    SDL_Delay(20);
	if(m<=180) {
                itoSwitchFrameBuffers();} 
                
                
              
	}
bkcolor=0;tamletra=2;PX=PY=0;color=0xffffffff;
}

#ifdef GEKKO
void *mod_file=NULL;

void Load_MOD()
{
int mfd,m;
char name2[256];

sprintf(name2,"%s%s",main_dir,"music.mod");
mfd=open(name2, O_RDWR | O_BINARY, S_IREAD);
if ( mfd < 0 ){
             
        }
 m= lseek(mfd,0,2);     
 if(m<128) {close(mfd);return;} 

 mod_file=malloc(m);
 if(!mod_file) {close(mfd);return;} 

 lseek(mfd,0,0);
 
 read(mfd,mod_file,m);

 close(mfd);

}
#endif

void * thread_ogg(void *zero);

int level_init=0;

void fun_exit()
{
if(background)  free(background);background=NULL;
if(ext_mastil)  free(ext_mastil);ext_mastil=NULL;
   
ResetVoice(); // free memory of cached voices

#ifndef GEKKO

if(level_init>=8)  SDL_SetTimer(0,NULL);
if(level_init>=2) itoExit();
if(icon) SDL_FreeSurface(icon); icon=NULL;
f_thread1=0;
SDL_state=0;
 #ifdef IS_WIN32
 
 if(sema_thread1) {long out; ReleaseSemaphore(sema_thread1,1,&out);}


 if(h_thread1) 
 {
 WaitForSingleObject(h_thread1,INFINITE);         
 CloseHandle(h_thread1);
 }
 if(sema_thread1) CloseHandle(sema_thread1);
 if(sema_main) CloseHandle(sema_main);
 if(sema_SDL) CloseHandle(sema_SDL);
 #else

if(level_init>=7)
{  
 pthread_cond_signal(&cond_thread1); 
 pthread_join(thread1, NULL);
}


if(level_init>=3) 
 pthread_mutex_destroy(&mutex_thread1);
if(level_init>=4) 
 pthread_cond_destroy(&cond_thread1);
if(level_init>=5) 
 pthread_mutex_destroy(&mutex_thread_main);
if(level_init>=6) 
 pthread_cond_destroy(&cond_thread_main);
 #endif 
 
if(n_sticks>0 && joy1) SDL_JoystickClose(joy1);
if(n_sticks>1 && joy2) SDL_JoystickClose(joy2);
if(level_init>=1) SDL_Quit(); 
    
freememsenocoseno();   

printf("End Of Program\n");
#else // GEKKO
f_thread1=0;
SDL_state=0;
if(level_init==8)
	{
	ReleaseAlarm();
	LWP_ThreadSignal(oggplayer_queue);
	Delay(100);
	LWP_ThreadSignal(oggplayer_queue);
    LWP_JoinThread(h_oggplayer,NULL);
	}
    WPAD_Shutdown();
	SND_End();
	if(keyboard_kb>=0)
	{
	IOS_Close(keyboard_kb);keyboard_kb=-1;
	}

	Delay(1000);
#endif // GEKKO
}

int main_select_list();
void score_screen();
void menu_principal();
void Loading_screen();
void PCMSilence();

int realtime=1;

#ifndef GEKKO
SDL_Surface *surface;
#endif

void InitVideomode()
{
static int initv=0;

int w,h,full; 

#ifndef GEKKO
unsigned flag=0;
int c;
#ifndef D3D
flag=SDL_OPENGL;
#endif
#endif
if(initv)
{
itoExit();
#ifndef GEKKO
if(icon) SDL_FreeSurface(icon); icon=NULL;
SDL_QuitSubSystem(SDL_INIT_VIDEO);
SDL_InitSubSystem(SDL_INIT_VIDEO);
#endif
}
#ifndef GEKKO
icon=SDL_CreateRGBSurfaceFrom((void *) bitmaps_sprite_17 ,
			32, 32, 16, 64,
			5, 5<<5, 5<<10, 0<<15);

SDL_WM_SetIcon(icon,0);
SDL_WM_SetCaption( "Guitarfun PC","Guitarfun PC" );


again:
#endif     

if(MODEVIDEO>3) MODEVIDEO=0;

#ifndef GEKKO
if(MODEVIDEO==0)
 {full=0;w=640;h=480;}
if(MODEVIDEO==1)
 {full=0;w=720;h=480;}
if(MODEVIDEO==2)
 {full=1;w=640;h=480;}
if(MODEVIDEO==3)
 {full=1;w=720;h=480;}

 
SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );  
  if(full)
  {
  surface= SDL_SetVideoMode(w, h, 32, flag | SDL_HWSURFACE | SDL_NOFRAME | SDL_FULLSCREEN );
  if(!surface)
  {
  surface= SDL_SetVideoMode(w, h, 16, flag | SDL_HWSURFACE | SDL_NOFRAME | SDL_FULLSCREEN );
  }

  if(!surface) 
    {
    MODEVIDEO++;goto again;
    }
  }
  else
  {
  surface= SDL_SetVideoMode(w, h, 0, flag | SDL_HWSURFACE );
  if(!surface) {printf("SetVideoMode failed!\n");exit(1);}
  }
 SDL_ShowCursor(0);
 
 
 #ifdef IS_WIN32
SDL_VERSION(&info_sdl.version);
if ( SDL_GetWMInfo(&info_sdl) )
{
}
#endif

#else // GEKKO
MODEVIDEO=0;
full=0;w=640;h=480;
#endif

 itoInit();
 itoGamma(gl_gamma);
 

if(MODEVIDEO & 1)
  itoViewport(0, 0, 720, 480);
else 
  itoViewport(0, 0, 640, 480);

  itoClear(0xff000000);
 
  
  initv=1;
}


int main(int argc, char *argv[])
{
int n;

#ifndef GEKKO         
int m;
// get the global directory

global_dir[0]=0;
n=m=0;
if(argc>0)
{
char *p=argv[0];
while(*p!=0)
{
if(*p=='/' || *p=='\\') m=n;
global_dir[n]=*p;
p++;n++;
}

if(m==0)
m--;
else
global_dir[m]=barra;
global_dir[m+1]=0;
memcpy(main_dir,global_dir,FILENAME_MAX);
memcpy(&global_dir[m+1],"songs",5);
global_dir[m+6]=barra;
global_dir[m+7]=0;

//printf("glob: %s\n",global_dir);
//return 0;
}
else
{
printf("Error!!: Invalid args\n");
return 1;
}

MODEVIDEO=0;
init_mem_card_datas();

n=sizeof configuration;
 if(memcardload("guitarfun.dat",(char *) &configuration,&n)!=0){ mc_test|=2;}
               else 
				 {
     
				  mc_test&=1; 
				  n=sizeof data_memory;
                  memcardload("songs_score.dat",(char *) &data_memory,&n);
				  get_mem_card_datas();
				 }

if(argc>1)
{
for(n=1;n<argc;n++)
{
char *p=argv[n];

if(!strncmp(p,"-full",5)) MODEVIDEO|=2; // fullscreen
else
if(!strncmp(p,"-pan",4)) MODEVIDEO|=1;  // panoramic (16:9)
else
if(!strncmp(p,"-normal",7)) realtime=0;   // change to non realtime process
else
if(!strncmp(p,"-xbox360",8)) 
   {int s;
   xbox360_guitar=1;   // it uses xbox 360 guitar as guitar1
   for(s=0;s<5;s++)
   stick1_map_button[s]=s;
   stick1_map_button[s]=256;s++;
   stick1_map_button[s]=256;s++; 
   stick1_map_button[s]=6;s++;  
   stick1_map_button[s]=7;s++;
   stick1_map_axis[0]=-1;
   stick1_map_axis[1]=-1;
   stick1_map_axis[2]=-1;
   }

else
{
strcpy(global_dir,p);
p=&global_dir[strlen(global_dir)-1];
if(*p!='\\' && *p!='/')
 {
  p++;
  *p++=barra; // a�ade '/' o '\'
  *p=0;
 }
}

}

}
#else // GEKKO
strcpy(&main_dir[0],"fat:/guitarfun/\0");
strcpy(&global_dir[0],"fat:/guitarfun/songs/\0");
WPAD_Init();
WPAD_SetIdleTimeout(60*5); // 5 minutes 

PAD_Init();

fatInit(8, false);

SND_Init(INIT_RATE_48000); // Initialize the Sound Lib

SND_Pause(0); // the sound loop is running now
SYS_SetResetCallback(reset_call);

Load_MOD();

MODEVIDEO=0;
init_mem_card_datas();

n=sizeof configuration;
 if(memcardload("guitarfun.dat",(char *) &configuration,&n)!=0){ mc_test|=2;}
               else 
				 {
     
				  mc_test&=1; 
				  n=sizeof data_memory;
                  memcardload("songs_score.dat",(char *) &data_memory,&n);
				  get_mem_card_datas();
				 }
#endif

// load external_background
{
int fd;
sprintf(pathname,"%sbitmaps%cbackground.bmp",main_dir,barra);
  fd=open(pathname,O_RDONLY | O_BINARY, S_IREAD);
  if(fd>=0)
  {
  char *t1;
  unsigned short *t2;
  int size;
  size=lseek(fd,0,2);
  t1=malloc(size+64); 
  if(t1)
  {
  lseek(fd,0,0);
  read(fd,t1,size);close(fd);
  memcpy((void *)&bmph,t1+2,52); // copia informacion del BMP

  // conversion de endian
bmph.offset=GET_U32(bmph.offset);
bmph.header_size=GET_U32(bmph.header_size);
bmph.width=GET_U32(bmph.width);
bmph.height=GET_U32(bmph.height);

bmph.planes=GET_U16(bmph.planes);
bmph.bpp=GET_U16(bmph.bpp);

bmph.compression=GET_U32(bmph.compression);
bmph.image_size=GET_U32(bmph.image_size);
bmph.colors_used=GET_U32(bmph.colors_used);
bmph.colors_important=GET_U32(bmph.colors_important);

  
  t2=malloc(bmph.height*((bmph.width+3) & ~3)*2);
  if(t2)
  {
  background=malloc(256*256*2);
  if(background)
    {
    load_bmp_texture(t1, t2,0);
    scale_bmp_16b(t2,bmph.width,bmph.height,background,256,256);
    }
  free(t2);
  } 
  free(t1);
  } else close(fd);
 
  }
  

 
}


load_external_neck();

ResetVoice();
SoundLoadMemVoice(0,(void *) guitar30_pcm,size_guitar30_pcm);
SoundLoadMemVoice(1,(void *) guitar31_pcm,size_guitar31_pcm);
SoundLoadMemVoice(2,(void *) guitar32_pcm,size_guitar32_pcm);
SoundLoadMemVoice(4,(void *) out_pcm,size_out_pcm);
SoundLoadMemVoice(5,(void *) effect_pcm,size_effect_pcm);
SoundLoadMemVoice(6,(void *) clin_pcm,size_clin_pcm);
SoundLoadMemVoice(7,(void *) clin2_pcm,size_clin2_pcm);
SoundLoadMemVoice(8,(void *) aplauso_pcm,size_aplauso_pcm);

SoundLoadMemVoice(9,(void *) ovacion_pcm,size_ovacion_pcm);
SoundLoadMemVoice(10,(void *) abucheo_pcm,size_abucheo_pcm);

#ifndef GEKKO
 SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER | SDL_INIT_AUDIO | SDL_INIT_JOYSTICK);
#endif
atexit(fun_exit);

level_init=1;

#ifndef GEKKO
n_sticks=SDL_NumJoysticks();
printf("n_sticks %i\n",n_sticks);

joy1=joy2=NULL;

if(n_sticks>0) joy1=SDL_JoystickOpen(0);
if(n_sticks>1) joy2=SDL_JoystickOpen(1);

if(n_sticks<1) input_mode=2;
SDL_JoystickEventState(SDL_ENABLE);
SDL_EnableKeyRepeat(0,0);
#endif

InitVideomode();

level_init=2;

SetGraphThd(GRAPH_PAUSED);
   

   
 is_activewindow=1; 

#ifndef GEKKO
  SDL_SetEventFilter(event_filt);
  
 
    #ifdef IS_WIN32

   sema_SDL=CreateSemaphore(NULL,1,1,NULL);
   if(!sema_SDL) exit(1);
   sema_thread1=CreateSemaphore(NULL,0,1,NULL);
   if(!sema_thread1) exit(1);
   sema_main=CreateSemaphore(NULL,0,1,NULL);
   if(!sema_main) exit(1);
   h_thread1=CreateThread(NULL,1024*1024,thread_ogg, NULL, 0, &thread1_id);
   if(!h_thread1) exit(1);
   level_init=6;
    #else
   if (pthread_mutex_init(&mutex_thread1,NULL))
    exit(1);
  level_init=3;
  if (pthread_cond_init(&cond_thread1,NULL))
    exit(1);  
  level_init=4;
    pthread_mutex_lock(&mutex_thread1);
   if (pthread_mutex_init(&mutex_thread_main,NULL))
    exit(1);
  level_init=5;
  if (pthread_cond_init(&cond_thread_main,NULL))
    exit(1); 
  level_init=6;
    pthread_create( &thread1, NULL, thread_ogg, NULL);
    #endif
  level_init=7; 
  
  
  #ifndef IS_WIN32 
  /* // this part need root perms
  memset(&sthread1, 0, sizeof(sthread1));
  memset(&sthread2, 0, sizeof(sthread2));
  // maybe you can use it under LINUX
  
    sched_setscheduler(getpid(),SCHED_APP);
    sthread1.sched_priority=PTHD_THREAD1_PRIORITY;
    
  
    pthread_setschedparam(thread1, SCHED_APP, &sthread1);
    
    sthread2.sched_priority=PTHD_MAIN_PRIORITY;
   
    n=pthread_setschedparam(pthread_self(), SCHED_APP, &sthread2);
   */
    
  #endif
   SDL_SetTimer(MS_TICK,mytimer);  

#else // GEKKO
LWP_InitQueue(&oggplayer_queue);

SetAlarm();


if(LWP_CreateThread(&h_oggplayer,(void *)thread_ogg,NULL,oggplayer_stack,STACKSIZE,80)==-1)
	{
	exit(1);
	}

#endif // GEKKO

   level_init=8; 
   
   
  SAMPLES_AUD=8192; // base de sonido 93 ms
  
   PCMInit(44100, 2);
   
uploadsubletter(1);  

if(background) UploadTexture(TEXT_PRI,256, 256,background, 16);
else UploadTexture(TEXT_PRI,128, 64,bitmaps_sprite_16, 16);

load_bmp_texture(guitarra_bmp, texture,1);

UploadTexture(TEXT_PRI+1,bmph.width, bmph.height,texture, 16);
UploadTexture(TEXT_PRI+2,bitmaps_sprite_13_sx, bitmaps_sprite_13_sy,bitmaps_sprite_13, 16);
//UploadTexture(TEXT_PRI+3,bitmaps_sprite_14_sx,bitmaps_sprite_14_sy,bitmaps_sprite_14, 16); 
UploadTexture(TEXT_PRI+3,logo_sprite_1_sx,logo_sprite_1_sy,logo_sprite_1, 16);
#ifdef GEKKO
UploadTexture(TEXT_WII,bitmaps_sprite_18_sx,bitmaps_sprite_18_sy,bitmaps_sprite_18, 16);
#endif



   intro_screen();

   PCMSilence();

#ifdef GEKKO

MODPlay_Init(&mod_track);  // Initialize the MOD Library

if(!mod_file) mod_file=lydbox_mod;

if (MODPlay_SetMOD (&mod_track, mod_file ) < 0 ) // set the MOD song
      {
        MODPlay_Unload (&mod_track);   
      }
	else  
	  {
	    MODPlay_SetVolume( &mod_track, 32,32); // fix the volume to 64 (max 64)
	    MODPlay_Start (&mod_track); // Play the MOD
	  }
#endif

while(1) // gamme loop
{
  SetGraphThd(GRAPH_PAUSED);

#ifdef IS_WIN32   

 SetPriorityClass(GetCurrentProcess(),NORMAL_PRIORITY_CLASS);
#endif

 SAMPLES_AUD=8192; // base de sonido 93 ms
 
if(MODEVIDEO & 1)
  itoViewport(0, 0, 720, 480);
else 
  itoViewport(0, 0, 640, 480);
  
  itoClear(0xff000000);
itoSwitchFrameBuffers();
itoClear(0xff000000);
do
{
itoZTest(TRUE);
rumble1=0;rumble2=0;
#ifdef GEKKO
itoSetFrameHalt(0);
mod_track.paused=0;
#endif
ResetVoice();      
itoFreeTextures();          
uploadsubletter(1);
if(background) UploadTexture(TEXT_PRI,256, 256,background, 16);
else UploadTexture(TEXT_PRI,128, 64,bitmaps_sprite_16, 16);

load_bmp_texture(guitarra_bmp, texture,1);

UploadTexture(TEXT_PRI+1,bmph.width, bmph.height,texture, 16);
UploadTexture(TEXT_PRI+2,bitmaps_sprite_13_sx, bitmaps_sprite_13_sy,bitmaps_sprite_13, 16);
//UploadTexture(TEXT_PRI+3,bitmaps_sprite_14_sx,bitmaps_sprite_14_sy,bitmaps_sprite_14, 16); 
UploadTexture(TEXT_PRI+3,logo_sprite_2_sx,logo_sprite_2_sy,logo_sprite_2, 16);
#ifdef GEKKO
UploadTexture(TEXT_WII,bitmaps_sprite_18_sx,bitmaps_sprite_18_sy,bitmaps_sprite_18, 16);
#endif

menu_principal();

}
while(main_select_list()==0);
rumble1=0;rumble2=0;
#ifdef GEKKO
itoSetFrameHalt(0);
//mod_track.paused=1;
mod_track.paused=0;
#endif




SetGraphThd(GRAPH_PAUSED);


#ifdef IS_WIN32    
if(realtime)
 SetPriorityClass(GetCurrentProcess(),REALTIME_PRIORITY_CLASS);
else printf("Non realtime\n");
#endif

#ifdef GEKKO
   current_audio_loop_divider=configuration.audio_loop=2;
#endif
current_audio_loop_divider=((current_audio_loop_divider-1) & 1)+1;

 SAMPLES_AUD=8192/current_audio_loop_divider; // base de sonido 
ResetVoice();
// fun_play();
// activa hilo main
// fun_thread1

// carga de texturas
border2=0xff000010; // extraborde en panoramico

itoFreeTextures();

uploadsubletter(0);
PX=PY=0;color=0xffffffff;bkcolor=0;tamletra=2;



   

for(n=0;n<12;n++)
	{ 
	UploadTexture(TEXT_PRI+n,128, 128,guitar_anim_sprites[n].ptr, 16);
	}

n=12;
UploadTexture(TEXT_PRI+n,64, 128,guitar_anim_sprites[n].ptr, 16);

n++;
UploadTexture(TEXT_PRI+n,32, 32,guitar_anim_sprites[n].ptr, 16);

n++;
//UploadTexture(TEXT_PRI+n,128, 32,bitmaps_sprite_14, 16);
UploadTexture(TEXT_PRI+n,logo_sprite_2_sx,logo_sprite_2_sy,logo_sprite_2, 16);

n++;
load_bmp_texture(publico1_bmp, &texture[0],1); 
UploadTexture(TEXT_PRI+n,256, 128,texture, 16);

load_bmp_texture(publico2_bmp, &texture[0],1);
n++;
UploadTexture(TEXT_PRI+n,256, 128,texture, 16);

n++;
UploadTexture(TEXT_PRI+n,128, 128,bitmaps_sprite_15, 16);

tex_mastil++;

if(tex_mastil>3) tex_mastil=0;
if(ext_mastil)
{
tex_mastil=4;
	memcpy(&mastil_texture[0][0],ext_mastil,64*256*2);
	memcpy(&mastil_texture[1][0],ext_mastil,64*256*2);
	memcpy(&mastil_texture[2][0],ext_mastil,64*256*2);              
}
else
if(tex_mastil==3) 
	{load_bmp_texture(mastil3_1_bmp, &texture[0],0);
	memcpy(&mastil_texture[0][0],&texture[0],64*256*2);
	load_bmp_texture(mastil3_2_bmp, &texture[0],0);
	memcpy(&mastil_texture[1][0],&texture[0],64*256*2);
	load_bmp_texture(mastil3_2_bmp, &texture[0],0);
	memcpy(&mastil_texture[2][0],&texture[0],64*256*2);
	
	}
else
if(tex_mastil==2) 
	{load_bmp_texture(mastil2_1_bmp, &texture[0],0);
	memcpy(&mastil_texture[0][0],&texture[0],64*256*2);
	load_bmp_texture(mastil2_2_bmp, &texture[0],0);
	memcpy(&mastil_texture[1][0],&texture[0],64*256*2);
	load_bmp_texture(mastil2_3_bmp, &texture[0],0);
	memcpy(&mastil_texture[2][0],&texture[0],64*256*2);
	
	}
else
if(tex_mastil==1) 
	{
	load_bmp_texture(mastil_1_bmp, &texture[0],0);
	memcpy(&mastil_texture[0][0],&texture[0],64*256*2);
	load_bmp_texture(mastil_2_bmp, &texture[0],0);
	memcpy(&mastil_texture[1][0],&texture[0],64*256*2);
	load_bmp_texture(mastil_3_bmp, &texture[0],0);
	memcpy(&mastil_texture[2][0],&texture[0],64*256*2);
	}
else
if(tex_mastil==0) 
	{
	load_bmp_texture(mastil_bmp, &texture[0],0);
	memcpy(&mastil_texture[0][0],&texture[0],64*256*2);
	memcpy(&mastil_texture[1][0],&texture[0],64*256*2);
	memcpy(&mastil_texture[2][0],&texture[0],64*256*2);

	}
 UploadTexture(TEXT_IND1,128, 64,bitmaps_sprite_1, 16); 
 UploadTexture(TEXT_IND2,128, 64,bitmaps_sprite_2, 16);
 UploadTexture(TEXT_IND3,128, 64,bitmaps_sprite_13, 16);
 for(n=0;n<10;n++)
     UploadTexture(TEXT_NUM+n,16, 16,bitmaps_sprites[n+2].ptr, 16);

#ifdef GEKKO
 UploadTexture(TEXT_WII,bitmaps_sprite_18_sx,bitmaps_sprite_18_sy,bitmaps_sprite_18, 16);    
#endif

// crea borde de mastil
 
for(n=0;n<256;n++)
{
unsigned short v;
unsigned short *p;

p=&mastil_texture[0][n<<6];

v=p[0]; v=(v & 0x8000) | (((v & 0x7c00)>>1) & 0x7c00) | (((v & 0x3e0)>>1) & 0x3e0) | (((v & 0x1f)>>1) & 0x1f);
p[0]=v;

v=p[63]; v=(v & 0x8000) | (((v & 0x7c00)>>1) & 0x7c00) | (((v & 0x3e0)>>1) & 0x3e0) | (((v & 0x1f)>>1) & 0x1f);
p[63]=v;

p=&mastil_texture[1][n<<6];

v=p[0]; v=(v & 0x8000) | (((v & 0x7c00)>>1) & 0x7c00) | (((v & 0x3e0)>>1) & 0x3e0) | (((v & 0x1f)>>1) & 0x1f);
p[0]=v;

v=p[63]; v=(v & 0x8000) | (((v & 0x7c00)>>1) & 0x7c00) | (((v & 0x3e0)>>1) & 0x3e0) | (((v & 0x1f)>>1) & 0x1f);
p[63]=v;

p=&mastil_texture[2][n<<6];

v=p[0]; v=(v & 0x8000) | (((v & 0x7c00)>>1) & 0x7c00) | (((v & 0x3e0)>>1) & 0x3e0) | (((v & 0x1f)>>1) & 0x1f);
p[0]=v;

v=p[63]; v=(v & 0x8000) | (((v & 0x7c00)>>1) & 0x7c00) | (((v & 0x3e0)>>1) & 0x3e0) | (((v & 0x1f)>>1) & 0x1f);
p[63]=v;

}    


for(n=0;n<3;n++) 
        UploadTexture(TEXT_MASTIL+n,64, 256,&mastil_texture[n][0], 16);




Loading_screen();
Loading_screen();


// activa hilo de ogg

SDL_state=0;
ticks=-MS_TICK;
control_thread1=2;


#ifndef GEKKO
#ifdef IS_WIN32
{long out; ReleaseSemaphore(sema_thread1,1,&out);}
#else
pthread_cond_signal(&cond_thread1);
pthread_mutex_unlock(&mutex_thread1);
#endif
#else // GEKKO
LWP_ThreadSignal(oggplayer_queue);
GetEvent();
#endif
Read_Keyboard(255);


while(control_thread1==2) // espera a que hilo de ogg concluya
{
                          
control_thread_main=1;
#ifndef GEKKO
#ifdef IS_WIN32

if(WaitForSingleObject( sema_main, INFINITE)==WAIT_TIMEOUT)
{

continue;
}
#else
pthread_cond_wait(&cond_thread_main,&mutex_thread_main);
#endif
#else // GEKKO

LWP_ThreadSleep(alarm_queue);
GetEvent();

#endif

is_activewindow=0;


SDL_state|=1;
#ifndef GEKKO
#ifdef IS_WIN32
WaitForSingleObject( sema_SDL, INFINITE);
#endif
SDL_PollEvent(&event); // warning: maybe you have problems with this SDL multithread access
#ifdef IS_WIN32
{long out; ReleaseSemaphore(sema_SDL,1,&out);}
#else
if(SDL_state & 2) {SDL_state=0;
                
                  pthread_cond_signal(&cond_thread1);
               
                  }
//else SDL_state=0;
#endif
#else // GEKKO


SDL_state=0;
LWP_ThreadSignal(oggplayer_queue);
				
#endif

if(control_thread1!=2) break;

if(graph_thd_mode!=GRAPH_INGAME) {continue;} // GRAPH_INGAME sended from  thread_ogg
control_thread_main=2;
ingame_graph();

}

SDL_Delay(100);
while(graph_thd_mode!=GRAPH_PAUSED)
{
SDL_state|=1;
#ifndef GEKKO
#ifdef IS_WIN32
WaitForSingleObject( sema_SDL, INFINITE);
#endif
SDL_PollEvent(&event); // warning: maybe you have problems with this SDL multithread access
#ifdef IS_WIN32
{long out; ReleaseSemaphore(sema_SDL,1,&out);}
#else
SDL_state=0;
pthread_cond_signal(&cond_thread1);
               
#endif
#else // GEKKO


LWP_ThreadSignal(oggplayer_queue);
			               
#endif
thread_wakeup=1;
#ifndef GEKKO
#ifdef IS_WIN32

if(WaitForSingleObject( sema_main, INFINITE)==WAIT_TIMEOUT)
{

continue;
}
#else
pthread_cond_wait(&cond_thread_main,&mutex_thread_main);
#endif
#else // GEKKO

LWP_ThreadSleep(alarm_queue);
#endif
}



SetGraphThd(GRAPH_PAUSED);

load_external_neck(); // load neck for the next song


if(!control_thread1) 
{ 
itoFreeTextures();          
uploadsubletter(1);
if(background) UploadTexture(TEXT_PRI,256, 256,background, 16);
else UploadTexture(TEXT_PRI,128, 64,bitmaps_sprite_16, 16);

load_bmp_texture(guitarra_bmp, texture,1);
UploadTexture(TEXT_PRI+1,128, 128,texture, 16);
UploadTexture(TEXT_PRI+2,128, 64,bitmaps_sprite_13, 16);
//UploadTexture(TEXT_PRI+3,128,32,bitmaps_sprite_14, 16); 
UploadTexture(TEXT_PRI+3,logo_sprite_2_sx,logo_sprite_2_sy,logo_sprite_2, 16);
	  score_screen();
}

} // game loop

  return(0);
}




struct TocEntry
{
unsigned char fileProperties;

char filename[FILENAME_MAX];
};

struct TocEntry TocEntryList[256];
struct TocEntry TocEntryList2[256];




unsigned char input;

unsigned char ref_1[7]="artist";
unsigned char ref_2[5]="name";


void text_screen(char *t, int percent)
{
   
itoZTest(0);
			
ClearScreen(0xff000000); // borra la pantalla
itoZTest(0);
itoPrimShade(ITO_PRIM_SHADE_GOURAUD);

tamletra=2;
color=0xffffffff;
	
PX=(640-16*strlen(t))>>1;PY=(screen_height-32)>>1; s_printf("%s",t);
tamletra=2;

PX=(640-48)>>1;PY=(screen_height-32+64)>>1; s_printf("%i%%",percent);
tamletra=2;

itoSwitchFrameBuffers();
SDL_Delay(20);

}



int get_ini(char *pathname2)
{

					int fd;
                    fd=open(pathname2,O_RDONLY | O_BINARY, S_IREAD);
					
				
			
					if(fd>=0)
						{
						char *p=(char *)&texture[0];
						int n,size;
						int status_1=0;
						int status_2=0;
						size=lseek(fd,0,2);
						memset(p,0,size+256); 
						lseek(fd,0,0);
						read(fd,p,size);
						close(fd);
					
						n=0;
						while(1)
						{
						if(n<size) {input=p[n];n++;}
						else {
								if(status_1>=64) status_1=-1; 
							if(status_2>=64) status_2=-1; 
							     break;
								}
						if(input==0)
						{
								if(status_1>=64) status_1=-1; 
							if(status_2>=64) status_2=-1; 
							     break;
								}		
                      
						if(input<32 && input!=9) 
							{
							if(status_1>=64) status_1=-1; 
							if(status_2>=64) status_2=-1; 
							if(status_1>-1) status_1=0; 
							if(status_2>-1) status_2=0;
                            continue;
							}
						
						if(status_1<32 && status_2<32)
							{
							if(status_1>-1)
								{
								if(input==ref_1[status_1]) 
									{status_1++;
									if(status_1>=6) {status_1=32;if(status_2>-1) status_2=0;} // adquirir =
									} else status_1=0;
								}
							}
						else if(status_1==32)
							{
							if(input=='=') status_1=64;
							list_songs[n_list_songs].artist[status_1-64]=0;
							}
						else if(status_1>=64)
							{
							if(status_2<127)
								{
								list_songs[n_list_songs].artist[status_1-64]=input;
								status_1++;
								list_songs[n_list_songs].artist[status_1-64]=0;
								}
							}
							

						// name
						
						if(status_1<32 && status_2<32)
							{
							if(status_2>-1)
								{
								if(input==ref_2[status_2]) 
									{status_2++;
									if(status_2>=4) {status_2=32;if(status_1>-1) status_1=0;} // adquirir =
									} else status_2=0;
								}
							}
						else if(status_2==32)
							{
							if(input=='=') status_2=64;
							list_songs[n_list_songs].title[status_2-64]=0;
							}
						else if(status_2>=64)
							{
							if(status_2<127)
								{
                             
								list_songs[n_list_songs].title[status_2-64]=input;
								status_2++;
								list_songs[n_list_songs].title[status_2-64]=0;
								}
							}
							

						}
						
						if(status_1==-1 || status_2==-1)
							{
							if(status_1!=-1) strcpy(list_songs[n_list_songs].artist,"Unknown");
							if(status_2!=-1) strcpy(list_songs[n_list_songs].title,"Unknown");
							//printf("title: %s\n",list_songs[n_list_songs].title);
							//printf("artis: %s\n",list_songs[n_list_songs].artist);
							
							}
						}
						else return -1;
//printf("title: %s\n",list_songs[n_list_songs].title);
//printf("artist: %s\n",list_songs[n_list_songs].artist);						
return 0;
}

int strcmp_r(const unsigned char *uno,const unsigned char *dos)
{
if(*uno==0 && *dos==0) return 0;
if(*uno==0) return 1;
if(*dos==0) return -1;
while(*uno!=0 && *dos!=0)
	{
	if(*uno>*dos) return 1;
	if(*uno<*dos) return -1;
	uno++;dos++;
	}
return 0;
}



void ordena_especial2()
{

int n,m,k,l,num;

if(n_list_songs<=0) return;
num=n_list_songs;
for(n=0;n<(num-1);n++) // no es l mas rapido, pero tengo prisa :P
	{
	for(m=n+1;m<num;m++)
		{
		k=strcmp_r((const unsigned char *) list_songs[n].group,(const unsigned char *) list_songs[m].group );
		if(k==0) l=strcmp_r((const unsigned char *) list_songs[n].title,(const unsigned char *) list_songs[m].title );
		if(k>0 || (k==0 && l>0))
			{
			list_songs[512]=list_songs[n];
			list_songs[n]=list_songs[m];
			list_songs[m]=list_songs[512];
			}
		}
	}



}

static unsigned char group_name[32];


int hdd_getdir(char *ruta,int type, struct TocEntry *entries,int maxentries)
{

#ifdef GEKKO
DIR_ITER *dd= diropen(ruta);
//DIR_ITER *dd2;
struct stat filestat;
#else
DIR * dd = opendir(ruta);
DIR * dd2;
int nfiles=0;
static struct dirent *direntp;
#endif
char ruta2[FILENAME_MAX];

if(dd!=NULL) 
{
int nfiles=0;
while(nfiles < maxentries)
		{
  
        #ifdef GEKKO
		memset(&entries[nfiles],0,sizeof entries[0]);
        if(dirnext (dd, entries[nfiles].filename, &filestat)!=0) break;
        if(entries[nfiles].filename[0]=='.') continue;
		sprintf(ruta2,"%s%s",ruta,entries[nfiles].filename);
       // dd2 = diropen(ruta2);
		//if(dd2) dirclose(dd2);
		 // directory
        if((filestat.st_mode & S_IFDIR)  && (type & 1)==1) {
                entries[nfiles].fileProperties=1;
                nfiles++;
                }
        // files
        if((!(filestat.st_mode & S_IFDIR)) && (type & 2)==2) {
                entries[nfiles].fileProperties=0;
                nfiles++;
                }
		#else
		direntp=readdir(dd);
	    if(direntp==NULL) break;
		if(direntp->d_name[0] == '.') continue;
	

		// directory test
		sprintf(ruta2,"%s%s",ruta,direntp->d_name);
        dd2=opendir(ruta2);
        if(dd2) closedir(dd2);
		memset(&entries[nfiles],0,sizeof entries[0]);
		 // directory
        if(dd2 && (type & 1)==1) {memcpy(entries[nfiles].filename,direntp->d_name,strlen(direntp->d_name));
                entries[nfiles].fileProperties=1;
                nfiles++;
                }
        // files
        if(!dd2 && (type & 2)==2) {memcpy(entries[nfiles].filename,direntp->d_name,strlen(direntp->d_name));
                entries[nfiles].fileProperties=0;
                nfiles++;
                }
        #endif
        
       

    }
#ifdef GEKKO
  dirclose(dd);
#else
  closedir(dd);
#endif
  return nfiles;
}


return 0;
}


void get_files()
{
int n,m,r,num_files,num_files2;

n_list_songs=0;


text_screen("Reading from USB...",0);

		num_files =hdd_getdir(global_dir, 1, TocEntryList,256);
		if(num_files>0)
			{

			for(n=0;n<num_files;n++)
				{
				text_screen("Reading from USB...",(n*100)/num_files);
				if(TocEntryList[n].filename[0]=='.') continue;
			

				if((TocEntryList[n].filename[0]=='p' && TocEntryList[n].filename[1]=='a' && TocEntryList[n].filename[2]=='c' && TocEntryList[n].filename[3]=='k') ||
					(TocEntryList[n].filename[0]=='P' && TocEntryList[n].filename[1]=='A' && TocEntryList[n].filename[2]=='C' && TocEntryList[n].filename[3]=='K'))
					{
					sprintf(pathname,"%s%s%c",global_dir,TocEntryList[n].filename,barra);
					
					num_files2 =hdd_getdir(pathname,1, TocEntryList2,256);
					if(num_files2>0)	
					 {
					sprintf(pathname,"%s%s%ctitle.txt",global_dir,TocEntryList[n].filename,barra);	
					memcpy(group_name,TocEntryList[n].filename,32);group_name[31]=0;
					//printf("path %s\n",pathname);
					m=open(pathname,O_RDONLY | O_BINARY, S_IREAD);
					if(m>=0)
						 {
						r=0;
						while(r<31)
							 {
							 if(read(m,&group_name[r],1)<=0) break;
							 if(group_name[r]<32 && group_name[r]!=9) break;
							 r++;
							 }
						if(r!=0) group_name[r]=0;
						close(m);

						 }

					 for(m=0;m<num_files2;m++)
						 {
						 if(TocEntryList2[m].filename[0]=='.') continue;
						 memcpy(list_songs[n_list_songs].group,group_name,32);list_songs[n_list_songs].group[31]=0;
						 sprintf(list_songs[n_list_songs].path,"%s%s%c%s%c",global_dir,TocEntryList[n].filename,barra,TocEntryList2[m].filename,barra);
						 //printf("path  ini %s\n",list_songs[n_list_songs].group);//list_songs[n_list_songs].path);
						 sprintf(pathname,"%ssong.ini",list_songs[n_list_songs].path);
						 
                         if(get_ini(pathname)==0)
							 {                  
							 n_list_songs++;if(n_list_songs>=512) return;
							 }

						 }
					 }


					}
				else
					{
					sprintf(list_songs[n_list_songs].path,"%s%s%c",global_dir,TocEntryList[n].filename,barra);
					sprintf(pathname,"%ssong.ini",list_songs[n_list_songs].path);
					list_songs[n_list_songs].group[0]=0;

					if(get_ini(pathname)==0)
					{
					n_list_songs++;if(n_list_songs>=512) return;
					}
					}

				
				}
			}

} 
 
void score_screen()
{
int n,m;
int stars,stars2;
int percent,percent2;
int update;
char *cad,*cad_edit=0;
static char name[4]="MNI";
int cursor=0;
int flash=0;
int retain=100;
int retain2=100;
int delay_button=90;


	
uploadsubletter(1);

#ifndef DEVELOP	
if(mc_test & 2) 
			   {display_fondo1();tamletra=2;bkcolor=0;color=0xff00f0f0;
				PX=640-23*16;PY=0; s_printf("Reading the Memory Card");
				#ifndef GEKKO
				SDL_PollEvent(&event);SDL_Delay(20);
				#else
				GetEvent();
				#endif
				itoSwitchFrameBuffers();
	            n=sizeof configuration;
			   if(memcardload("guitarfun.dat",(char *) &configuration,&n)!=0){ mc_test|=2;}
               else 
				 {
				  mc_test&=1;
				  n=sizeof data_memory;
			      memcardload("songs_score.dat",(char *) &data_memory,&n);
				  get_mem_card_datas();
				 }
			   }
#endif

new_pad=0;
old_pad=0xffffffff;

m=0;
while(1)
	{
	display_fondo1();
	
	tamletra=2;

	bkcolor=0;

	color=0xff00f0f0;
	autocenterprintf=1;
	PX=0;PY=16; tamletra=1;
	if(rockometro<=0 && twoplayers==0) {
		color=0xff0000f0;s_printf("Song Failed!!!");
		score=0;
		WPAD_Rumble(0, 0);
		}
	else s_printf("Song Finished");
	autocenterprintf=0;
	
	tamletra=2;
	itoSprite(0xff00f000 ,0,screen_height-48,32,screen_height,0);itoGsFinish();
	color=0xff000000;PX=4;PY=screen_height-24; s_printf("F1");
	color=0xfff0f0f0;
	PX=48;PY=screen_height-24; s_printf("Continue");
	PX+=16;
	itoSprite(0xff0000f0 ,PX,screen_height-48,PX+32,screen_height,0);itoGsFinish();
	color=0xff000000;PX+=2;PY=screen_height-24; s_printf("F2");
	color=0xfff0f0f0;
	PX+=16;s_printf("Exit");
	
	n=(screen_height>>1)-48*2+32;
//
if(twoplayers==0)
{
	color=0xfff0f0f0;
	PX=216;PY=n; s_printf("Score: %i",score);n+=48;
	
	percent=(100*notes_ok)/notes_total;
	if(percent>=95) stars=5;
	else
	if(percent>=85) stars=4;
	else
	if(percent>=66) stars=3;
	else 
	if(percent>=25) stars=2;
	else stars=1;

	if(rockometro<=0) stars=0;

	PX=216;PY=n; s_printf("Accuracy: %i%%",percent);n+=48;

   for(m=0;m<stars;m++) display_star2((640-stars*40)/2+m*40,n,0xffffffff);
   
   n+=48;
	
   PX=120;PY=n; s_printf("Longest note sequence: %i",max_note_seq);n+=48;

   PY=n;
	autocenterprintf=1;
	tamletra=1;
	switch(global_song_level)
		{
		case 0:s_printf("EASY LEVEL");break;
		case 1:s_printf("MEDIUM LEVEL");break;
		case 2:s_printf("HARD LEVEL");break;
		case 3:s_printf("EXPERT LEVEL");break;
		case 4:s_printf("3 KEYS SPECIAL LEVEL");break;
		}
	autocenterprintf=0;
	tamletra=2;
	}
else
	{

	color=0xff00f0f0;
	PX=40+32;PY=n-48; s_printf("Player 1");
	PX=392+32;PY=n-48; s_printf("Player 2");
    
    
    
	color=0xfff0f0f0;
	PX=40;PY=n; s_printf("Score: %i",score);
	PX=392;PY=n; s_printf("Score: %i",two_score);
	n+=48;
	if(notes_total==0) percent=0;
	else percent=(100*notes_ok)/notes_total;
	if(percent>=95) stars=5;
	else
	if(percent>=85) stars=4;
	else
	if(percent>=66) stars=3;
	else 
	if(percent>=25) stars=2;
	else if(percent!=0) stars=1; else stars=0;

	if(rockometro<=0) stars=0;

	
	if(two_notes_total==0) percent2=0;
	else percent2=(100*two_notes_ok)/two_notes_total;
	if(percent2>=95) stars2=5;
	else
	if(percent2>=85) stars2=4;
	else
	if(percent2>=66) stars2=3;
	else 
	if(percent2>=25) stars2=2;
	else if(percent2!=0) stars2=1; else stars2=0;

	if(two_rockometro<=0) stars2=0;

	PX=40;PY=n; s_printf("Accuracy: %i%%",percent);
	PX=392;PY=n; s_printf("Accuracy: %i%%",percent2);
	
	
	n+=48;

   for(m=0;m<stars;m++) display_star2((140-stars*20)+m*40,n,0xffffffff);
   for(m=0;m<stars2;m++) display_star2((492-stars2*20)+m*40,n,0xffffffff);
   
   n+=48;
	
   PX=60;PY=n; s_printf("Longest note sequence: %i %i ",max_note_seq,two_max_note_seq);n+=48;

   PY=n;
	autocenterprintf=1;
	tamletra=1;
	color=0xff00f010;
	if(modeplayers==0)
		{
		if(score==0) percent=0;
		if(two_score==0) percent2=0;

		if(percent>percent2 || (percent==percent2 && score>two_score) || (percent==percent2 && score==two_score && max_note_seq>two_max_note_seq))
			s_printf("*** PLAYER 1 WINS ***");
		else
		if(percent2>percent || (percent2==percent && two_score>score) || (percent2==percent && two_score==score && two_max_note_seq>max_note_seq))
			s_printf("*** PLAYER 2 WINS ***");
		else s_printf("TIE? This is incredible!!!");
		}
	else
		{
		tamletra=2;
		s_printf("Full Score: %i",score+two_score); 
		}
	color=0xfff0f0f0;
	autocenterprintf=0;
	tamletra=2;
	}

		
	if(Read_Keyboard(0))
		{
		if (delay_button) delay_button--;
		else
		{
			
		if(new_key & (KEY_ENTER | KEY_F1 | KEY_F2 | KEY_ESC)) 
			{
			break;
			}
		}
		}

	if(readpad(2))
		{
		
		if (delay_button) delay_button--;
		else
		{
			
		if(new_pad & ( PAD_1 | PAD_2)) 
			{
			break;
			}
		}
	

		}
	#ifndef GEKKO
	SDL_PollEvent(&event);SDL_Delay(20);
	#else
	GetEvent();
	#endif
	itoSwitchFrameBuffers();
	}

if(twoplayers) return;
if(mid_speed<4) return;
if(rockometro<=0) return;

if(stars<3) return;
m=0;
for(n=0;n<128;n++)
	{
	if(data_memory.songs[n].older>=0)
	if(!strncmp((char *) &data_memory.songs[n].title,list_songs[tema].title,32))
		if(!strncmp((char *) &data_memory.songs[n].artist,list_songs[tema].artist,32))
		{
		break;
		}
	}
if(n>=128) // no encontrado, busca un slot libre e inicializalo
	{
	m=0;
	for(n=0;n<128;n++)
	{
	if(data_memory.songs[n].older<0) break;
	if((data_memory.songs[n].older & 0x80ffffff)>(data_memory.songs[m].older & 0x80ffffff)) m=n;
	}
	if(n>=128) n=m;

	for(m=0;m<128;m++) // update
		{
		if(data_memory.songs[m].older<0 || n==m) continue;

		data_memory.songs[m].older+=1;
		}
	data_memory.songs[n].older=0x1000000;
	memcpy(&data_memory.songs[n].title,list_songs[tema].title,32);
	memcpy(&data_memory.songs[n].artist,list_songs[tema].artist,32);
	memset(&data_memory.songs[n].records,0, 5*3*3*2);

	}

update=0;


	for(m=0;m<3;m++)
	{
	if(data_memory.songs[n].records[global_song_level][stars-3][m][0]<score) 
		{
		int t;
		for(t=2;t>m;t--)
			{
			data_memory.songs[n].records[global_song_level][stars-3][t][0]=data_memory.songs[n].records[global_song_level][stars-3][t-1][0];
			data_memory.songs[n].records[global_song_level][stars-3][t][1]=data_memory.songs[n].records[global_song_level][stars-3][t-1][1];
			}
		
		update=1;
		break;
		}
	}


if(update)
{
data_memory.songs[n].older=(data_memory.songs[n].older & 0xffffff) | 0x1000000;
data_memory.songs[n].records[global_song_level][stars-3][m][0]=score;
memcpy(&data_memory.songs[n].records[global_song_level][stars-3][m][1],name,4);
}

#ifdef GEKKO
mod_track.paused=0;
#endif
while(1)
	{
	int l,k,s;
	display_fondo1();
	flash++;
	
	tamletra=2;

	bkcolor=0;

	color=0xff00f0f0;
	PX=(640-12*16)>>1;PY=16; s_printf("Hall Of Fame");

	itoSprite(0xff00f000 ,0,screen_height-48,32,screen_height,0);itoGsFinish();
	color=0xff000000;PX=4;PY=screen_height-24; s_printf("F1");
	color=0xfff0f0f0;

	PX=48;PY=screen_height-24; 
	if(update)
	{
	s_printf("Enter");
	PX+=16;
	itoSprite(0xff0000f0 ,PX,screen_height-48,PX+32,screen_height,0);itoGsFinish();
	color=0xff000000;PX+=2;PY=screen_height-24; s_printf("F2");
	color=0xfff0f0f0;
	PX+=16;s_printf("Back  START - End");
	}
	else s_printf("Continue");

	l=(screen_height>>1)-48*2+32;

	
	for(k=0;k<3;k++)
	{
    int q;
	
	color=0xfff0f0f0;
	if(k==m && update) color=0xff00f040;
	s=data_memory.songs[n].records[global_song_level][stars-3][k][0];

    cad=(char *) &data_memory.songs[n].records[global_song_level][stars-3][k][1];
	cad[3]=0;


	PX=80;PY=l; s_printf("%i.: %i ",k+1,s);

	q=80+192;
	if(stars>=1) display_star(q,PY,0xffffffff);
	q+=20;
	if(stars>=2) display_star(q,PY,0xffffffff);
	q+=20;
	if(stars>=3) display_star(q,PY,0xffffffff);
	q+=20;
	if(stars>=4) display_star(q,PY,0xffffffff);
	q+=20;
	if(stars>=5) display_star(q,PY,0xffffffff);
	q+=20;

	PX=q+32;

	if(k==m && cursor==0 && (flash & 16)==0 && update) bkcolor=0xfff00000; else bkcolor=0;
	if(cad[0]<'A') cad[0]=' ';
	s_printf("%c",cad[0]);q+=20;

	if(k==m && cursor==1 && (flash & 16)==0 && update) bkcolor=0xfff00000; else bkcolor=0;
	if(cad[1]<'A') cad[1]=' ';
	s_printf("%c",cad[1]);q+=20;
	
	if(cad[2]<'A') cad[2]=' ';
	if(k==m && cursor==2 && (flash & 16)==0 && update) bkcolor=0xfff00000; else bkcolor=0;
	s_printf("%c",cad[2]);q+=20;
	if(k==m) cad_edit=cad;
	

	l+=48;
	bkcolor=0;
	}
	color=0xffFFFFFF;

	PY=l;
	autocenterprintf=1;
	tamletra=1;
	switch(global_song_level)
		{
		case 0:s_printf("EASY LEVEL");break;
		case 1:s_printf("MEDIUM LEVEL");break;
		case 2:s_printf("HARD LEVEL");break;
		case 3:s_printf("EXPERT LEVEL");break;
		case 4:s_printf("3 KEYS SPECIAL LEVEL");break;
		}
	autocenterprintf=0;
	tamletra=2;

	if(Read_Keyboard(0))
		{
		
		if(update)
		{
		if((new_key & KEY_UP) || ((old_key & KEY_UP) && retain2==0))  
			{
			if(new_key & KEY_UP) retain2=25; else retain2=5;
			cad_edit[cursor]--;if(cad_edit[cursor]<' ') cad_edit[cursor]='Z'; else if(cad_edit[cursor]<'A') cad_edit[cursor]=' ';
			}
		if((new_key & KEY_DOWN) || ((old_key & KEY_DOWN) && retain2==0)) 
			{
			if(new_key & KEY_DOWN) retain2=25; else retain2=5;
			cad_edit[cursor]++;if(cad_edit[cursor]<=33) cad_edit[cursor]='A'; else if(cad_edit[cursor]>'Z') cad_edit[cursor]=' ';
			}
		}
		
		if(retain2) retain2--;
		if(new_key & (KEY_F2)) 
			{
			if(!update) break;
			if(cursor>0) cursor--;
			}	
		if(new_key & (KEY_F1 | KEY_ENTER) ) 
			{
			if(!update) break;
			cursor++;
			if(cursor==3) break;
			}
		if(new_key & ( KEY_ESC)) 
			{
			break;
			}
		
		
		}

	if(readpad(2))
		{
		if(update)
		{
		if((new_pad & PAD_UP) || ((old_pad & PAD_UP) && retain==0))  
			{
			if(new_pad & PAD_UP) retain=25; else retain=5;
			cad_edit[cursor]--;if(cad_edit[cursor]<' ') cad_edit[cursor]='Z'; else if(cad_edit[cursor]<'A') cad_edit[cursor]=' ';
			}
		if((new_pad & PAD_DOWN) || ((old_pad & PAD_DOWN) && retain==0)) 
			{
			if(new_pad & PAD_DOWN) retain=25; else retain=5;
			cad_edit[cursor]++;if(cad_edit[cursor]<=33) cad_edit[cursor]='A'; else if(cad_edit[cursor]>'Z') cad_edit[cursor]=' ';
			}
		}
		
		if(retain) retain--;
		if(new_pad & (PAD_2)) 
			{
			if(!update) break;
			if(cursor>0) cursor--;
			}	
		if(new_pad & ( PAD_1)) 
			{
			if(!update) break;
			cursor++;
			if(cursor==3) break;
			}
		if(new_pad & (PAD_START)) 
			{
			break;
			}


		}
	#ifndef GEKKO
	SDL_PollEvent(&event);SDL_Delay(20);
	#else
	GetEvent();
	#endif
	itoSwitchFrameBuffers();
	}
if(update)
{
if(cad_edit) memcpy(name,cad_edit,4);

 if((data_memory.songs[n].older & 0xffffff) !=0 && update)
	{
	for(m=0;m<128;m++) // update
		{
		if(data_memory.songs[m].older<0 || n==m) continue;

		data_memory.songs[m].older+=1;
		}
	data_memory.songs[n].older=0x1000000;
	}
}
SDL_Delay(1500);

#ifndef DEVELOP	
if(update)
{
display_fondo1();tamletra=2;bkcolor=0;color=0xff00f0f0;
PX=640-23*16;PY=0; s_printf("Writing the Memory Card");
#ifndef GEKKO
SDL_PollEvent(&event);SDL_Delay(20);
#else
	GetEvent();
#endif
itoSwitchFrameBuffers();

if(save_songs_datas()!=0)
	{
	ClearScreen(0xff000000);
	PX=16;
	PY=16;
	color=0xffffffff;
	s_printf("MEMORY CARD: ERROR SAVING SONG DATAS");
	#ifndef GEKKO
	SDL_PollEvent(&event);itoSwitchFrameBuffers();SDL_Delay(2000);
	#else
	GetEvent();
	itoSwitchFrameBuffers();
	Delay(2000);
	#endif
	}
}
#endif


} 
void menu_sound()
{
int n,m;

m=0;
while(1)
	{
	display_fondo1();
	
	tamletra=2;

	bkcolor=0;

	itoSprite(0xff00f000 ,0,screen_height-48,32,screen_height,0);itoGsFinish();
	color=0xff000000;PX=4;PY=screen_height-24; s_printf("F1");
	color=0xfff0f0f0;
	PX=48;PY=screen_height-24; s_printf("Increase");
	PX+=16;
	itoSprite(0xff0000f0 ,PX,screen_height-48,PX+32,screen_height,0);itoGsFinish();
	color=0xff000000;PX+=2;PY=screen_height-24; s_printf("F2");
	color=0xfff0f0f0;
	PX+=16;s_printf("Decrease");
	
	n=(screen_height>>1)-48*2;

	if(m==0) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("PCM Volume: %u %%",pcm_volume);n+=40;

	if(m==1) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("Effects Volume: %u %%",effects_volume);n+=40;

	if(m==2) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("Track #1 Volume Divider: %i",1+sound1_div);n+=40;

	if(m==3) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("Track #2 Volume Divider: %i",1+sound2_div);n+=40;
	
	if(m==4) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n;if(current_audio_loop_divider==1) s_printf("Audio Loop: Slow"); else  s_printf("Audio Loop: Fast");
    n+=40;
	
	if(m==5) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("Exit");n+=48;

		if(Read_Keyboard(0))
		{
		
		if(new_key & KEY_UP) {if(m>0) m--; else m=5;}
		if(new_key & KEY_DOWN) {if(m<5) m++; else m=0;}
			
		if(new_key & (KEY_ENTER | KEY_F1)) 
			{
			if(m==0) {pcm_volume+=10;if(pcm_volume>100) pcm_volume=100;}
			if(m==1) {effects_volume+=10;if(effects_volume>100) effects_volume=100;}
			if(m==2) sound1_div=1;
			if(m==3) sound2_div=1;
			if(m==4) {if(current_audio_loop_divider==1) current_audio_loop_divider=2; else current_audio_loop_divider=1;}
			if(m==5) break;
			}
		if(new_key & (KEY_F2)) 
			{
			if(m==0) {pcm_volume-=10;if(pcm_volume<20) pcm_volume=20;}
			if(m==1) {effects_volume-=10;if(effects_volume<20) effects_volume=20;}
			if(m==2) sound1_div=0;
			if(m==3) sound2_div=0;
			if(m==4) {if(current_audio_loop_divider==1) current_audio_loop_divider=2; else current_audio_loop_divider=1;}
			if(m==5) break;
			}
		}


	if(readpad(2))
		{
		
		if(new_pad & PAD_UP) {if(m>0) m--; else m=5;}
		if(new_pad & PAD_DOWN) {if(m<5) m++; else m=0;}
			
		if(new_pad & ( PAD_1)) 
			{
			if(m==0) {pcm_volume+=10;if(pcm_volume>100) pcm_volume=100;}
			if(m==1) {effects_volume+=10;if(effects_volume>100) effects_volume=100;}
			if(m==2) sound1_div=1;
			if(m==3) sound2_div=1;
			if(m==4) {if(current_audio_loop_divider==1) current_audio_loop_divider=2; else current_audio_loop_divider=1;}
			if(m==5) break;
			}
		if(new_pad & (PAD_2)) 
			{
			if(m==0) {pcm_volume-=10;if(pcm_volume<20) pcm_volume=20;}
			if(m==1) {effects_volume-=10;if(effects_volume<20) effects_volume=20;}
			if(m==2) sound1_div=0;
			if(m==3) sound2_div=0;
			if(m==4) {if(current_audio_loop_divider==1) current_audio_loop_divider=2; else current_audio_loop_divider=1;}
			if(m==5) break;
			}
		}

    #ifndef GEKKO
    SDL_PollEvent(&event);SDL_Delay(20);
	#else
	GetEvent();
	#endif
	itoSwitchFrameBuffers();
	}
}

void license_screen(char *text, int size_text)
{
int n,m,l,k=0,m2,last;

int retain=100;
int retain2=100;

char linea[64];


	
last=0;
m=0;
while(1)
	{
	ClearScreen(0xff602000);
	
	tamletra=2;

	bkcolor=0;

	itoSprite(0xff00f000 ,0,screen_height-48,32,screen_height,0);itoGsFinish();
	color=0xff000000;PX=4;PY=screen_height-24; s_printf("F1");
	color=0xfff0f0f0;
	PX=48;PY=screen_height-24; s_printf("Return");
	PX+=16;
	itoSprite(0xff0000f0 ,PX,screen_height-48,PX+32,screen_height,0);itoGsFinish();
	color=0xff000000;PX+=2;PY=screen_height-24; s_printf("F2");
	color=0xfff0f0f0;
	PX+=16;s_printf("Exit");
	tamletra=3;
	color=0xfff0f0f0;

    m2=m;
	l=0;
	while(l<20)
	{
	int flag=0;
	if(l==2) k=m;
	
	if(m>=size_text) {m=k;break;}
	n=0;
	while(n<53)
		{
		if(m>=size_text) break;
		if(text[m]<32 && text[m]!=9) {break;}
		if(text[m]=='[') {color=0xff00f0f0;m++;}
		else if(text[m]==']') {m++;flag=1;}
		else {linea[n]=text[m];n++;linea[n]=0;m++;}
		}
	if(n>0)
	{
	PX=0;PY=80+l*16; s_printf("%s",linea);
	}
	if(flag) {flag=0;color=0xfff0f0f0;}
	if(m>=size_text) break;
	if(text[m]=='\n') {l++;m++;}
	else m++;
	}
    m=m2;
	if(Read_Keyboard(0))
		{

		if((new_key & KEY_DOWN) || ((old_key & KEY_DOWN) && retain2==0)) 
			{if(new_key & KEY_DOWN) retain2=25; else retain2=5;if(l>=20) {last=m;m=k;}}
		if((new_key & KEY_UP) || ((old_key & KEY_UP) && retain2==0)) 
		{if(new_key & KEY_UP) retain2=25; else retain2=5;
		
		if(m>0)
			{
			while(m>0 && text[m]!='\n') m--;
			if(m>0) {m--;while(m>0 && text[m]!='\n') m--;}
			if(m>0) {m--;while(m>0 && text[m]!='\n') m--;if(m>0) m++;}
			}
		}
			
	

		if(new_key & (KEY_ENTER | KEY_F1 | KEY_F2 | KEY_ESC))  {return;}

		if(retain2) retain2--;
		}
	
	if(readpad(2))
		{
		
		//if(new_pad & PAD_UP) {if(m>0) m--;}
		if((new_pad & PAD_DOWN) || ((old_pad & PAD_DOWN) && retain==0)) 
			{if(new_pad & PAD_DOWN) retain=25; else retain=5;if(l>=20) {last=m;m=k;}}
		if((new_pad & PAD_UP) || ((old_pad & PAD_UP) && retain==0)) 
		{if(new_pad & PAD_UP) retain=25; else retain=5;
		
		if(m>0)
			{
			while(m>0 && text[m]!='\n') m--;
			if(m>0) {m--;while(m>0 && text[m]!='\n') m--;}
			if(m>0) {m--;while(m>0 && text[m]!='\n') m--;if(m>0) m++;}
			}
		}
			
		

		if(new_pad & (PAD_2)) {return;}

		if(retain) retain--;

		}
#ifndef GEKKO
    SDL_PollEvent(&event);SDL_Delay(20);
#else
	GetEvent();
#endif
    itoSwitchFrameBuffers();
	}
}


void menu_definekeys(int player)
{
int n,m,l;
unsigned  keys[12];

for(n=0;n<128;n++) Read_Keyboard(3);

m=0;
while(1)
	{
	display_fondo1();
	
	tamletra=2;

	bkcolor=0;

    if(m<10)
	{
	itoSprite(0xff0000f0 ,0,screen_height-48,32,screen_height,0);itoGsFinish();
	color=0xff000000;PX=2;PY=screen_height-24; s_printf("F2");
	color=0xfff0f0f0;
	PX=48;PY=screen_height-24; s_printf("Abort");
	PX+=32;
	}
	else
	{
	itoSprite(0xff00f000 ,0,screen_height-48,32,screen_height,0);itoGsFinish();
	color=0xff000000;PX=4;PY=screen_height-24; s_printf("F1");
	color=0xfff0f0f0;
	PX=48;PY=screen_height-24; s_printf("Confirm");
	PX+=16;
	itoSprite(0xff0000f0 ,PX,screen_height-48,PX+32,screen_height,0);itoGsFinish();
	color=0xff000000;PX+=2;PY=screen_height-24; s_printf("F2");
	color=0xfff0f0f0;
	PX+=16;s_printf("Abort");
	}

	
	
    //n=(screen_height>>1)-48*2-16;
    n=(screen_height>>1)-48*2-40;

	for(l=0;l<=m;l++)
	{
	PX=80;PY=n+l*32; color=0xffffffff;
	if(l==0)    bkcolor=0xff00b000;
	if(l==1)    bkcolor=0xff0000b0;
	if(l==2)	bkcolor=0xff00b0b0;
	if(l==3)	bkcolor=0xffb07000;
	if(l==4)	bkcolor=0xff0070b0;

	if(l<5)
		{s_printf("  Key #%i  ",l+1);
	   
		}
	bkcolor=0;
	if(l==5) s_printf("   Pick   ");
	if(l==6) s_printf("   Esc    ");
	if(l==7) s_printf("   Up     ");
	if(l==8) s_printf("   Down   ");
	if(l==9) s_printf("Overdriver");

	if(l==10) 
		{
	
		}
	else
 // F1-F5,Enter,esc,arriba,abajo,izquierda,derecha
		{
		if(l<m) s_printf(": %u",keys[l]);	
		}


    }
tamletra=2;

if(m<10)
{
l=Read_Keyboard(3);

if(l)
		{
        int s;
        for(s=0;s<m;s++)
         {
         if(keys[s]==l) {l=0;break;} // keys must be different
         }
         if(l) {keys[m]=l;m++;}
		}
}
else
	{
	l=Read_Keyboard(0);
	if(l)
		{
       		                                      
		if(new_key & (KEY_ESC | KEY_F2)) 
			{
			break;
			}
		if(new_key & (KEY_ENTER | KEY_F1)) 
			{
			if(m==10) 
				{
				if(player==1)
					{
					for(n=0;n<10;n++) keys_raw[n]=keys[n];
					}
				 else
					 {
					for(n=0;n<10;n++) keys_raw2[n]=keys[n];
					}
				break;
				}
			}
		
		
		}
	}
	if(readpad(2))
		{		
	
		if(new_pad & ( PAD_1)) 
			{
			if(m==10) 
				{
				if(player==1)
					{
					for(n=0;n<10;n++) keys_raw[n]=keys[n];
					}
				 else
					 {
					for(n=0;n<10;n++) keys_raw2[n]=keys[n];
					}
				break;
				}
			}
		if(new_pad & (PAD_2)) 
			{
          
			break;
			}
		}

#ifndef GEKKO
	SDL_PollEvent(&event);SDL_Delay(20);
#else
	GetEvent();
#endif	
	itoSwitchFrameBuffers();
	}
  for(n=0;n<128;n++) Read_Keyboard(3);
}



void menu_definepad(int player)
{
int n,m;

int crt_manual=0;
int isplayer2;

isplayer2=(player>=128);

player&=127;

#ifndef GEKKO

int manual=0;
int k,l=0,num_buttons,num_axis,num_hats;
int flashs=0;
int is_pad=0;

int  keys[12];

int axes[32];
int hats[32];

int hats_used[32];
int axes_used[32];
int buttons_used[256];

SDL_Joystick *joy;

for(n=0;n<128;n++) Read_Keyboard(3);


if((player-1) & 1) {joy=joy2;is_pad=((input_mode2==1) || (input_mode2==4));
                   
                  } else {joy=joy1;is_pad=((input_mode==1) || (input_mode==4));}
if(!joy) return;
num_buttons=SDL_JoystickNumButtons(joy);
if(num_buttons<1) return;
if(num_buttons>256) num_buttons=256;
num_axis=SDL_JoystickNumAxes(joy);
if(num_axis<1) num_axis=0;
if(num_axis>32) num_axis=32;

num_hats=SDL_JoystickNumHats(joy);
if(num_hats<1) num_hats=0;
if(num_hats>32) num_axis=32;

n=0;
while(n<75)
{
int ret;
int flag=0;
for(k=0;k<num_buttons;k++) 
  {
  ret=SDL_JoystickGetButton(joy, k);
  if(ret<0) {continue;}
  if(ret!=0) flag=1;
  }
if(!flag) break;

SDL_PollEvent(&event);
SDL_Delay(20);

n++;
}

for(k=0;k<num_buttons;k++) 
if(SDL_JoystickGetButton(joy, k))
    buttons_used[k]=2; // ignore buttons pressed
else buttons_used[k]=0;

for(k=0;k<num_hats;k++) 
if(SDL_JoystickGetHat(joy, k))
    hats_used[k]=2; // ignore buttons pressed
else hats_used[k]=0;

for(k=0;k<num_axis;k++)
{
axes_used[k]=0;   
                
axes[k]=SDL_JoystickGetAxis(joy,k);
} 
m=0;
while(1)
	{
    SDL_PollEvent(&event); 
	display_fondo1();
	
	tamletra=2;

	bkcolor=0;

    if(m<10)
	{
	color=0xfff0f0f0;
	if(manual==0)
	{
    	PX=40;PY=16;s_printf("Press UP/Down Arrows to Manual mode");             
     }
	PX=0;PY=screen_height-24; s_printf("ESC - Abort");
	PX+=48;
	if(manual) color=0xff0000f0;
    if(manual==0 || crt_manual==0) 
    {s_printf("ENTER - Unused Button");
    if(manual)
              {
              itoSprite(0xff0000f0 ,540,200,540+64,200+80,0);itoGsFinish();
              PX=540;PY=200;color=0xfff0f0f0;s_printf("Test");
              }
    }
    else if(m<5 || m==7 || m==8)
          {
           s_printf("ENTER - Button %u",crt_manual-1);
           if(SDL_JoystickGetButton(joy, crt_manual-1))
            itoSprite(0xff00f000 ,540,200,540+64,200+80,0);
           else itoSprite(0xff0000f0 ,540,200,540+64,200+80,0);itoGsFinish();
           PX=540;PY=200;color=0xfff0f0f0;s_printf("Test");
          }
    else if(m==9)
          {
          int s=SDL_JoystickGetAxis(joy,crt_manual-1);
           s_printf("ENTER - Axis %u",crt_manual-1);
            itoSprite(0xff0000f0 ,540,200,540+64,200+80,0);
            itoSprite(0xff00f000 ,540,200+39,540+64,200+40+(s>>10),0);
            itoGsFinish();
            PX=540;PY=200;color=0xfff0f0f0;s_printf("Test");
          }
    else if(m==5 || m==6)
         {
         if(crt_manual<=num_hats)  
                  {s_printf("ENTER - Hats %u",crt_manual-1);
                  
                   if(SDL_JoystickGetHat(joy, crt_manual-1))
                   itoSprite(0xff00f000 ,540,200,540+64,200+80,0);
                   else itoSprite(0xff0000f0 ,540,200,540+64,200+80,0);itoGsFinish();
                   PX=540;PY=200;color=0xfff0f0f0;s_printf("Test");
                  }
         else if(crt_manual<=num_hats+num_buttons) 
                  {s_printf("ENTER - Button %u",crt_manual-num_hats-1);
                   if(SDL_JoystickGetButton(joy, crt_manual-num_hats-1))
                   itoSprite(0xff00f000 ,540,200,540+64,200+80,0);
                   else itoSprite(0xff0000f0 ,540,200,540+64,200+80,0);itoGsFinish();
                   PX=540;PY=200;color=0xfff0f0f0;s_printf("Test");
                  }
         else {
              int s=SDL_JoystickGetAxis(joy,crt_manual-num_hats-num_buttons-1);
              s_printf("ENTER - Axis %u",crt_manual-num_hats-num_buttons-1);
              itoSprite(0xff0000f0 ,540,200,540+64,200+80,0);
              itoSprite(0xff00f000 ,540,200+39,540+64,200+40+(s>>10),0);
              itoGsFinish();
              PX=540;PY=200;color=0xfff0f0f0;s_printf("Test");
              }
         
         }
      
  
	}
	else
	{
	color=0xfff0f0f0;
	PX=0;PY=screen_height-24; s_printf("ENTER - Confirm");
	PX+=48;
    s_printf("ESC - Abort");
	}

	n=(screen_height>>1)-48*2-40;


	for(l=0;l<=m;l++)
	{
	PX=80;PY=n+l*32; color=0xffffffff;
	if(l==0)    bkcolor=0xff00b000;
	if(l==1)    bkcolor=0xff0000b0;
	if(l==2)	bkcolor=0xff00b0b0;
	if(l==3)	bkcolor=0xffb07000;
	if(l==4)	bkcolor=0xff0070b0;

	if(l<5)
		{s_printf(" Pad  #%i  ",l+1);
		}
	bkcolor=0;
	if(l==5) s_printf(" Pick Down");
	if(l==6) s_printf(" Pick Up  ");
	if(l==7) s_printf(" Select   ");
	if(l==8) s_printf(" Start    ");
	if(l==9) s_printf(" Wah-Wah  ");

	if(l==10) 
		{
        // nothing to do
		}
	else
 // F1-F5,Enter,esc,arriba,abajo,izquierda,derecha
		{
		
		if(l<m) 
         {
         if(keys[l]<0) s_printf(": Unused");
         else if(keys[l]<128) s_printf(": Button %u",keys[l]);
         else if(keys[l]<256) s_printf(": Axis %u",(keys[l]-128)>>1);
         else  s_printf(": Hat %u",keys[l]-256);
         }
      else{if(l==9) s_printf("(Must be an Axis)"); else 
           if((l<5) || l==7 || l==8) s_printf("(Must be a Button)");
           else s_printf("(Can be Button or Axis)");
           } 
		
		}


    }
tamletra=2;

if(m<10)
{

l=0;
if(manual==0)
{//manual
if(m!=9)
{
if(m==5)
{
for(k=0;k<num_hats;k++)
{
int ret;
ret=SDL_JoystickGetHat(joy, k);
if(ret<0) {continue;}

if(hats_used[k]==0)
{                         
if(ret) {hats_used[k]=1;l=k+256;break;}
}
else {if(hats_used[k]==2 && ret==0) hats_used[k]=0;} // libera boton bloqueado, si se solt�
   
}
}        
if(l==0)        
for(k=0;k<num_buttons;k++)
{
int ret;
ret=SDL_JoystickGetButton(joy, k);
if(ret<0) {continue;}

if(buttons_used[k]==0)
{                         
if(ret) {buttons_used[k]=1;l=k+1;break;}
}
else {if(buttons_used[k]==2 && ret==0) buttons_used[k]=0;} // libera boton bloqueado, si se solt�
   
}
}        


if(l==0 && (m>=5) && m!=7 && m!=8)
for(k=0;k<num_axis;k++)
{
int ret;
if(xbox360_guitar && (k==2 || k==3)) continue;  
if(axes_used[k]==0)    
{ret=SDL_JoystickGetAxis(joy,k)>>12;                 
if((axes[k]>>12)!=(ret) && (ret<-1 || ret>=0)) {axes_used[k]=1;l=128+(k<<1)+1*(ret>0);break;}
}


} 

if(l)
		{
                        
                        
		keys[m]=l-1*(l<128);
		
		if(m==5 && l>=128)
		{
        m++;
        if(l<256) keys[m]=l^1; // -axe
        else  keys[m]=l; // hat
        }
		m++;
	
    	for(k=0;k<num_buttons;k++)
        if(buttons_used[k]==0) 
        if(SDL_JoystickGetButton(joy, k))
          buttons_used[k]=2; // ignore buttons pressed 

       for(k=0;k<num_hats;k++) 
       if(hats_used[k]==0)
       if(SDL_JoystickGetHat(joy, k)) hats_used[k]=2; // ignore buttons pressed
       
		
		}
} // manual
}

	if(Read_Keyboard(0))
		{		
	    if(!manual)
	    {
        if(new_key & (KEY_UP | KEY_DOWN))
               {manual=1;crt_manual=0;continue;}
			if(new_key & (KEY_ENTER | KEY_F1))  
			{
			if(m==10) 
				{
				if(player==1)
					{
                    for(n=0;n<5;n++)
                      stick1_map_button[n]=keys[n];  
                  
                    //stick down
                 
                    if(keys[n]<128 || keys[n]>=256) {stick1_map_button[n]=keys[n]; stick1_map_axis[0]=-1;} 
                    else {stick1_map_button[n]=-1; stick1_map_axis[0]=((keys[n]-128)/*<<1*/);}
                    n++;
                    
                    //stick up
                 
                    if(keys[n]<128 || keys[n]>=256) {stick1_map_button[n]=keys[n]; stick1_map_axis[1]=-1;} 
                    else {stick1_map_button[n]=-1; stick1_map_axis[1]=((keys[n]-128)/*<<1*/);}
                    n++;
                    stick1_map_button[7]=keys[n];n++;
                    stick1_map_button[8]=keys[n];n++;
                    if(keys[n]>=128 && keys[n]<256)
                     { stick1_map_axis[2]=((keys[n]-128)/*<<1*/);}
                     else stick1_map_axis[2]=-1;
                    
    
					}
				 else
				    {
				    for(n=0;n<5;n++)
                      stick2_map_button[n]=keys[n];  
                  
                    //stick down
                 
                    if(keys[n]<128 || keys[n]>=256) {stick2_map_button[n]=keys[n]; stick2_map_axis[0]=-1;} 
                    else {stick2_map_button[n]=-1; stick2_map_axis[0]=((keys[n]-128)/*<<1*/);}
                    n++;
                    
                    //stick up
                 
                    if(keys[n]<128 || keys[n]>=256) {stick2_map_button[n]=keys[n]; stick2_map_axis[1]=-1;} 
                    else {stick2_map_button[n]=-1; stick2_map_axis[1]=((keys[n]-128)/*<<1*/);}
                    n++;
                    stick2_map_button[7]=keys[n];n++;
                    stick2_map_button[8]=keys[n];n++;
                    if(keys[n]>=128 && keys[n]<256)
                     { stick2_map_axis[2]=((keys[n]-128)/*<<1*/);}
                     else stick2_map_axis[2]=-1;
                    
    
					}
				
				break;
				}
				else {keys[m]=-1;m++;}
			}
			
      }
      else // manual
      {
       if(new_key & (KEY_DOWN))
        {
        int limit=0;
        if(m<9) limit+=num_buttons;
        if(m==5) limit+=num_hats;
        if(m==5 || m==9) limit+=num_axis;

        crt_manual++;
        if(crt_manual>limit) crt_manual=0;
        } 
      if(new_key & (KEY_UP))
        {
        int limit=0;
        if(m<9) limit+=num_buttons;
        if(m==5) limit+=num_hats;
        if(m==5 || m==9) limit+=num_axis;

        crt_manual--;
        if(crt_manual<0) crt_manual=limit;
        } 
      if(new_key & (KEY_ENTER | KEY_F1))  
        {
        keys[m]=-1;
        if(m==9)
         {
         if(crt_manual!=0) keys[m]=((crt_manual-1)<<1)+128; 
          m++;
         }
         else
         if(m==5 || m==6)
         {
          if(crt_manual!=0)
           {
           if(crt_manual<=num_hats) {keys[m]=(crt_manual-1) | 256; if(m==5) {m++;keys[m]=keys[m-1];} m++;}
           else if(crt_manual<=num_hats+num_buttons) {keys[m]=crt_manual-num_hats-1;m++;}
           else {keys[m]=(((crt_manual-num_hats-num_buttons-1)<<1) | (m==5)) | 128; if(m==5) {m++;keys[m]=keys[m-1]^1;} m++;}
           } else m++;
         }
         else
        if(m<5 || m==7 || m==8) {keys[m]=crt_manual-1;m++;}
        else
         if(m==10) 
				{
				if(player==1)
					{
                    for(n=0;n<5;n++)
                      stick1_map_button[n]=keys[n];  
                  
                    //stick down
                 
                    if(keys[n]<128 || keys[n]>=256) {stick1_map_button[n]=keys[n]; stick1_map_axis[0]=-1;} 
                    else {stick1_map_button[n]=-1; stick1_map_axis[0]=((keys[n]-128)/*<<1*/);}
                    n++;
                    
                    //stick up
                 
                    if(keys[n]<128 || keys[n]>=256) {stick1_map_button[n]=keys[n]; stick1_map_axis[1]=-1;} 
                    else {stick1_map_button[n]=-1; stick1_map_axis[1]=((keys[n]-128)/*<<1*/);}
                    n++;
                    stick1_map_button[7]=keys[n];n++;
                    stick1_map_button[8]=keys[n];n++;
                    if(keys[n]>=128 && keys[n]<256)
                     { stick1_map_axis[2]=((keys[n]-128)/*<<1*/);}
                     else stick1_map_axis[2]=-1;
                    
    
					}
				 else
				    {
				    for(n=0;n<5;n++)
                      stick2_map_button[n]=keys[n];  
                  
                    //stick down
                 
                    if(keys[n]<128 || keys[n]>=256) {stick2_map_button[n]=keys[n]; stick2_map_axis[0]=-1;} 
                    else {stick2_map_button[n]=-1; stick2_map_axis[0]=((keys[n]-128)/*<<1*/);}
                    n++;
                    
                    //stick up
                 
                    if(keys[n]<128 || keys[n]>=256) {stick2_map_button[n]=keys[n]; stick2_map_axis[1]=-1;} 
                    else {stick2_map_button[n]=-1; stick2_map_axis[1]=((keys[n]-128)/*<<1*/);}
                    n++;
                    stick2_map_button[7]=keys[n];n++;
                    stick2_map_button[8]=keys[n];n++;
                    if(keys[n]>=128 && keys[n]<256)
                     { stick2_map_axis[2]=((keys[n]-128)/*<<1*/);}
                     else stick2_map_axis[2]=-1;
                    
    
					}
				
				break;
          }
          crt_manual=0;
         ///
        
        }
        
      }	
		if(new_key & (KEY_ESC | KEY_F2))  
			{
          
			break;
			}
		}

flashs++;
SDL_PollEvent(&event);
	SDL_PumpEvents();SDL_Delay(20);itoSwitchFrameBuffers();
	}
  for(n=0;n<128;n++) Read_Keyboard(3);
#else // GEKKO

m=0;

if(isplayer2) 
	{
	 if(input_mode2==0 || input_mode2==3) crt_manual=1;
	}
else
	{
	 if(input_mode==0 || input_mode==3) crt_manual=1;
	}

if(crt_manual)
 {
 player=1+isplayer2;
  if(player==1)
   {
   if(stick1_map_button[1]==0x666) m=1;
   }
 else 
   {
   if(stick2_map_button[1]==0x666) m=1;
   }
 }
else
{
 if(player==1)
   {
   if(stick1_map_button[0]==0x666) m=1;
   if(stick1_map_button[0]==0x667) m=2;
   }
 else 
   {
   if(stick2_map_button[0]==0x666) m=1;
   if(stick2_map_button[0]==0x667) m=2;
   }
}

while(1)
	{
	display_fondo1();
	
	tamletra=2;

	bkcolor=0;

	itoSprite(0xff00f000 ,0,screen_height-48,32,screen_height,0);itoGsFinish();
	color=0xff000000;PX=4;PY=screen_height-24; s_printf("F1");
	color=0xfff0f0f0;
	PX=48;PY=screen_height-24; s_printf("Enter");
	PX+=32;
	
	
	
	n=(screen_height>>1)-48*2-32;

	#undef SKIPY 
	#define SKIPY 28
	
	PX=64;PY=n;
	color=0xff00f0f0;
	if(crt_manual==0)
	   s_printf("Wiimote Buttons For Player %i:", player);
    else
	   s_printf("Guitar Mode For Player %i:", player);
	n+=32*2;


    if(crt_manual==0)
	{
	if(m==0) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=64;PY=n; 
	s_printf("Config 1: ");
	color=0xfff0f0f0;
	bkcolor=0x8000ff00;s_printf("D.PAD");bkcolor=0x800000ff;s_printf("  A  ");bkcolor=0x8000ffff;s_printf(" - + ");
	bkcolor=0x80ff0000;s_printf("  1  ");bkcolor=0x800080ff;s_printf("  2  ");bkcolor=0;
	
	n+=SKIPY;

	if(m==1) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=64;PY=n; 
	
	s_printf("Config 2: ");
	color=0xfff0f0f0;
	bkcolor=0x8000ff00;s_printf("  B  ");bkcolor=0x800000ff;s_printf("D.PAD");bkcolor=0x8000ffff;s_printf("  A  ");
	bkcolor=0x80ff0000;s_printf("  1  ");bkcolor=0x800080ff;s_printf("  2  ");bkcolor=0;
	
	n+=SKIPY;

	if(m==2) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=64;PY=n; 
   
    s_printf("Config 3: ");
    color=0xfff0f0f0;
	bkcolor=0x8000ff00;s_printf("D.PAD");bkcolor=0x800000ff;s_printf("  A  ");bkcolor=0x8000ffff;s_printf("  1  ");
	bkcolor=0x80ff0000;s_printf("  2  ");bkcolor=0x800080ff;s_printf(" - + ");bkcolor=0;
  
	n+=SKIPY;

	if(m==3) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=64;PY=n; 
   
    s_printf("Exit");
    
  
	n+=SKIPY;
    
	n+=64;
	color=0xfff0f0f0;
    PX=64;PY=n; 
   
    s_printf("With Nunchuk Expansion");
	n+=SKIPY;
	PX=64;PY=n; 
    color=0xfff0f0f0;
	s_printf("          ");
	bkcolor=0x8000ff00;s_printf("  Z  ");bkcolor=0x800000ff;s_printf("  C  ");bkcolor=0x8000ffff;s_printf("  A  ");
	bkcolor=0x80ff0000;s_printf("  B  ");bkcolor=0x800080ff;s_printf("D.PAD");bkcolor=0;
	}
	else // define guitarra
	{
	if(m==0) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=64;PY=n; 
	s_printf("Config 1: Guitar Hero III Wii");
	n+=SKIPY;

	if(m==1) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=64;PY=n; 
	s_printf("Config 2: From GameCube Adaptor");
	n+=SKIPY;

	if(m==2) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=64;PY=n; 
   
    s_printf("Exit");
    
  
	n+=SKIPY;
	}
	#undef SKIPY 

		if(Read_Keyboard(0))
		{
		
		if(crt_manual) // define guitar
			{
			if(new_key & KEY_UP) {if(m>0) m--; else m=2;}
			if(new_key & KEY_DOWN) {if(m<2) m++; else m=0;}
			
			if(new_key & (KEY_ENTER | KEY_F1)) 
				{
				if(m==0) {if(player==1) stick1_map_button[1]=0x665; else stick2_map_button[1]=0x665; break;}
				if(m==1) {if(player==1) stick1_map_button[1]=0x666; else stick2_map_button[1]=0x666; break;}
				
				if(m==2) break;
				}
			}
		else        // define pad
			{
			if(new_key & KEY_UP) {if(m>0) m--; else m=3;}
			if(new_key & KEY_DOWN) {if(m<3) m++; else m=0;}
			
			if(new_key & (KEY_ENTER | KEY_F1)) 
				{
				if(m==0) {if(player==1) stick1_map_button[0]=0x665; else stick2_map_button[0]=0x665; break;}
				if(m==1) {if(player==1) stick1_map_button[0]=0x666; else stick2_map_button[0]=0x666; break;}
				if(m==2) {if(player==1) stick1_map_button[0]=0x667; else stick2_map_button[0]=0x667; break;}
			
				if(m==3) break;
				}
			}
	
		if(new_key & (KEY_F2)) 
			{
			break;
			}
		}


	if(readpad(2))
		{
	
		if(crt_manual) // define guitar
			{
			if(new_pad & PAD_UP) {if(m>0) m--; else m=2;}
			if(new_pad & PAD_DOWN) {if(m<2) m++; else m=0;}

			if(new_pad & PAD_1)
				{
				if(m==0) {if(player==1) stick1_map_button[1]=0x665; else stick2_map_button[1]=0x665; break;}
				if(m==1) {if(player==1) stick1_map_button[1]=0x666; else stick2_map_button[1]=0x666; break;}
				
				if(m==2) break;
				}
			}
        else   // define pad
			{
		    if(new_pad & PAD_UP) {if(m>0) m--; else m=3;}
			if(new_pad & PAD_DOWN) {if(m<3) m++; else m=0;}
			
			if(new_pad & PAD_1) 
				{
				if(m==0) {if(player==1) stick1_map_button[0]=0x665; else stick2_map_button[0]=0x665; break;}
				if(m==1) {if(player==1) stick1_map_button[0]=0x666; else stick2_map_button[0]=0x666; break;}
				if(m==2) {if(player==1) stick1_map_button[0]=0x667; else stick2_map_button[0]=0x667; break;}
				if(m==3) break;
				}
			}
			
	
		if(new_pad & (PAD_2)) 
			{
			break;
			}
		}

   
	GetEvent();
	
	itoSwitchFrameBuffers();
	}
#endif
}

void menu_input()
{
int n,m;

m=0;
while(1)
	{
	display_fondo1();
	
	tamletra=2;

	bkcolor=0;

	itoSprite(0xff00f000 ,0,screen_height-48,32,screen_height,0);itoGsFinish();
	color=0xff000000;PX=4;PY=screen_height-24; s_printf("F1");
	color=0xfff0f0f0;
	PX=48;PY=screen_height-24; s_printf("Enter");
	PX+=32;
	
	
	
	n=(screen_height>>1)-48*2-32;

	#undef SKIPY 
	#define SKIPY 28
	
	PX=64;PY=n;
	color=0xff00f0f0;
	s_printf("Player 1:");

	n+=32;
	if(m==0) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; 
	if(zurdo==0) s_printf("Right-handed");
	else s_printf("Left-handed");
	n+=SKIPY;

	if(m==1) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; 
	
	if(input_mode==0) s_printf("Current Input: Guitar 1");
	if(input_mode==1) s_printf("Current Input: Pad 1");
	if(input_mode==2) s_printf("Current Input: Keyboard");
	if(input_mode==3) s_printf("Current Input: Guitar 2");
	if(input_mode==4) s_printf("Current Input: Pad 2");
	
	
	n+=SKIPY;

	if(m==2) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; 
   
    if(input_mode==0) s_printf("Define Guitar 1");
	if(input_mode==1) s_printf("Define Pad 1");
	if(input_mode==2) s_printf("Define Keyboard");
	if(input_mode==3) s_printf("Define Guitar 2");
	if(input_mode==4) s_printf("Define Pad 2");
    
    n+=32;

	// two

	PX=64;PY=n;
	color=0xff00f0f0;
	s_printf("Player 2:");

	n+=32;
	if(m==3) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; 
	if(two_zurdo==0) s_printf("Right-handed");
	else s_printf("Left-handed");
	n+=SKIPY;

	if(m==4) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; 
	
	if(input_mode2==0) s_printf("Current Input: Guitar 2");
	if(input_mode2==1) s_printf("Current Input: Pad 2");
	if(input_mode2==2) s_printf("Current Input: Keyboard");
	if(input_mode2==3) s_printf("Current Input: Guitar 1");
	if(input_mode2==4) s_printf("Current Input: Pad 1");
	
	n+=SKIPY;

	if(m==5) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; 
	
    if(input_mode2==0) s_printf("Define Guitar 2");
	if(input_mode2==1) s_printf("Define Pad 2");
	if(input_mode2==2) s_printf("Define Keyboard");
	if(input_mode2==3) s_printf("Define Guitar 1");
	if(input_mode2==4) s_printf("Define Pad 1");
    
    n+=SKIPY;

	if(m==6) color=0xff00ff00;
	else color=0xff00f0f0;
	PX=64;PY=n;
	if(rumbledis==0) s_printf("Disable Rumble");
	else s_printf("Enable Rumble");
	n+=SKIPY;

	if(m==7) color=0xff00ff00;
	else color=0xff00f0f0;
	PX=64;PY=n; s_printf("Exit");n+=SKIPY;
	
	#undef SKIPY 

		if(Read_Keyboard(0))
		{
		
		if(new_key & KEY_UP) {if(m>0) m--; else m=7;}
		if(new_key & KEY_DOWN) {if(m<7) m++; else m=0;}
			
		if(new_key & (KEY_ENTER | KEY_F1)) 
			{
			if(m==0) zurdo^=1;
			if(m==1) {input_mode++;if(input_mode>4) input_mode=0;}
			if(m==2) {if(input_mode==2) menu_definekeys(1); else if(input_mode<2) menu_definepad(1); else menu_definepad(2); new_key=new_pad=0;}
			if(m==3) two_zurdo^=1;
			if(m==4) {input_mode2++;if(input_mode2>4) input_mode2=0;}
			if(m==5) {if(input_mode2==2) menu_definekeys(2); else if(input_mode2<2) menu_definepad(128+2); else menu_definepad(128+1); new_key=new_pad=0;}
			if(m==6) rumbledis^=1;
			if(m==7) break;
			}
		if(new_key & (KEY_F2)) 
			{
			break;
			}
		}


	if(readpad(2))
		{
		
		if(new_pad & PAD_UP) {if(m>0) m--; else m=7;}
		if(new_pad & PAD_DOWN) {if(m<7) m++; else m=0;}
			
		if(new_pad & ( PAD_1)) 
			{
			if(m==0) zurdo^=1;
			if(m==1) {input_mode++;if(input_mode>4) input_mode=0;}
			if(m==2) {if(input_mode==2) menu_definekeys(1); else if(input_mode<2) menu_definepad(1); else menu_definepad(2); new_key=new_pad=0;}
			if(m==3) two_zurdo^=1;
			if(m==4) {input_mode2++;if(input_mode2>4) input_mode2=0;}
			if(m==5) {if(input_mode2==2) menu_definekeys(2); else if(input_mode2<2) menu_definepad(128+2); else menu_definepad(128+1); new_key=new_pad=0;}
			if(m==6) rumbledis^=1;
			if(m==7) break;
			}
		if(new_pad & (PAD_2)) 
			{
			break;
			}
		}

    #ifndef GEKKO
	SDL_PollEvent(&event);SDL_Delay(20);
	#else
	GetEvent();
	#endif
	
	itoSwitchFrameBuffers();
	}

}

void osd_1(char *str)
{
tamletra=1;
PX=(640-32*strlen(str))>>1;
PY=(screen_height-32)>>1;
s_printf(str);
}
static u8 memcard_buffer[2048] __attribute__((aligned(16)));

int memcardsave(char *name,char *dat,int len) 
{
int n,mfd,m;


#ifdef GEKKO
char name2[256];
sprintf(name2,"%s%s",main_dir,name);
name=name2;
#endif

mfd=open(name, O_CREAT | O_WRONLY | O_BINARY, S_IWRITE | S_IREAD);
if ( mfd < 0 ){
             
          return -1; // memcard no presente o fichero no se pudo crear
        }
 lseek(mfd,0,0);    
 m=len;
 while(m>0)
 {
 n=m;if(n>2048) n=2048;
 memcpy(memcard_buffer,dat,n);
 n=write(mfd,memcard_buffer,n);
 if(n<=0) break;
 dat+=n;
 m-=n;
 
 }
 close(mfd);
  
if(m==0) return 0; else return 1; // 0-ok 1- truncated

}
// *len debe  recibir el tama�o maximo a leer
int memcardload(char *name,char *dat,int *len) 
{
int n,mfd,m;
int readed;

#ifdef GEKKO
char name2[256];
sprintf(name2,"%s%s",main_dir,name);
name=name2;
#endif

mfd=open(name, O_RDWR | O_BINARY,S_IWRITE | S_IREAD);
if ( mfd < 0 ){
             
          return -1; // memcard no presente o fichero no se pudo abrir
        }
 m= lseek(mfd,0,2);     
if(m>*len)   {close(mfd);return 2;} // fichero demasiado grande
 lseek(mfd,0,0);
 readed=0;
 while(m>0)
 {
 n=m;if(n>2048) n=2048;
 n=read(mfd,memcard_buffer,n);
 if(n>0) memcpy(dat,memcard_buffer,n);
if(n<=0) break;
 dat+=n;
 m-=n;
 
 readed+=n;
 if(n<2048) break;
 }
 close(mfd);
 *len=readed;
if(m==0) return 0; else return 1; // 0-ok 1- truncated

}


int save_songs_datas()
{
int n,m,r,mfd,s;

char *dat;
#ifdef GEKKO
char name2[256];

#endif


configuration.id=0x1cacafea;
configuration.video=MODEVIDEO;
configuration.hand=zurdo | (two_zurdo<<1);
configuration.volume=pcm_volume;
configuration.div1=sound1_div;
configuration.div2=sound2_div;
configuration.effects_volume=effects_volume;
configuration.input_mode=input_mode | (input_mode2<<4);
configuration.rumble=rumbledis;
for(n=0;n<10;n++) configuration.keyboard[n]=keys_raw[n];
for(n=0;n<10;n++) configuration.keyboard[n+10]=keys_raw2[n];
for(n=0;n<9;n++) configuration.stick1_map_button[n]=stick1_map_button[n];
for(n=0;n<9;n++) configuration.stick2_map_button[n]=stick2_map_button[n];
for(n=0;n<3;n++) configuration.stick1_map_axis[n]=stick1_map_axis[n];
for(n=0;n<3;n++) configuration.stick2_map_axis[n]=stick2_map_axis[n];
configuration.audio_loop=current_audio_loop_divider; 
configuration.gamma=(int) (gl_gamma*1000.0f);

if(memcardsave("guitarfun.dat", (char *) &configuration, sizeof configuration)!=0) return -1;

#ifdef GEKKO
sprintf(name2,"%s%s",main_dir,"songs_score.dat");
mfd=open(name2, O_RDWR | O_BINARY,S_IWRITE | S_IREAD);
#else
mfd=open("songs_score.dat", O_RDWR | O_BINARY,S_IWRITE | S_IREAD);
#endif
if ( mfd < 0 ) 
	{
    //printf("fail1\n");return -1;
	if(memcardsave("songs_score.dat", (char *) &data_memory, sizeof data_memory)!=0)  {printf("fail1\n");return -1; }
	for(n=0;n<128;n++)
	{
	if((data_memory.songs[n].older & 0xff000000)==0x1000000) // update
		{
		data_memory.songs[n].older&=0xffffff;
		}
	}
	return 0;
	}

lseek(mfd,4,0);
m=4;

for(n=0;n<128;n++)
	{
	r=lseek(mfd,m+n*sizeof(data_songs),0);
	if(r<0) goto exit;
	if((data_memory.songs[n].older & 0xff000000)==0x1000000) // update
		{
		data_memory.songs[n].older&=0xffffff;
		dat=(char *) &data_memory.songs[n]; s= sizeof(data_songs);

		while(s>0)
			{
			r=s;if(r>2048) r=2048;
			memcpy(memcard_buffer,dat,r);

			r=write(mfd, memcard_buffer, r);
			if(r<=0) break;


			s-=r;dat+=r;
			}
			if(s) goto exit;
		}

	}

close(mfd);
return 0;

exit:
printf("fail3\n");
close(mfd);
return -1;
}

int menu_video()
{
int n,m;

int count_1=0;
int count_2=0;
int count_3=0;
int count_4=0;

m=MODEVIDEO & 3;
while(1)
	{
	display_fondo1();
	
	tamletra=2;

	bkcolor=0;

	itoSprite(0xff00f000 ,0,screen_height-48,32,screen_height,0);itoGsFinish();
	color=0xff000000;PX=4;PY=screen_height-24; s_printf("F1");
	color=0xfff0f0f0;
	PX=48;PY=screen_height-24; 
    if(m!=4) s_printf("Enter");
     else {s_printf("Increase");PX+=16;
	      itoSprite(0xff0000f0 ,PX,screen_height-48,PX+32,screen_height,0);itoGsFinish();
	      color=0xff000000;PX+=2;PY=screen_height-24; s_printf("F2");
	      color=0xfff0f0f0;
	      PX+=16;s_printf("Decrease");
       }
	
	
	#undef SKIPY 
	#define SKIPY 32
	n=(screen_height>>1)-56*2;

	if(m==0) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("Window 640x480");n+=SKIPY;

	if(m==1) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("Window 720x480");n+=SKIPY;

	if(m==2) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("Full 640x480");n+=SKIPY;

	if(m==3) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("Full 720x480");
	n+=SKIPY;

	if(m==4) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("Gamma Correction: %2.2f",gl_gamma);n+=SKIPY;

	if(m==5) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("Exit");n+=SKIPY;

	
	
	
	
	#undef SKIPY 
	if(Read_Keyboard(0))
		{
		
		if(new_key & KEY_UP) {if(m>0) m--; else m=5;}
		if(new_key & KEY_DOWN) {if(m<5) m++; else m=0;}
		if(old_key & (KEY_F1 | KEY_ENTER)) 	
		  {
          count_1++;if(count_1>50) {count_1=45;new_key=old_key & (KEY_F1 | KEY_ENTER);}
          } else count_1=0;
        if(old_key & (KEY_F2 | KEY_ESC)) 	
		  {
          count_2++;if(count_2>50) {count_2=45;new_key=old_key & (KEY_F2 | KEY_ESC);}
          } else count_2=0;
          
		if(new_key & (KEY_F1 | KEY_ENTER)) 
			{
		
			if(m==5) {new_key=new_pad=0;return 1;}
		    if(m==4)
             {
             gl_gamma+=.025f;
             if(gl_gamma>4.0f) gl_gamma=4.0f;
            
 
             itoGamma(gl_gamma);
             
             }
			if(m<4)
			{
            MODEVIDEO=m;
            InitVideomode();
		
         
			uploadsubletter(1);
			ClearScreen(0xff000000); // borra los dos bufferes de pantalla
			//itoSwitchFrameBuffers();set_border(border);
			PX=PY=0;color=0xffffffff;bkcolor=0;tamletra=2;
		       
            if(background) UploadTexture(TEXT_PRI,256, 256,background, 16);
            else UploadTexture(TEXT_PRI,128, 64,bitmaps_sprite_16, 16);

            load_bmp_texture(guitarra_bmp, texture,1);
            UploadTexture(TEXT_PRI+1,128, 128,texture, 16);
            UploadTexture(TEXT_PRI+2,128, 64,bitmaps_sprite_13, 16);
            //UploadTexture(TEXT_PRI+3,128,32,bitmaps_sprite_14, 16); 
			UploadTexture(TEXT_PRI+3,logo_sprite_2_sx,logo_sprite_2_sy,logo_sprite_2, 16);
            
			itoZTest(FALSE);
            new_key=new_pad=0;return 0;
            }
		
			}
			if(new_key & (KEY_ESC)) {new_key=new_pad=0;return 1;}
		    if(new_key & (KEY_F2)) 
			{
             if(m==4)
             {
             gl_gamma-=.025f;
             if(gl_gamma<0.5f) gl_gamma=0.5f;
            
             itoGamma(gl_gamma);
             
             }
             else {new_key=new_pad=0;return 1;}
            }

	    

		

		}

	if(readpad(2))
		{
		
		if(new_pad & PAD_UP) {if(m>0) m--; else m=5;}
		if(new_pad & PAD_DOWN) {if(m<5) m++; else m=0;}
		
		if(old_pad & (PAD_1)) 	
		  {
          count_3++;if(count_3>50) {count_3=45;new_pad=old_pad & (PAD_1);}
          } else count_3=0;
        if(old_pad & (PAD_2)) 	
		  {
          count_4++;if(count_4>50) {count_4=45;new_pad=old_pad & (PAD_2);}
          } else count_4=0;
			
		if((new_pad & ( PAD_1)) ) 
			{
			if(m==5) {new_key=new_pad=0;return 1;}
			 if(m==4)
             {
             gl_gamma+=.025f;
             if(gl_gamma>4.0f) gl_gamma=4.0f;
            
 
             itoGamma(gl_gamma);
       
             }
			if(m<4)
			{
            MODEVIDEO=m;
            InitVideomode();
		
         
			uploadsubletter(1);
			ClearScreen(0xff000000); // borra los dos bufferes de pantalla
			PX=PY=0;color=0xffffffff;bkcolor=0;tamletra=2;
			
			if(background) UploadTexture(TEXT_PRI,256, 256,background, 16);
            else UploadTexture(TEXT_PRI,128, 64,bitmaps_sprite_16, 16);

            load_bmp_texture(guitarra_bmp, texture,1);
            UploadTexture(TEXT_PRI+1,128, 128,texture, 16);
            UploadTexture(TEXT_PRI+2,128, 64,bitmaps_sprite_13, 16);
            //UploadTexture(TEXT_PRI+3,128,32,bitmaps_sprite_14, 16); 
			UploadTexture(TEXT_PRI+3,logo_sprite_2_sx,logo_sprite_2_sy,logo_sprite_2, 16);
			itoZTest(FALSE);
			new_key=new_pad=0;return 0;
            
            }
            }
		if((new_pad & ( PAD_2)) ) 
			{	
             if(m==4)
             {
             gl_gamma-=.025f;
             if(gl_gamma<0.5f) gl_gamma=0.5f;
            
             itoGamma(gl_gamma);
             }
             else {new_key=new_pad=0;return 1;}
            
            }
	


		}
	#ifndef GEKKO
	SDL_PollEvent(&event);SDL_Delay(20);
	#else
	GetEvent();
	#endif
	itoSwitchFrameBuffers();
	}
}

void menu_principal()
{
int n,m;

int video_alert=0;


	
#ifndef DEVELOP	
if(mc_test & 2) 
			   {
			   display_fondo1();tamletra=2;bkcolor=0;color=0xff00f0f0;
			   PX=640-23*16;PY=0; s_printf("Reading the Memory Card");
			   #ifndef GEKKO
			   SDL_PollEvent(&event);SDL_Delay(20);
			   #else
	             GetEvent();
			   #endif
			   itoSwitchFrameBuffers();
			   n=sizeof configuration;
			   if(memcardload("guitarfun.dat",(char *) &configuration,&n)!=0){ mc_test|=2;}
               else 
				 {
				  mc_test&=1; 
				  n=sizeof data_memory;
                  memcardload("songs_score.dat",(char *) &data_memory,&n);
				  get_mem_card_datas();
				 }
			   }
#endif

m=0;
while(1)
	{
	display_fondo1();
	
	tamletra=2;

	bkcolor=0;

	itoSprite(0xff00f000 ,0,screen_height-48,32,screen_height,0);itoGsFinish();
	color=0xff000000;PX=4;PY=screen_height-24; s_printf("F1");
	color=0xfff0f0f0;
	PX=48;PY=screen_height-24; s_printf("Enter");
	PX+=32;
	
	s_printf("SELECT/TAB - To Change Video");
	
	#undef SKIPY 
	#define SKIPY 32
	n=(screen_height>>1)-56*2;

	if(m==0) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("Single Player");n+=SKIPY;

	if(m==1) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("Multiplayer");n+=SKIPY;

	if(m==2) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("Refresh Songs");n+=SKIPY;

	if(m==3) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; 
	s_printf("Input Options");
	n+=SKIPY;

	if(m==4) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("Sound Options");n+=SKIPY;

	if(m==5) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("Greets");n+=SKIPY;

	if(m==6) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("License Agreement");n+=SKIPY;
	
	if(m==7) color=0xff00ff00;
	else color=0xfff0f0f0;
	PX=80;PY=n; s_printf("Program Exit");n+=SKIPY;
	
	if(video_alert)
	{
    video_alert--;
    color=0xff00f0f0;
	
	
    if(MODEVIDEO==0)
	 {
     osd_1("WINDOW 4:3");
     }
    if(MODEVIDEO==1)
	 {
     osd_1("WINDOW 16:9");
     }
    if(MODEVIDEO==2)
	 {
     osd_1("FULLSCREEN 4:3");
     }
    if(MODEVIDEO==3)
	 {
     osd_1("FULLSCREEN 16:9");
     }
 
    }
	
	#undef SKIPY 
	if(Read_Keyboard(0))
		{
		
		if(new_key & KEY_UP) {if(m>0) m--; else m=7;}
		if(new_key & KEY_DOWN) {if(m<7) m++; else m=0;}
	#ifndef GEKKO
		if(new_key & (KEY_ESC)) 
        {
        // exit 
        exit(0);
        }	
	#endif
		if(new_key & (KEY_F1 | KEY_ENTER)) 
			{
			if(m==0 || m==1 || m==7) 
				{
				if(m==1) twoplayers=1; else twoplayers=0;
#ifndef DEVELOP	
			   display_fondo1();tamletra=2;bkcolor=0;color=0xff00f0f0;
			   PX=640-23*16;PY=0; s_printf("Writing the Memory Card");
			   #ifndef GEKKO
			   SDL_PollEvent(&event);SDL_Delay(20);
			   #else
	             GetEvent();
			   #endif
			   itoSwitchFrameBuffers();

				if(save_songs_datas()!=0)
				{
				ClearScreen(0xff000000);
				PX=16;
				PY=16;
				color=0xffffffff;
				s_printf("MEMORY CARD: ERROR SAVING SONG DATAS");
				#ifndef GEKKO
				SDL_PollEvent(&event);itoSwitchFrameBuffers();SDL_Delay(1000);
				#else
	            GetEvent();
				itoSwitchFrameBuffers();Delay(1000);
				#endif
				
				}

#endif 
                if(m==7) exit(0);
				return;
			    }
			if(m==2) {get_files();ordena_especial2();}
			if(m==3) {menu_input();new_key=new_pad=0;}
			if(m==4) {menu_sound();new_key=new_pad=0;}
			if(m==5) {license_screen(credits_txt,size_credits_txt); border=0xff000000;itoClear(0xff000000);itoSwitchFrameBuffers();itoClear(0xff000000);new_key=new_pad=0;}
			if(m==6) {license_screen(licenses_txt,size_licenses_txt);border=0xff000000; itoClear(0xff000000);itoSwitchFrameBuffers();itoClear(0xff000000);new_pad=0;}
		    //m==7 exit
			}

	    	if(new_key & KEY_F5) // SDLK_TAB
			{
          
			if(!menu_video()) video_alert=5000/20;

			}

		

		}

	if(readpad(2))
		{
		
		if(new_pad & PAD_UP) {if(m>0) m--; else m=7;}
		if(new_pad & PAD_DOWN) {if(m<7) m++; else m=0;}
			
		if((new_pad & ( PAD_1)) ) 
			{
			itoSwitchFrameBuffers();
			if(m==0 || m==1 || m==7) 
				{
				if(m==1) twoplayers=1; else twoplayers=0;
                 
#ifndef DEVELOP	
			   display_fondo1();tamletra=2;bkcolor=0;color=0xff00f0f0;
			   PX=640-23*16;PY=0; s_printf("Writing the Memory Card");
			  #ifndef GEKKO
			  SDL_PollEvent(&event);SDL_Delay(20);
			  #else
	            GetEvent();
			  #endif
			  itoSwitchFrameBuffers();

				if(save_songs_datas()!=0)
				{
				ClearScreen(0xff000000);
				PX=16;
				PY=16;
				color=0xffffffff;
				s_printf("MEMORY CARD: ERROR SAVING SONG DATAS");
				#ifndef GEKKO
					SDL_PollEvent(&event);itoSwitchFrameBuffers();SDL_Delay(1000);
				#else
	                GetEvent();
				    itoSwitchFrameBuffers();Delay(1000);
				#endif
				}

#endif
                if(m==7) exit(0);
				return;
			    }
			if(m==2) {get_files();ordena_especial2();}
			if(m==3)  {menu_input();new_key=new_pad=0;}
			if(m==4) {menu_sound();new_pad=0;}
			if(m==5) {license_screen(credits_txt,size_credits_txt);border=0xff000000;itoClear(0xff000000);itoSwitchFrameBuffers();itoClear(0xff000000);new_key=new_pad=0;}
			if(m==6) {license_screen(licenses_txt,size_licenses_txt);border=0xff000000;itoClear(0xff000000);itoSwitchFrameBuffers();itoClear(0xff000000);new_key=new_pad=0;}
		    //if(m==7) exit(0);
			}

		if(new_pad & PAD_SELECT)
			{
			if(!menu_video()) video_alert=5000/20;
			}

		}
	#ifndef GEKKO
	SDL_PollEvent(&event);SDL_Delay(20);
	#else
	   GetEvent();
	#endif
	itoSwitchFrameBuffers();
	}
}

int main_select_list()
{
int fd,fd2,fd3,n,m,play=0,r;
int midi_levels=0;
int level=0;
int nlevels=0;
int retain=100;
int retain2=100;
int loading=0;

int instrument=0;

int failed=-1;

int mode=0;

int count_list=50;

play=1;

flag_tresnotas=0;

midi_ritmo=0;
mid_speed=4;
 

modeplayers=0;
#ifdef GEKKO
itoSetFrameHalt(1);
mod_track.paused=1;
#endif
while(1)
{
if(!play) {count_list--;if(count_list<0) {play=1;count_list=50;}}

if(n_list_songs<=0) {get_files();ordena_especial2();}

if(n_list_songs<=0) 
	{
    return 0;
	}

if(tema>=n_list_songs) tema=0;

display_fondo1();

bkcolor=0;

if(mode==0)
{
m=tema-4;
tamletra=2;
#ifdef GEKKO
mod_track.paused=1;
#endif
modeplayers=0;

itoSprite(0xff00f000 ,0,screen_height-48,32,screen_height,0);itoGsFinish();
color=0xff000000;PX=4;PY=screen_height-24; s_printf("F1");
	color=0xfff0f0f0;
	PX=48;PY=screen_height-24; s_printf("Play");
	PX+=16;
	itoSprite(0xff0000f0 ,PX,screen_height-48,PX+32,screen_height,0);itoGsFinish();
	color=0xff000000;PX+=2;PY=screen_height-24; s_printf("F2");
	color=0xfff0f0f0;
	PX+=16;s_printf("Exit");


r=16;
for(n=0;n<8;n++)
	{
	bkcolor=0;
	if(m<0) m=0;
	if(m>=n_list_songs) {break;}

	if(m>0)
		{
		if(strncmp(list_songs[m-1].group,list_songs[m].group,32))
			{
			color=0xffff9090;
			PX=0;PY=r+16; s_printf(" %s",list_songs[m].group);
			r+=50;n++;
			}
		}
		else
		{
		color=0xffff9090;
			PX=0;PY=r+16; s_printf(" %s",list_songs[m].group);
			r+=50;n++;
		}
	if(n>=8) break;

	
	if(m==tema) color=0xff00ff00;
	else color=0xff00f0f0;
	
	PX=0;PY=r; s_printf(" %s",list_songs[m].title);
	if(m==tema) color=0xffffff00;
	else color=0xffa0a0a0;
	PX=0;PY=r+20;s_printf(" %s",list_songs[m].artist);
	r+=50;
	m++;
	}
instrument=0;
}
else
if(mode==1)
{
tamletra=2;
#ifdef GEKKO
mod_track.paused=0;
#endif

itoSprite(0xff00f000 ,0,screen_height-48,32,screen_height,0);itoGsFinish();
color=0xff000000;PX=4;PY=screen_height-24; s_printf("F1");
	color=0xfff0f0f0;
	PX=48;PY=screen_height-24; s_printf("Continue");
	PX+=16;

PY=(screen_height/2)-130+16;

if(twoplayers)
	{
	n=0;
	PX=100;
	if(instrument==n) color=0xff00ff00; else color=0xffc0c0c0;
	s_printf("Guitar Battle");PY+=30;n++;
	PX=100;
	if(instrument==n) color=0xff00ff00; else color=0xffc0c0c0;
	s_printf("Cooperative");PY+=30;n++;
	}
else
	{
	n=0;
	PX=100;
	if(instrument==n) color=0xff00ff00; else color=0xffc0c0c0;
	s_printf("GUITAR");PY+=30;n++;
	PX=100;
	if(instrument==n) color=0xff00ff00; else color=0xffc0c0c0;
	s_printf("RHYTHM");PY+=30;n++;
	}

}
else
if(mode==2)
{

tamletra=2;
tamletra=2;
#ifdef GEKKO
mod_track.paused=0;
#endif
itoSprite(0xff00f000 ,0,screen_height-48,32,screen_height,0);itoGsFinish();
color=0xff000000;PX=4;PY=screen_height-24; s_printf("F1");
	color=0xfff0f0f0;
	PX=48;PY=screen_height-24; s_printf("Continue");
	PX+=16;
	itoSprite(0xff0000f0 ,PX,screen_height-48,PX+32,screen_height,0);itoGsFinish();
	color=0xff000000;PX+=2;PY=screen_height-24; s_printf("F2");
	color=0xfff0f0f0;
	PX+=16;s_printf("Exit  SEL/TAB - Training");

PY=(screen_height/2)-130+16;
nlevels=0;
n=0;
PX=100;
if(level==n) color=0xff00ff00; else color=0xffc0c0c0;
if((midi_levels>>(instrument<<3)) & EASY_LEVEL) {s_printf("EASY");PY+=30;nlevels++;n++;}
PX=100;
if(level==n) color=0xff00ff00; else color=0xffc0c0c0;
if((midi_levels>>(instrument<<3)) & MEDIUM_LEVEL) {s_printf("MEDIUM");PY+=30;nlevels++;n++;}
PX=100;
if(level==n) color=0xff00ff00; else color=0xffc0c0c0;
if((midi_levels>>(instrument<<3)) & HARD_LEVEL) {s_printf("HARD");PY+=30;nlevels++;n++;}
PX=100;
if(level==n) color=0xff00ff00; else color=0xffc0c0c0;
if((midi_levels>>(instrument<<3)) & EXPERT_LEVEL) {s_printf("EXPERT");PY+=30;nlevels++;n++;}
PX=100;
if(level==n) color=0xff00ff00; else color=0xffc0c0c0;
s_printf("3 KEYS SPECIAL");PY+=30;nlevels++;n++;
}

if(loading==0 && play && n_list_songs>0 && mode==0)
	{
	loading=1;
	color=0xff00ffff;
	itoClearZ();
	PX=640-10*16;PY=0;
	s_printf("Playing...");

	}
#ifndef GEKKO
SDL_PollEvent(&event);
SDL_Delay(20);
#else
	GetEvent();
#endif
if(loading<2)
	{
	 itoSwitchFrameBuffers();
	
	}
 new_pad =0;
if(loading) loading++;
 if(loading==0)
	{

 if(Read_Keyboard(0))
		{
		if(n_list_songs>0)
		{
		if(mode==0)
		{
		if((new_key & KEY_UP) || ((old_key & KEY_UP) && retain2==0)) 
			{if(new_key & KEY_UP) retain2=25; else retain2=5;if(tema>0) tema--;count_list=50;}
		if((new_key & KEY_DOWN) || ((old_key & KEY_DOWN) && retain2==0))
			{if(new_key & KEY_DOWN) retain2=25; else retain2=5;if(tema<(n_list_songs-1)) tema++;count_list=50;}

		if(retain2) retain2--;
		
		}
		else
		if(mode==1)
		{
		
		if(new_key & KEY_UP) {if(instrument>0) instrument--;}
		if(new_key & KEY_DOWN) {if(instrument<(1)) instrument++;}
		
		}
		
		else
			{
			if(new_key & KEY_UP) {if(level>0) level--;}
			if(new_key & KEY_DOWN) {if(level<(nlevels-1)) level++;}
			}
		if((new_key & KEY_F5) && mode==2) {mid_speed=3;new_key|=PAD_1;}
		if(new_key & (KEY_F1 | KEY_ENTER)) 
			{
			
			if(mode==0)
			{
			for(n=0;n<MAX_NOTES;n++) {nota[n]=0;two_nota[n]=0;}
			sprintf(pathname,"%srhythm.ogg",list_songs[tema].path);
			n=open(pathname,O_RDONLY | O_BINARY, S_IREAD);
			if(n>=0) {close(n);midi_ritmo=1;} else midi_ritmo=0;
			
			sprintf(pathname,"%snotes.mid",list_songs[tema].path);
			midi_levels=open_midi(pathname,0);
			instrument=0; if(midi_ritmo)	mode=1; else mode=2;
			}
			else 
			if(mode==1)
				{
				mode=2;
				
				if(twoplayers)
					{
					midi_ritmo=0;
					if(instrument==0) modeplayers=0; else modeplayers=1;
					instrument=0;
					}
				else
				if(instrument==0) midi_ritmo=0;
				}
			else
				{
				n=0;
				m=0;
				if(((midi_levels>>(instrument<<3)) & EASY_LEVEL) && m==0)
					{
					if(n==level) {m=EASY_LEVEL;global_song_level=0;} else n++;
					}
				if(((midi_levels>>(instrument<<3)) & MEDIUM_LEVEL) && m==0)
					{
					if(n==level) {m=MEDIUM_LEVEL;global_song_level=1;} else n++;
					}
				if(((midi_levels>>(instrument<<3)) & HARD_LEVEL) && m==0)
					{
					if(n==level) {m=HARD_LEVEL;global_song_level=2;} else n++;
					}
				if(((midi_levels>>(instrument<<3)) & EXPERT_LEVEL) && m==0)
					{
					if(n==level) {m=EXPERT_LEVEL;global_song_level=3;} else n++;
					}
				if(m==0)
					{
					 if((midi_levels>>(instrument<<3)) & MEDIUM_LEVEL) m=MEDIUM_LEVEL;
					 else  if((midi_levels>>(instrument<<3)) & HARD_LEVEL) m=HARD_LEVEL;
					 else  if((midi_levels>>(instrument<<3)) & EXPERT_LEVEL) m=EXPERT_LEVEL;
					 else m=EASY_LEVEL; 
					 flag_tresnotas=1;
					 global_song_level=4;
					}
			 notes_total=0;two_notes_total=0;
			 open_midi(pathname,m);
			
		     
			 return 1;
				}

			}
		}

		if(new_key & (KEY_ESC | KEY_F2)) {if(mode!=0) {play=0;mode=0;flag_tresnotas=0;} else return 0;}

		}

 if(readpad(2))
		{
	
		if(n_list_songs>0)
		{
		if(mode==0)
		{
		if((new_pad & PAD_UP) || ((old_pad & PAD_UP) && retain==0)) 
			{if(new_pad & PAD_UP) retain=25; else retain=5;if(tema>0) tema--;count_list=50;}
		if((new_pad & PAD_DOWN) || ((old_pad & PAD_DOWN) && retain==0))
			{if(new_pad & PAD_DOWN) retain=25; else retain=5;if(tema<(n_list_songs-1)) tema++;count_list=50;}

		if(retain) retain--;
		
		}
		else
		if(mode==1)
			{
			if(new_pad & PAD_UP) {if(instrument>0) instrument--;}
			if(new_pad & PAD_DOWN) {if(instrument<(1)) instrument++;}
			}
		else
			{
			if(new_pad & PAD_UP) {if(level>0) level--;}
			if(new_pad & PAD_DOWN) {if(level<(nlevels-1)) level++;}
			}
		if((new_pad & PAD_SELECT) && mode==2) {mid_speed=3;new_pad|=PAD_1;}
		if(new_pad & (PAD_1)) 
			{
			
			if(mode==0)
			{
			for(n=0;n<MAX_NOTES;n++) {nota[n]=0;two_nota[n]=0;}
			sprintf(pathname,"%srhythm.ogg",list_songs[tema].path);
			n=open(pathname,O_RDONLY | O_BINARY, S_IREAD);
			if(n>=0) {close(n);midi_ritmo=1;} else midi_ritmo=0;

			sprintf(pathname,"%snotes.mid",list_songs[tema].path);
			midi_levels=open_midi(pathname,0);
			instrument=0; if(midi_ritmo)	mode=1; else mode=2;
			}
			else 
			if(mode==1)
				{
				mode=2;
				if(twoplayers)
					{
					midi_ritmo=0;
					if(instrument==0) modeplayers=0; else modeplayers=1;
					instrument=0;
					}
				else
				if(instrument==0) midi_ritmo=0;
				}
			else
				{
				n=0;
				m=0;
				if(((midi_levels>>(instrument<<3)) & EASY_LEVEL) && m==0)
					{
					if(n==level) {m=EASY_LEVEL;global_song_level=0;} else n++;
					}
				if(((midi_levels>>(instrument<<3)) & MEDIUM_LEVEL) && m==0)
					{
					if(n==level) {m=MEDIUM_LEVEL;global_song_level=1;} else n++;
					}
				if(((midi_levels>>(instrument<<3)) & HARD_LEVEL) && m==0)
					{
					if(n==level) {m=HARD_LEVEL;global_song_level=2;} else n++;
					}
				if(((midi_levels>>(instrument<<3)) & EXPERT_LEVEL) && m==0)
					{
					if(n==level) {m=EXPERT_LEVEL;global_song_level=3;} else n++;
					}
				if(m==0)
					{
					 if((midi_levels>>(instrument<<3)) & MEDIUM_LEVEL) m=MEDIUM_LEVEL;
					 else  if((midi_levels>>(instrument<<3)) & HARD_LEVEL) m=HARD_LEVEL;
					 else  if((midi_levels>>(instrument<<3)) & EXPERT_LEVEL) m=EXPERT_LEVEL;
					 else m=EASY_LEVEL; 
					 flag_tresnotas=1;
					 global_song_level=4;
					}
			 notes_total=0;two_notes_total=0;
			 open_midi(pathname,m);
			
		     
			 return 1;
				}

			}
		}

		if(new_pad & PAD_2) {if(mode!=0) {play=0;mode=0;flag_tresnotas=0;} else return 0;}

		}
	}

//

if(play && n_list_songs>0 && mode==0 && loading>=3)
{
retain=100;
retain2=100;
loading=0;

sprintf(pathname,"%sguitar.ogg",list_songs[tema].path);

fd=open(pathname,O_RDONLY | O_BINARY, S_IREAD);
if(fd<0) 
	{
	sprintf(pathname,"%ssong.ogg",list_songs[tema].path);
	fd=open(pathname,O_RDONLY | O_BINARY, S_IREAD);
	if(fd<0) {/*n_list_songs=0;return 0;*/
	        if(failed!=tema)
			if(debug_mode) s_debug("Track #1: open fail");
			failed=tema;
			play=0;continue;}
	
	}


sprintf(pathname,"%ssong.ogg",list_songs[tema].path);
fd2=open(pathname,O_RDONLY | O_BINARY, S_IREAD);

if(fd2<0) 
	{
	sprintf(pathname,"%sguitar.ogg",list_songs[tema].path);
	fd2=open(pathname,O_RDONLY | O_BINARY, S_IREAD);
	if(fd2<0) {/*f_close(&fd);n_list_songs=0;return 0;*/
			  if(failed!=tema)
	          if(debug_mode) s_debug("Track #2: open fail");
			  failed=tema;
			  play=0;continue;}
	}



 if(ov_open((void *)&fd, &vf, NULL, 0) < 0) {
	
	close(fd);
	 if(failed!=tema)
	 if(debug_mode) s_debug("Track #1: ov_open fail");
	 failed=tema;
	play=0;continue;
  }
if(ov_open((void *)&fd2, &vf2, NULL, 0) < 0) {
     ov_clear(&vf);//f_close(&fd2);
	 if(failed!=tema)
	 if(debug_mode) s_debug("Track #2: ov_open fail");
	 failed=tema;
	 play=0;continue;
  }


sprintf(pathname,"%srhythm.ogg",list_songs[tema].path);

fd3=-1;
if(fd3>=0)
{
 if(ov_open((void *)&fd3, &vf3, NULL, 0) < 0) {
     ov_clear(&vf);ov_clear(&vf2);//f_close(&fd3);
	 if(failed!=tema)
	 if(debug_mode) s_debug("Track #3: ov_open fail");
	 failed=tema;
	 play=0;continue;
   }
  }


 vi=ov_info(&vf,-1);
vi2=ov_info(&vf2,-1);
if(fd3>=0) vi3=ov_info(&vf3,-1);
ov_time_seek(&vf,30*1000);
ov_time_seek(&vf2,30*1000);
if(fd3>=0) ov_time_seek(&vf3,30*1000);

if(1)
{
int status=0;



PCMInit(vi->rate,vi->channels);
//PCMVolume(pcm_volume*0x7fff/100,pcm_volume*0x7fff/100);

pcm_indx=0;pcm_indx2=0;pcm_indx3=0;my_eof=my_eof2=my_eof3=0;
old_text=-1; // inicializa textura de escenario

 //itoSwitchFrameBuffers();

while(!my_eof && !my_eof2 && !my_eof3){
    long ret;
   #ifndef GEKKO
	SDL_PollEvent(&event);
   color=0xff00ffff;
	itoClearZ();

   #else
	GetEvent();
   
    color=0xff00ffff;
	itoClearZ();

	itoZTest(0);
	#endif
	PX=640-10*16;PY=0;
	s_printf("Playing...");
	
	if(pcm_indx<READ_SAMPLES)
	{
	ret=ov_read(&vf,(void *) pcmout,MAX_PCMOUT,/*0,2,1,*/&current_section);
    if (ret == 0) {
      /* EOF */
      my_eof=1;
    } else if (ret < 0) {
      /* error in the stream.  Not a problem, just reporting it in
	 case we (the app) cares.  In this case, we don't. */
    } else {
      /* we don't bother dealing with sample rate changes, etc, but
	 you'll have to*/
			pcm_indx+=copy_samples(&pcm_ring[pcm_indx],pcmout,ret,vi->channels);
			
			}
	}

	if(pcm_indx2<READ_SAMPLES && pcm_indx>=READ_SAMPLES)
	{
	ret=ov_read(&vf2,(void *)pcmout,MAX_PCMOUT,/*0,2,1,*/&current_section2);
    if (ret == 0) {
      /* EOF */
      my_eof2=1;
    } else if (ret < 0) {
      /* error in the stream.  Not a problem, just reporting it in
	 case we (the app) cares.  In this case, we don't. */
    } else {
      /* we don't bother dealing with sample rate changes, etc, but
	 you'll have to*/
			pcm_indx2+=copy_samples(&pcm_ring2[pcm_indx2],pcmout,ret,vi2->channels);
			
			}
	}
	
	if(fd3>=0)
	if(pcm_indx3<READ_SAMPLES && pcm_indx>=READ_SAMPLES && pcm_indx2>=READ_SAMPLES)
	{
	ret=ov_read(&vf3,(void *) pcmout,MAX_PCMOUT,/*0,2,1,*/&current_section3);
    if (ret == 0) {
      /* EOF */
      my_eof3=1;
    } else if (ret < 0) {
      /* error in the stream.  Not a problem, just reporting it in
	 case we (the app) cares.  In this case, we don't. */
    } else {
      /* we don't bother dealing with sample rate changes, etc, but
	 you'll have to*/
			if(fd3>=0)
			pcm_indx3+=copy_samples(&pcm_ring3[pcm_indx3],pcmout,ret,vi3->channels);
			else pcm_indx3+=copy_samples(&pcm_ring3[pcm_indx3],pcmout,ret,2);
		
			}
	}



if(pcm_indx>=SEND_SAMPLES && pcm_indx2>=SEND_SAMPLES && (pcm_indx3>=SEND_SAMPLES || fd3<0))
		{

	if(status==0)
		{
		int n;
		int m;
		
			{
			
			for(n=0;n<SEND_SAMPLES;n++)
				{
				m=(pcm_ring[n])>>sound1_div;
				m+=pcm_ring2[n]>>sound2_div;
				if(fd3>=0) m+=pcm_ring3[n]>>sound2_div;
			
				if(m<-32768) m=-32768;
				if(m>32767) m=32767;
				pcm_mix_ring[n]=m;
				}
			
			}
		status=1;
		}

		
			{
			int r;
		
			r=PCMSend(pcm_mix_ring,SEND_SAMPLES);
		
			if(r>0)
				{
				#ifndef GEKKO
                SDL_PollEvent(&event);
				#else
	            GetEvent();
				#endif
				itoSwitchFrameBuffers();
				 if(Read_Keyboard(0))
					{
					if(n_list_songs>0)
					{
					if((new_key & KEY_UP) || ((old_key & KEY_UP) && retain2==0)) 
						{if(new_key & KEY_UP) retain2=25; else retain2=5; if(tema>0) tema--;break;}
					if((new_key & KEY_DOWN) || ((old_key & KEY_DOWN) && retain2==0)) 
						{if(new_key & KEY_DOWN) retain2=25; else retain2=5;if(tema<(n_list_songs-1)) tema++;break;}

					if(retain2) retain2--;
					if(new_key & (KEY_F1 | KEY_ENTER)) 
					  {
					  for(n=0;n<MAX_NOTES;n++) {nota[n]=0;two_nota[n]=0;}
					
					  sprintf(pathname,"%srhythm.ogg",list_songs[tema].path);
					  n=open(pathname,O_RDONLY | O_BINARY, S_IREAD);
					  if(n>=0) {close(n);midi_ritmo=1;} else midi_ritmo=0;

					  sprintf(pathname,"%snotes.mid",list_songs[tema].path);
					  midi_levels=open_midi(pathname,0);
					  instrument=0; if(midi_ritmo)	mode=1; else mode=2;
					  break;
					  }
					}
			
			
					if(new_key & (KEY_ESC | KEY_F2)) {if(mode!=0) {mode=0;flag_tresnotas=0;} else play=-1;break;}
					}
				 if(readpad(2))
					{
				
					if(n_list_songs>0)
					{
					if((new_pad & PAD_UP) || ((old_pad & PAD_UP) && retain==0)) 
						{if(new_pad & PAD_UP) retain=25; else retain=5; if(tema>0) tema--;break;}
					if((new_pad & PAD_DOWN) || ((old_pad & PAD_DOWN) && retain==0)) 
						{if(new_pad & PAD_DOWN) retain=25; else retain=5;if(tema<(n_list_songs-1)) tema++;break;}

					if(retain) retain--;
					if(new_pad & ( PAD_1)) 
					  {
					  for(n=0;n<MAX_NOTES;n++) {nota[n]=0;two_nota[n]=0;}
					  
					  sprintf(pathname,"%srhythm.ogg",list_songs[tema].path);
					  n=open(pathname, O_RDONLY | O_BINARY, S_IREAD);
					  if(n>=0) {close(n);midi_ritmo=1;} else midi_ritmo=0;

					  sprintf(pathname,"%snotes.mid",list_songs[tema].path);
					  midi_levels=open_midi(pathname,0);
					  instrument=0; if(midi_ritmo)	mode=1; else mode=2;
					  break;
					  }
					}

					if(new_pad & PAD_2) {if(mode!=0) {mode=0;flag_tresnotas=0;} else play=-1;break;}

					}

			    memcpy(&pcm_ring[0],&pcm_ring[r],(pcm_indx-r)*2);
				pcm_indx-=r;
				memcpy(&pcm_ring2[0],&pcm_ring2[r],(pcm_indx2-r)*2);
				pcm_indx2-=r;

				if(fd3>=0)
				{
				memcpy(&pcm_ring3[0],&pcm_ring3[r],(pcm_indx3-r)*2);
				pcm_indx3-=r;
				}
				status=0;
				}
			}


		}

  }

}


ov_clear(&vf);
ov_clear(&vf2);
if(fd3>=0) ov_clear(&vf3);

PCMSilence(); // PCM off


if(play==-1) return 0;
play=0;
}

}

}

void Loading_screen()
{
itoZTest(0);
ClearScreen(0xff000000); // borra los dos bufferes de pantalla
itoZTest(0);
itoPrimShade(ITO_PRIM_SHADE_GOURAUD);


tamletra=1;
color=0xffffffff;
	
PX=(640-32*10)>>1;PY=(screen_height-32)>>1; s_printf("Loading...");
tamletra=2;

#ifndef GEKKO
SDL_Delay(20);SDL_PollEvent(&event);
#else
	GetEvent();
#endif
itoSwitchFrameBuffers();

}



void * thread_ogg(void *zero)
{
int fd=-1,fd2=-1,fd3=-1,n,end_tema=0;
int delay_samples=0;

f_thread1=1;



while(f_thread1) // bucle de tema
{
      
int abort=0;

SetGraphThd(GRAPH_PAUSED);
if(control_thread1<=0)
{
thread_wakeup=1; // wakeup signal
}

#ifndef GEKKO
#ifdef IS_WIN32
WaitForSingleObject( sema_thread1, INFINITE);
#else
pthread_cond_wait(&cond_thread1,&mutex_thread1);
#endif
#else // GEKKO
  if(exit_by_reset) {control_thread1=0;f_thread1=0;continue;}
  LWP_ThreadSleep(oggplayer_queue);
  if(exit_by_reset) {f_thread1=0;}
#endif

if(!f_thread1) {control_thread1=0;break;}
if(control_thread1!=2) continue;// running?
/*
SDL_PollEvent(&event);
    if(event.key.keysym.sym == SDLK_ESCAPE) {control_thread1=abort=1;continue;}
*/


reset_notes();


procesa_notas();


		   
if(midi_ritmo) sprintf(pathname,"%srhythm.ogg",list_songs[tema].path);
	else
sprintf(pathname,"%sguitar.ogg",list_songs[tema].path);
fd=open(pathname,O_RDONLY | O_BINARY, S_IREAD);
if(fd<0) 
	{
	sprintf(pathname,"%ssong.ogg",list_songs[tema].path);
	fd=open(pathname,O_RDONLY | O_BINARY , S_IREAD);
	if(fd<0) {if(debug_mode) s_debug("Track #1: open fail");
              control_thread1=-1; // error
		      continue;}
	}
	

file[0].size=lseek(fd,0,2);

lseek(fd,0,0);
file[0].pos=0;
file[0].mem=malloc(file[0].size);
if(!file[0].mem) {close(fd);fd=-1;
				  if(debug_mode) s_debug("Track #1: malloc fail");
				  control_thread1=-1; // error
				  continue;}
n=read(fd,file[0].mem,file[0].size);
close(fd);
fd=0x666;
if(n<file[0].size) {f_close(&fd);fd=-1;
					if(debug_mode) s_debug("Track #1: truncated file");
                    control_thread1=-1; // error		
					continue;
					}

sprintf(pathname,"%ssong.ogg",list_songs[tema].path);
fd2=open(pathname,O_RDONLY | O_BINARY, S_IREAD);

if(fd2<0) 
	{
	sprintf(pathname,"%sguitar.ogg",list_songs[tema].path);
	fd2=open(pathname,O_RDONLY | O_BINARY, S_IREAD);
	if(fd2<0) {f_close(&fd);
			if(debug_mode) s_debug("Track #2: open fail");
			 control_thread1=-1; // error
			continue;
			}
	}

file[2].size=lseek(fd2,0,2);

lseek(fd2,0,0);
file[2].pos=0;
file[2].mem=malloc(file[2].size);
if(!file[2].mem) {f_close(&fd);fd=-1;close(fd2);fd2=-1;
				  if(debug_mode) s_debug("Track #2: malloc fail");
				  control_thread1=-1; // error
				  continue;}
n=read(fd2,file[2].mem,file[2].size);
close(fd2);
fd2=0x668;
if(n<file[2].size) {f_close(&fd);fd=-1;f_close(&fd2);fd2=-1;
					if(debug_mode) s_debug("Track #2: truncated file");
                    control_thread1=-1; // error		
					continue;
					}


 if(ov_open((void *)&fd, &vf, NULL, 0) < 0) {
	 ov_clear(&vf);
	 if(debug_mode) s_debug("Track #1: ov_open fail");
	  control_thread1=-1; // error
	 continue;
  }
if(ov_open((void *)&fd2, &vf2, NULL, 0) < 0) {
    ov_clear(&vf);
	if(debug_mode) s_debug("Track #2: ov_open fail");
	 control_thread1=-1; // error
	continue;
  }
 if(midi_ritmo) sprintf(pathname,"%sguitar.ogg",list_songs[tema].path);
	else sprintf(pathname,"%srhythm.ogg",list_songs[tema].path);



my_eof3=0;
fd3=open(pathname,O_RDONLY | O_BINARY, S_IREAD);
if(fd3>=0)
{

file[1].size=lseek(fd3,0,2);
lseek(fd3,0,0);
file[1].pos=0;
file[1].mem=malloc(file[1].size);
if(!file[1].mem) {
				 close(fd3);
				 fd3=-1;
				 if(debug_mode) s_debug("Track #3: malloc fail");
				 } // tira sin cachear
else
	{
	n=read(fd3,file[1].mem,file[1].size);
	close(fd3);
	fd3=0x667;
	if(n<file[1].size) {f_close(&fd3);
						fd3=-1;
						if(debug_mode) s_debug("Track #3: truncated file");
						}
	}
}

if(fd3>=0)
{
 if(ov_open((void *)&fd3, &vf3, NULL, 0) < 0) {
     ov_clear(&vf);ov_clear(&vf2);f_close(&fd3);
	 if(debug_mode) s_debug("Track #3: ov_open fail");
	  control_thread1=-1; // error
	 continue;
   }
  }

vi=ov_info(&vf,-1);
vi2=ov_info(&vf2,-1);

if(fd3>=0)  vi3=ov_info(&vf3,-1); 
// SAL 1
 //control_thread1=-1; continue;// error
if(1)
{
int status=0;
int send_samples=SEND_SAMPLES;


PCMInit((vi->rate*mid_speed)/4,2/*vi->channels*/);

delay_samples=vi->rate*5*2; // 5 segundos de delay

//PCMVolume(pcm_volume*0x7fff/100,pcm_volume*0x7fff/100);

pcm_indx=0;pcm_indx2=0;pcm_indx3=0;;my_eof=my_eof2=my_eof3=0;

ticks=0;

#ifdef GEKKO
mod_track.paused=1;
#endif 

while(!my_eof && !my_eof2 &&!my_eof3){
    long ret;

    if(!f_thread1) {abort=1;control_thread1=1;break;}
	if(rockometro<=0) {rockometro=0;score=0;break;} // rockometro break

	if(twoplayers && two_rockometro<=0) {two_rockometro=0;two_score=0;break;} // rockometro break

// break the song
   
	if((((new_pad & (PAD_START |  PAD_1 | PAD_4 | PAD_3)) &&  input_mode!=2) || ((new_pad2 & (PAD_START  | PAD_1 | PAD_4 | PAD_3))
    &&  input_mode2!=2)) && paused && men_pause==1) {abort=1;
    break;}
   
	if((new_key & (KEY_F1 | KEY_ENTER)) && paused && men_pause==1 && input_mode==2) {abort=1;break;}
	if((new_key2 & (KEY_F1 | KEY_ENTER)) && paused && men_pause==1 && input_mode2==2) {abort=1;break;}
	
	
/* estaban aqui los waits */

   // if(event.key.keysym.sym == SDLK_ESCAPE) {abort=1;break;}

	{
	if(pcm_indx<READ_SAMPLES)
	{

	ret=ov_read(&vf,(void *) pcmout,MAX_PCMOUT,/*0,2,1,*/&current_section);
    if (ret == 0) {
      /* EOF */
      my_eof=1;
    } else if (ret < 0) {
      /* error in the stream.  Not a problem, just reporting it in
	 case we (the app) cares.  In this case, we don't. */
    } else {
      /* we don't bother dealing with sample rate changes, etc, but
	 you'll have to*/
			pcm_indx+=copy_samples(&pcm_ring[pcm_indx],pcmout,ret,vi->channels);
			
			}
	}
	

	if(pcm_indx2<READ_SAMPLES && pcm_indx>=READ_SAMPLES)
	{
	ret=ov_read(&vf2,(void *) pcmout,MAX_PCMOUT,/*0,2,1,*/&current_section2);
    if (ret == 0) {
      /* EOF */
      my_eof2=1;
    } else if (ret < 0) {
      /* error in the stream.  Not a problem, just reporting it in
	 case we (the app) cares.  In this case, we don't. */
    } else {
      /* we don't bother dealing with sample rate changes, etc, but
	 you'll have to*/

			pcm_indx2+=copy_samples(&pcm_ring2[pcm_indx2],pcmout,ret,vi2->channels);
		
			}
	}

	if(pcm_indx3<READ_SAMPLES && pcm_indx>=READ_SAMPLES && pcm_indx2>=READ_SAMPLES)
	{
   
	if(fd3>=0 && bajo_off==0)
	   ret=ov_read(&vf3,(void *)pcmout,MAX_PCMOUT,/*0,2,1,*/&current_section3);
	else
		{
		ret=MAX_PCMOUT;
		memset(pcmout,0,MAX_PCMOUT);
		}

    if (ret == 0) {
      /* EOF */
      my_eof3=1;
    } else if (ret < 0) {
      /* error in the stream.  Not a problem, just reporting it in
	 case we (the app) cares.  In this case, we don't. */
    } else {
      /* we don't bother dealing with sample rate changes, etc, but
	 you'll have to*/
			if(fd3>=0  && bajo_off==0)
			pcm_indx3+=copy_samples(&pcm_ring3[pcm_indx3],pcmout,ret,vi3->channels);
			else pcm_indx3+=copy_samples(&pcm_ring3[pcm_indx3],pcmout,ret,2);
			
			}
	}



	}

if((pcm_indx>=SEND_SAMPLES && pcm_indx2>=SEND_SAMPLES && pcm_indx3>=SEND_SAMPLES) || delay_samples)
		{ 
	   
	    #ifndef GEKKO
        #ifdef IS_WIN32
          WaitForSingleObject( sema_SDL, INFINITE);

          SDL_PollEvent(&event2); // warning: maybe you have problems with this SDL multithread access

          {long out; ReleaseSemaphore(sema_SDL,1,&out);}

        #else

        if(SDL_state)
         {
         SDL_state |=2;
         pthread_cond_wait(&cond_thread1,&mutex_thread1);
         }
         SDL_PollEvent(&event2); // warning: maybe you have problems with this SDL multithread access

        #endif
        #else // GEKKO
       if(exit_by_reset) {abort=1;break;}
         if(SDL_state || 1)
         {
         SDL_state |=2;
         LWP_ThreadSleep(oggplayer_queue);
         }
		 if(exit_by_reset) {abort=1;break;}
       #endif
	
	if(!f_thread1) {abort=1;control_thread1=1;break;}
	
	if(status==0)
		{
		int n;
		int m;
		int div1,div2,div3;
		sound1_div&=1;sound2_div&=1; // limita a uno el divisor
	

			if(twoplayers) {div1=div3=sound1_div;div2=sound2_div;}
			 else {div2=div3=sound2_div;div1=sound1_div;}
		
		
	        if(delay_samples)
				{
				
				send_samples=vi->rate*(audio.samples*1000/44100/*audio.freq*/)*mid_speed/4000;
			for(n=0;n<send_samples;n++)
				{
				pcm_mix_ring[n]=0;if(delay_samples) delay_samples--;
				}
				//send_samples+=16;// por si las moscas... (la rutina pcmsend elimina el sobrante)
				for(;n<send_samples;n++)
				{
				pcm_mix_ring[n]=0;
				}
				}
			else
				{

				register int mult=0,mult2=0;
				send_samples=SEND_SAMPLES;

				if((fallo && twoplayers==0) 
					|| ((fallo) && modeplayers!=0 && twoplayers!=0)
					|| ((fallo && two_fallo) && modeplayers==0 && twoplayers!=0)) div1=16; // silencia canal 1 (guitar)

				if(two_fallo!=0 && modeplayers!=0) div3=16; // silencia canal 3 (rhythm)

		
			
		
	
		// vibrato
        	mult=128-stick1_wahwah;
     
			if(mult<0) mult=0;
			if(mult>127) mult=127;
			mult=127-mult;

			if(twoplayers==1)
				{
    
				mult2=128-stick2_wahwah;
			
				if(mult2<0) mult2=0;
				if(mult2>127) mult2=127;
				mult2=127-mult2;

				if(modeplayers==0) {if(mult2>mult) mult=mult2;mult2=0;}
				}
				else mult2=0;

			send_samples=SEND_SAMPLES;
			for(n=0;n<SEND_SAMPLES;n++)
				{
				m=((pcm_ring[n])+((pcm_ring[n]*mult)>>8))>>div1;
				m+=pcm_ring2[n]>>div2;
				m+=((pcm_ring3[n])+((pcm_ring3[n]*mult2)>>8))>>div3;
			
				if(m<-32768) m=-32768;
				if(m>32767) m=32767;
				pcm_mix_ring[n]=m;
				}
			
			}
		status=1;
		}

		
			{
			int r;
		
			if(!paused)
				{
				if(voices & 1) {PlayVoice(4,44100,0,1000,0x4fff*effects_volume/100,0x4fff*effects_volume/100, 5);voices&=~1;} // nota fuera de pantalla
				if(fallo_sound<128)
				{
				if(fallo_sound==0) PlayVoice(0,44100,0,1000,0x7fff*effects_volume/100,0x7fff*effects_volume/100, -1);
				if(fallo_sound==1) PlayVoice(1,44100,0,1000,0x7fff*effects_volume/100,0x7fff*effects_volume/100, -1);
				if(fallo_sound==2) PlayVoice(2,44100,0,1000,0x7fff*effects_volume/100,0x7fff*effects_volume/100, -1);
	
				fallo_sound=((fallo_sound+1) % 3) | 128;
				}

				if(voices & 4) {PlayVoice(6,22050,0,500,0x3fff*effects_volume/100,0x3fff*effects_volume/100, -1);voices&=~4;} // cuenta proteccion
				if(voices & 8) {PlayVoice(6,22050/4,0,250,0x7fff*effects_volume/100,0, 3);
								PlayVoice(6,18000/4,250,250,0,0x7fff*effects_volume/100, 4);voices&=~8;} // multiplicador
                
                if(voices & 16) {PlayVoice(7,14000,0,30,0x4fff*effects_volume/100,0x4fff*effects_volume/100, -1);voices&=~16;if(aplausos<=0  && abucheo<=0) aplausos=ACTIVE_SOUND; } // score_star
			

				if(aplausos==ACTIVE_SOUND || aplausos==65536) 
					{
					if(aplausos==ACTIVE_SOUND) aplausos=4000;

					PlayVoice(8,8000,0,3560,0x5fff*effects_volume/100,0x5fff*effects_volume/100, 0);
					PlayVoice(8,8000,500,3560,0x5fff*effects_volume/100,0x5fff*effects_volume/100, 0);
						
					aplausos--;
					}

				 if(ovacion==ACTIVE_SOUND) 
					{
					ovacion=9900+8000;
					PlayVoice(9,8000,0,9900,0x7fff*effects_volume/100,0x7fff*effects_volume/100, 1);
						
					}
				if(abucheo==ACTIVE_SOUND) 
					{
					abucheo=10500;
					
					PlayVoice(10,8000,0,10500,0x7fff*effects_volume/100,0x7fff*effects_volume/100, 2);
				    PlayVoice(10,8000,20,10500,0x7fff*effects_volume/100,0x7fff*effects_volume/100, 2);
				
					abucheo--;	
					}

			
                r=PCMSend(pcm_mix_ring,send_samples);}
			else r=0;
		

				
			if(r>0)
				{
				if(graph_thd_mode==GRAPH_PAUSED)
					{
				    thread_wakeup=1;
                    SetGraphThd(GRAPH_INGAME); // graphics on (from timer thread)
					}
                
				if(!delay_samples)
				{
			    memcpy(&pcm_ring[0],&pcm_ring[r],(pcm_indx-r)*2);
				pcm_indx-=r;
				memcpy(&pcm_ring2[0],&pcm_ring2[r],(pcm_indx2-r)*2);
				pcm_indx2-=r;

				memcpy(&pcm_ring3[0],&pcm_ring3[r],(pcm_indx3-r)*2);
				pcm_indx3-=r;
				}
				
				status=0;
				}
			}

	
		}

  }

}


ov_clear(&vf);
ov_clear(&vf2);
if(fd3>=0) ov_clear(&vf3);

PCMSilence(); // PCM off

SetGraphThd(GRAPH_PAUSED);

end_tema=1;
score>>=1;two_score>>=1;

control_thread1=abort; 


}// bucle de tema
if(control_thread1<0x666) control_thread1+=0x666;
return NULL;
}

